#include <stdarg.h>
#include <stdio.h>
#include <vector>
#include <string.h>
#include <time.h>
#include <dirent.h>
#include <fnmatch.h>
#include <ctype.h>

using namespace std;

const char *GetDataDir(void);

const char *GetApplicationTitle(void)
{
 return "Berusky";
}

#ifndef MAX_PATH
#define MAX_PATH 1024
#endif

char ExeDir[MAX_PATH]="";

const char *GetPathDelimiter(void)
{
 return "/";
}

const char *GetExeDir(void)
{
 if(ExeDir[0]==0)
   {
	strcpy(ExeDir,APPLICATION_DIR);
    	int i,j;
	i=0;j=-1;
	while(ExeDir[i]!=0&&i<MAX_PATH)
	  {
	   if(ExeDir[i]=='/') j=i;
	   i++;
	  }
	if(j<strlen(ExeDir)-1)
	  {
	   strcat(ExeDir,"/");
	  }
   }
 return ExeDir;
}

bool GetNewBitmapFileName(char *ch, int max)
{
 if(!ch) return false;
 char buff[3*MAX_PATH];
 char flnm[20];
 strcpy(buff,GetExeDir());
 int len=strlen(buff);
 while(len>0&&buff[len-1]!='/') len--;
 //buff[len]='\\'; len++;
 int count=0;
 bool done=false;
 FILE *f=NULL;
 while(!done)
   {
    sprintf(flnm,"ber%05d.bmp",count);
    buff[len]=0;
	count++;
	if(count>99999) break;
    strcat(buff,flnm);
	f=fopen(buff,"r");
	if(!f)
	  {
	   done=true;
	  }
	 else
	  {
	   fclose(f);
	  }
   }
 if(done)
   {
    if(int(strlen(buff))<max-1)
	  {
	   strcpy(ch,buff);
	  }
	 else done=false;
   }
 return done;
}

void WriteToLog(const char *format,...)
{
 if(!format) return;
 va_list margs;
 char file[1024];
 strcpy(file,GetExeDir());
 strcat(file,"error.log");
 FILE *f=fopen(file,"a+t");
 if(f)
   {
    va_start(margs,format);
    time_t tm=time(NULL);
    struct tm *ltm=localtime(&tm);
    if(ltm)
      {
       fprintf(f,"%02d.%02d.%04d %02d:%02d.%02d ",ltm->tm_mday, ltm->tm_mon, ltm->tm_year+1900, ltm->tm_hour, 
		ltm->tm_min, ltm->tm_sec);
       vfprintf(f,format,margs);
       fprintf(f,"\n");
      }
    fclose(f);
    va_end(margs);
   }
 // else
   {
    va_start(margs,format);
       vfprintf(stderr,format,margs);
       fprintf(stderr,"\n");
    va_end(margs);
   }
}

int RunApplication(void);

int main(int argc, char *argv[])
{
 ExeDir[0]=0;
 if(argc>1){
    strncpy(ExeDir,argv[1],sizeof(ExeDir)-1);
    int len=strlen(ExeDir);
    if(len>0&&ExeDir[len-1]!=GetPathDelimiter()[0]&&len<sizeof(ExeDir)-1){
       strcat(ExeDir,GetPathDelimiter());
    }
    printf("Setting ExeDir '%s'\n",GetExeDir());
 }
 return RunApplication();
}

void SystemEvalFiles(vector<char*> *files,const char *dir, const char *filemask)
{
 if(!files||!filemask) return;

 char fl[1024];
 if(dir&&dir[0]) strcpy(fl,dir);
  else strcpy(fl,GetDataDir());
 
 struct dirent **namelist;
 int n; 
 n = scandir(fl, &namelist, 0, alphasort);
 if(n >= 0)
   {            
    while(n--)
      {
       if(0==fnmatch(filemask,namelist[n]->d_name,FNM_PATHNAME|FNM_CASEFOLD))
         {
          files->push_back(strdup(namelist[n]->d_name));
         }
       free(namelist[n]);
      }
    free(namelist);
   }
}

int strnicmp(const char *str1, const char *str2, int max)
{
 if(str1==str2) return 0;
 if(!str1||!str2) return -2;
 int i=0;
 for(i=0;(i<max||max==-1)&&str1[i]!=0&&str2[i]!=0&&tolower(str1[i])==tolower(str2[i]);i++);

 return (max==-1||i<max)?str1[i]-str2[i]:0;
}

int stricmp(const char *str1, const char *str2)
{
 return strnicmp(str1,str2,-1);
}
