#include "IdentNames.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

//-------------------------------------------------------------------------------------------

MResultData::MResultData(){}
MResultData::~MResultData(){}

//-------------------------------------------------------------------------------------------
MIdentNamesData::MIdentNamesData()
{
 Next=NULL;
 Data=NULL;
 Text=NULL;
 TextRefs=NULL;
}

MIdentNamesData::~MIdentNamesData(){Clear();}

void MIdentNamesData::Clear(void)
{
 Next=NULL;
 Data=NULL;
 FreePtr(Text);
 FreePtr(TextRefs);
}

int MIdentNamesData::Append(const char ch)
{ 
 if(ch==-1) return -1;
 if(Text==NULL)
   {
    Text=(char *)malloc(sizeof(char)*(2));
	if(Text==NULL) return -1;
	TextRefs=(MIdentNamesData **)malloc(sizeof(MIdentNamesData *)*(1));
	if(TextRefs==NULL) 
	  {
	   FreePtr(Text);
	   return -1;
	  }
	Text[0]=ch; Text[1]=0;
	TextRefs[0]=NULL;
	return 0;
   }
  else
   {
    int i,res=-1;
	i=0;
	while(Text[i]!=0&&res==-1)
	  {
	   if(Text[i]==ch) res=i;
	   i++;
	  }
	if(res==-1)
	  {
	   /*char */Text=(char *)realloc(Text,sizeof(char)*(2+i));
	   if(Text==NULL) 
	     {
		  FreePtr(TextRefs);
		  return -1;
		 }
	   /*MIdentNamesData **/TextRefs=(MIdentNamesData **)realloc(TextRefs,sizeof(MIdentNamesData *)*(i+1));
	   if(TextRefs==NULL)
	     {
		  FreePtr(Text);
		  return -1;
		 }
	   /*memcpy(Text2,Text,i-1);
	   memcpy(TextRefs2,TextRefs,i-1);
	   FreePtr(Text); FreePtr(TextRefs);
	   Text=Text2; TextRefs=TextRefs2;*/
	   Text[i]=ch; Text[i+1]=0;
	   TextRefs[i]=NULL;
	   res=i;
	  }
	return res;
   }
}

int MIdentNamesData::CharPosInText(const char ch)
{
 if(ch==0||Text==NULL) return -1;
 int res=-1,i;
 i=0;
 while(Text[i]!=0&&res==-1)
   {
    if(Text[i]==ch) res=i;
    i++;
   }
 return res;
}

int MIdentNamesData::AddChar(const char ch)
{
 return Append(toupper(ch));
}

//-------------------------------------------------------------------------------------------

MIdentNames::MIdentNames()
{
 First=NULL;
 Last=NULL;
 ClearAlsoData=true;
}

MIdentNames::~MIdentNames() {Clear(ClearAlsoData);}

bool MIdentNames::FindWayToIdent(const char *pIdentName, MResultData *pData, bool CanAdd)
{ 
 if(pIdentName==NULL||(CanAdd&&pData==NULL)) return false;
 MIdentNamesData *obj,*last=NULL;
 int idx=-1,pos=0;
 bool res=true;
 bool done=false;

 obj=First;
 while(obj!=NULL/*&&idx==-1*/&&res&&!done)
   {
    done=pIdentName[pos]==0;
	if(done) res=AddToSeznam(obj,pIdentName,pos,pData,CanAdd);
	 else
	  {
       idx=obj->CharPosInText(pIdentName[pos]);
	   if(idx!=-1)
	     { 
	      last=obj;
	      obj=obj->TextRefs[idx];
	      pos++;
	      if(pIdentName[pos]==0) 
		    {
			 obj=NULL;
			 done=true;
			}
	     }
	    else
	     {
	      if(!CanAdd) return false;
	      res=AddToSeznam(obj,pIdentName,pos,pData,CanAdd);
	      obj=NULL;
	      last=NULL;
		 }
	  }
   }
 if(First==NULL)
   {
    res=AddToSeznam(NULL,pIdentName,pos,pData,CanAdd);
   }
 if(res&&!done&&!CanAdd) res=false;
 if(res)
   {
    if(CanAdd&&last!=NULL)
	  {
	   if(pData==NULL||last->Data!=NULL) res=false;
	    else
		 {
		  last->Data=pData;
		 }
	  }
	if(!CanAdd&&pIdentName[pos]==0&&last!=NULL)
	  {
	   if(last->Data==NULL) res=false;
	    else
		 {
	      if(pData!=NULL) pData->Assign(last->Data);
		 }
	  }
   }
 return res;
}

MIdentNamesData *MIdentNames::AddPrvek(void)
{
 MIdentNamesData *obj=new MIdentNamesData;
 if(obj!=NULL)
   {
    if(First==NULL)
	  {
	   First=obj;
	   Last=First;
	  }
	 else
	  {
	   Last->Next=obj;
	   Last=obj;
	  }
   }
 return obj; 
}

bool MIdentNames::AssignData(MIdentNamesData *pObj,MResultData *pData,bool CanAdd)
{
 if(pObj==NULL) return false;
 bool res=true;
 if(CanAdd)
   {
    if(pObj->Data!=NULL) res=false;
     else pObj->Data=pData;
   }
  else
   {
    if(pData!=NULL)
      {
       if(pObj->Data==NULL) res=false;
	    else pData->Assign(pObj->Data);
      }
   }
 return res;
}

bool MIdentNames::AddToSeznam(MIdentNamesData *pFirstCharHere,const char *pIdentName,int pos,MResultData *pData,bool CanAdd)
{
 /*if(pIdentName[pos]==0)
   {
    if(pFirstCharHere!=NULL) return AssignData(pFirstCharHere,pData,CanAdd);
	MIdentNamesData *obj=AddPrvek();
	return AssignData(obj,pData,CanAdd);
   }*/

 MIdentNamesData *obj=pFirstCharHere;

 int idx;
 bool done=false, res=true;
 while(!done&&res)
   { 
    done=pIdentName[pos]==0;
	if(done)
	  {
	   if(obj==NULL) obj=AddPrvek();
	   res=AssignData(obj,pData,CanAdd);
	  }
	 else
	  {
	   if(obj==NULL) obj=AddPrvek();
	   if(obj==NULL) res=false;
	    else
		 {
		  idx=obj->AddChar(pIdentName[pos]);
		  if(idx==-1) res=false;
		   else
		    {
			 if(pIdentName[pos+1]==0)
			   {
			    res=AssignData(obj,pData,CanAdd);
				done=true;
			   }
			  else
			   {
			    if(obj->TextRefs[idx]==NULL) obj->TextRefs[idx]=AddPrvek();
			    obj=obj->TextRefs[idx];
			   }
			}
		 }
	  }
	if(pIdentName[pos]!=0) pos++;
   }
 return res;
}

bool MIdentNames::Add(const char *pIdentName, MResultData *pData)
{
 char *Ident=(char *)malloc(sizeof(char)*(strlen(pIdentName)+2));
 strcpy(Ident,pIdentName);
 strcat(Ident,"#");
 bool res=FindWayToIdent(Ident,pData,true);
 FreePtr(Ident);
 return res;
}

bool MIdentNames::Find(const char *pIdentName, MResultData *pData)
{
 char *Ident=(char *)malloc(sizeof(char)*(strlen(pIdentName)+2));
 strcpy(Ident,pIdentName);
 strcat(Ident,"#");
 bool res=FindWayToIdent(Ident,pData,false);
 FreePtr(Ident);
 return res;
}

void MIdentNames::Clear(bool pAlsoData)
{
 MIdentNamesData *obj;
 while(First!=NULL)
   {
    obj=First;
	First=First->Next;
	if(obj!=NULL&&pAlsoData) {DeletePtr(obj->Data);}
	DeletePtr(obj);
   }
 Last=NULL;
}

DWORD MIdentNames::GetSize(void)
{
 DWORD ptrsz=sizeof(MIdentNamesData *);
 DWORD res=2*ptrsz;
 MIdentNamesData *p=First;

 DWORD count=0;

 while(p!=NULL)
   {
    res+=sizeof(MResultData *)+/*ptrsz+*/sizeof(char *)+sizeof(MIdentNamesData **);
	if(p->Text!=NULL)
	  {
	   int len=strlen(p->Text);
	   res+=sizeof(char)*(1+len);
	   res+=len*ptrsz;
	  }
	count++;
    p=p->Next;
   }
 printf("\nCount=%d\n",count);
 return res;
}

