#ifndef IdentNames_HEADER
#define IdentNames_HEADER

#include <windows.h>
//-------------------------------------------------------------------------------------------
#define CHYBA(x) MessageBox(NULL,x,"chyba",MB_OK)


#define FreePtr(x) if(x!=NULL) free(x); x=NULL
#define DeletePtr(x) if(x!=NULL) delete x; x=NULL

//-------------------------------------------------------------------------------------------
//data co jsou jako vysledek prohledavani, vyrobim si z ni vlastni tridu a tam si dam svoje data
class MResultData
{
 private:
 public:
   MResultData();
   virtual ~MResultData();

   virtual void Assign(MResultData *src)=0; //kopirovani udaju, kazdy implementuje sam
   /*virtual bool Load(BYTE *strm, DWORD strmsize)=0; //predava se mu pointer s daty s delkou GetMemSize(); vraci false kdyz neco nepovedlo
   virtual int GetMemSize(void)=0; //vraci kolik potrebuje mista na ulozeni/nacteni
   virtual bool Save(BYTE *strm, DWORD strmsize)=0; //ulozi do strm, kdyz bude malo mista (male strmsize), tak chyba*/
};

//-------------------------------------------------------------------------------------------
//prvky v seznamu identifikatoru
class MIdentNamesData
{
 private:
   int Append(const char ch); //prida na konec Text jeden znak a dalsi misto do TextRefs, vraci index toho novyho
 public:
   MIdentNamesData();
   ~MIdentNamesData();

   MIdentNamesData *Next; //opravdovy naslednik v seznamu prvku

   MResultData *Data; //pokud byl text docten az do konce, tak zde je vysledek

   char *Text; //znaky co jsou k dispozici na jednotlive urovni
   MIdentNamesData **TextRefs; //reference k jednotlivym znakum v Text, kde je nasledujici znak; stejny pocet jako v Text znaku

   void Clear(void);
   int CharPosInText(const char ch); //vraci index znaku v polozce Text; -1 znaci ze neni; znak nesmi byt 0
   int AddChar(const char ch); //vraci index to TextRefs, ktery prvek pole si muzu zapsat, -1 kdyz nepovedlo; znak nesmi byt 0
};

//-------------------------------------------------------------------------------------------

class MIdentNames
{
 protected:
   MIdentNamesData *First; //prvni aposledni prvek v seznamu
   MIdentNamesData *Last;

 private:
   bool FindWayToIdent(const char *pIdentName, MResultData *pData, bool CanAdd); //projde stromem a bud vraci jestli nasel/jestli se mu podarilo pridat do seznamu
   bool AddToSeznam(MIdentNamesData *pFirstCharHere,const char *pIdentName,int pos,MResultData *pData,bool CanAdd); //prida novy prvek do seznamu, vraci NULL kdyz nepovedlo/malo pameti
   MIdentNamesData *AddPrvek(void); //vytvori novy prvek a prida jej na konec seznamu
   bool AssignData(MIdentNamesData *pObj,MResultData *pData,bool CanAdd); //priradi data podle CanAdd bud z pObj do pData nebo obracene

 public:
   MIdentNames();
   virtual ~MIdentNames();

   DWORD GetSize(void); //vraci kolik to zabira v pameti

   virtual bool Add(const char *pIdentName, MResultData *pData); //prida do seznamu identifikator a jeho data; vraci false kdyz neco nepovedlo, napriklad kdyz jiz takovy v seznamu existuje; pData nesmi byt NULL !
   virtual bool Find(const char *pIdentName, MResultData *pData); //vraci false kdyz nenasel identifikator, jinak kdyz neni pData NULL, tak u nej zavola Assign na vysledek v seznamu
   virtual void Clear(bool pAlsoData); //vymaze vse z pameti, parametr rika, jestli ma mazat i polozku Data z prvku v seznamu
   bool ClearAlsoData; //v destruktoru jestli ma i vymazat data; default je true
};

//-------------------------------------------------------------------------------------------

#endif