#include <windows.h>
#include "IdentNames.h"
#include <stdio.h>
#include <vector>
#include <memory.h>

class MResultDataDWORD:public MResultData
{
 private:
 public:
   MResultDataDWORD();
   virtual ~MResultDataDWORD();

   DWORD val;

   void Assign(MResultData *src);
};

//-----------------------------------------------------------------------------------

MResultDataDWORD::MResultDataDWORD(){val=0;}
MResultDataDWORD::~MResultDataDWORD(){val=0;}

void MResultDataDWORD::Assign(MResultData *src)
{
 val=0;
 if(src==NULL) return;
 val=((MResultDataDWORD *)src)->val;
}

//-----------------------------------------------------------------------------------

class MIdentNamesDWORD: public MIdentNames
{
 private:
   unsigned int getPoiterID(MIdentNamesData *ptr,MIdentNamesData *from, unsigned int idfrom); //nula je NULL ci nenasel
   unsigned int GetCount(void);

   BYTE *mem; //pamet s udaji o identifikatorech, nactena z ulozeni
   DWORD memsize; //kolik bere v pameti mem
 public:
   MIdentNamesDWORD();
   ~MIdentNamesDWORD();

   void Save(const char *pFileName); //ulozi obsah do souboru
   bool Load(const char *pFileName); //nacte obsah ze souboru
   bool Add(const char *pIdentName, MResultDataDWORD *pData); //prida do seznamu identifikator a jeho data; vraci false kdyz neco nepovedlo, napriklad kdyz jiz takovy v seznamu existuje; pData nesmi byt NULL !
   bool Find(const char *pIdentName, MResultDataDWORD *pData); //vraci false kdyz nenasel identifikator, jinak kdyz neni pData NULL, tak u nej zavola Assign na vysledek v seznamu
   void Clear(bool pAlsoData); //vymaze vse z pameti, parametr rika, jestli ma mazat i polozku Data z prvku v seznamu
};

MIdentNamesDWORD::MIdentNamesDWORD(){mem=NULL;memsize=0;}

MIdentNamesDWORD::~MIdentNamesDWORD(){FreePtr(mem);memsize=0;}

unsigned int MIdentNamesDWORD::GetCount(void)
{
 unsigned int res=0;
 MIdentNamesData *p=First;
 while(p!=NULL)
   {
    res++;
	p=p->Next;
   }
 return res;
}

unsigned int MIdentNamesDWORD::getPoiterID(MIdentNamesData *ptr,MIdentNamesData *from, unsigned int idfrom)
{
 if(ptr==NULL) return 0;

 if(from==NULL)
   {
    from=First;
	idfrom=0;
   }
 unsigned int res=idfrom;
 bool have=false;
 MIdentNamesData *p=from;
 while(p!=NULL&&!have)
   {
    have=p==ptr;
    if(!have) res++;
	p=p->Next;
   }
 if(have) return res+1;
 return 0;
}

void GetTextUntil(FILE *f,unsigned int pos, char *txt, int max)
{
 fseek(f,pos,SEEK_SET);
 int i=0;
 while(txt[i]=fgetc(f),txt[i]!=0&&!feof(f)&&max>i) i++;
 txt[i]=0;
}

void MIdentNamesDWORD::Save(const char *pFileName)
{
 if(pFileName==NULL) return;
 DeleteFile(pFileName);
 FILE *f=fopen(pFileName,"w+b");
 if(f==NULL) { CHYBA("Nepovedlo otevrit k zapisu"); /*FreePtr(fl);*/ return;}

 MResultDataDWORD dt;
 MIdentNamesData *p;
 std::vector<unsigned int> filepos;
 p=First;
 DWORD dval;
 unsigned int ival,idfrom=0;
 int len,i;
 ival=GetCount();
 fwrite(&ival,sizeof(unsigned int),1,f);
 while(p!=NULL)
   {
    filepos.push_back(ftell(f));
    len=strlen(p->Text);
    fwrite(p->Text,len+1,1,f);
	for(i=0;i<len;i++)
	  {
	   dval=getPoiterID(p->TextRefs[i],p,idfrom);
	   fwrite(&dval,sizeof(DWORD),1,f);
	  }
	if(p->Data==NULL) dval=-1;
	 else
	  {
	   dt.Assign(p->Data);
	   dval=dt.val;
	  }
    fwrite(&dval,sizeof(DWORD),1,f);
	//fputc(33,f);
	idfrom++;
    p=p->Next;
   }
 /*fclose(f);
 CopyFile(fl,pFileName,FALSE);
 FreePtr(fl);
 f=fopen(pFileName,"w+b");*/
 fflush(f);
 fseek(f,0,SEEK_SET);
 fread(&ival,sizeof(unsigned int),1,f);
 //char txt[50];
 long flpos;
 if(ival!=GetCount()||filepos.size()!=ival) CHYBA("Nesedi pocet prvku");
 p=First;
 for(i=0;i<filepos.size()&&p!=NULL;i++)
   {
	fseek(f,filepos[i],SEEK_SET);
    len=strlen(p->Text);
	fseek(f,len+1,SEEK_CUR);
	for(int j=0;j<len;j++)
	  {
	   flpos=ftell(f);
	   fread(&dval,sizeof(DWORD),1,f);
	   printf("'%s'[%d] = %d, filepos=%d\n",p->Text,j,dval,flpos);
	   if(dval!=0)
	     {
	      fseek(f,flpos,SEEK_SET);
	      dval=filepos[dval-1];//+1; //davam "o jedno mensi", protoze v pameti indexujem od 0
	      fwrite(&dval,sizeof(DWORD),1,f);
	      fflush(f);//fseek(f,flpos,SEEK_SET);
		 }
	  }
	p=p->Next;
   }
 fclose(f);
}

bool MIdentNamesDWORD::Load(const char *pFileName)
{
 if(pFileName==NULL) return false;
 WIN32_FIND_DATA fd;
 HANDLE Find=FindFirstFile(pFileName,&fd);
 if(Find==INVALID_HANDLE_VALUE) return false;
 FindClose(Find);
 FreePtr(mem); 
 memsize=sizeof(BYTE)*(/*(fd.nFileSizeHigh * (MAXDWORD+1)) + */fd.nFileSizeLow);
 mem=(BYTE *)malloc(memsize);
 if(mem==NULL) {memsize=0; return false;}
 FILE *f=fopen(pFileName,"rb");
 if(f==NULL) {FreePtr(mem); memsize=0; return false;}
 fread(mem,memsize,1,f);
 fclose(f);
 unsigned int count;
 memcpy(&count,mem,sizeof(unsigned int));
 printf("Nacetl %d identifikatoru\n",count);
 return true;
}

bool MIdentNamesDWORD::Add(const char *pIdentName, MResultDataDWORD *pData)
{
 if(mem!=NULL) return false;
 return MIdentNames::Add(pIdentName, pData);
}

bool MIdentNamesDWORD::Find(const char *pIdentName, MResultDataDWORD *pData)
{
 if(pIdentName==NULL) return false;
 if(mem==NULL) return MIdentNames::Find(pIdentName,pData); 
 char *ident=(char *)malloc(sizeof(char)*(strlen(pIdentName)+2));
 strcpy(ident,pIdentName); strcat(ident,"#");
 DWORD pos=sizeof(unsigned int),posfrom;
 DWORD num,val=-1,identidx,idx;
 BYTE *buff=mem;
 identidx=0;
 bool have=false,done=false;
 while(!have&&!done&&pos>0&&pos<memsize)
   {
    posfrom=pos;
    done=ident[identidx]==0||ident[identidx+1]==0;
    while(buff[pos]!=0&&pos<memsize)
	  {
	   if(!have&&toupper(buff[pos])==toupper(ident[identidx])) {have=true; idx=pos-posfrom;}
	   pos++;
	  }
	if(pos<memsize) pos+=1;
	if(!have) {done=true;}
	 else
	  {
	   have=false;
	   if(done) idx=pos-posfrom-1;
	   memcpy(&num,buff+(pos+sizeof(DWORD)*(idx)),sizeof(DWORD));
	   if(done)
	     {
		  have=num!=-1;
		  if(have) val=num;
		 }
	    else identidx++;
	   pos=num;
	  }
   }
 if(have&&pData!=NULL) pData->val=val;
 FreePtr(ident);
 return have;
}

void MIdentNamesDWORD::Clear(bool pAlsoData)
{
 FreePtr(mem); memsize=0;
 MIdentNames::Clear(pAlsoData);
}

DWORD ResID=1;
MIdentNamesDWORD nms;

//smaze obsah delanich pameti
void ClearData(void)
{
 ResID=1;
 nms.Clear(true);
}

//Prida do dat identifikator, do pResID vraci vygenerovany Resource ID
bool AddString(const char *pString, DWORD *pResID)
{
 if(pString==NULL) return false;
 char *str=(char*)malloc(strlen(pString)+2);
 if(!str) return false;
 strcpy(str,pString);
 strcat(str,"#");
 MResultDataDWORD *dt=new MResultDataDWORD;
 dt->val=*pResID;
 if(nms.Add(pString,dt))
   {
	if(pResID!=NULL) *pResID=ResID;
    ResID++;
	free(str);
	return true;
   }
 free(str);
 delete dt;
 return false;
}

//ulozi dosud nacteny data do souboru
bool SaveToFile(const char *pFileName)
{
 if(pFileName==NULL) return false;
 nms.Save(pFileName);
 return true;
}

DWORD GetNextFreeResID(void)
{
 return ResID;
}
