#include <windows.h>
#include <string.h>
#include <stdio.h>

bool AddString(const char *pString, DWORD *pResID);
bool SaveToFile(const char *pFileName);
void ClearData(void);

#define DATFILEHEAD "Dat@2005"

DWORD EvalFileSize(const char *path)
{
 DWORD res=0;
 WIN32_FIND_DATA fd;
 HANDLE handle;
 handle=FindFirstFile(path,&fd);
 if(handle!=INVALID_HANDLE_VALUE)
   {
    res=fd.nFileSizeLow;
    FindClose(handle);
   }
 return res;
}

bool IsTxtFile(const char *fl)
{
 if(!fl) return false;
 char *f=strchr(fl,'.');
 while(f!=NULL&&strchr(f+1,'.')) f=strchr(f+1,'.');
 if(f)
   {
    if(stricmp(f,".txt")==0) return true;
   }
 return false;
}

void AppendFileContent(const char *dir,const char *fl,FILE *wrt)
{
 if(!dir||!fl||!wrt) return;
 int ch;
 char *ff=(char*)malloc(strlen(dir)+strlen(fl)+1);
 if(!ff) return;
 strcpy(ff,dir);
 strcat(ff,fl);
 int xorval=1+4+16+64;
 if(!IsTxtFile(fl)) xorval=0;
 FILE *f=fopen(ff,"rb");
 if(f)
   {
    while(ch=fgetc(f),!feof(f))
	  {
	   fputc(ch^xorval,wrt);
	  }
    fclose(f);
   }
 free(ff);
}

void LookInDir(const char *dir,const char *addstr, int &cnt, DWORD &writeAt, FILE *wrt)
{
 WIN32_FIND_DATA fd;
 HANDLE handle;
 bool done=false;
 char pth[10*MAX_PATH];
 strcpy(pth,dir);
 strcat(pth,"*.*");
 handle=FindFirstFile(pth,&fd);
 while(handle!=INVALID_HANDLE_VALUE&&!done)
   {
    if(!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
	  {
	   bool chyba=true;
	   DWORD data=writeAt;
	   char *str=(char*)malloc(strlen(addstr)+strlen(fd.cFileName)+1);
	   if(str)
	     {
		  strcpy(str,addstr);
		  strcat(str,fd.cFileName);
	      chyba=!AddString(str,&data);
		  free(str);
		 }
	   printf("%s%s %d",addstr,fd.cFileName,data);
	   if(chyba) printf(" CHYBA");
	   printf("\n");
	   if(!chyba)
	     {
		  writeAt+=fd.nFileSizeLow+4; //prvni 4 bytey jsou velikost bloku
		  if(wrt)
		    {
			 fwrite(&fd.nFileSizeLow,sizeof(DWORD),1,wrt);
			 AppendFileContent(dir,fd.cFileName,wrt);
			}
		 }
	   cnt++;
	  }
	 else
	  {
	   if(strcmp(fd.cFileName,".")&&strcmp(fd.cFileName,".."))
	     {
		  char nadd[10*MAX_PATH],ppth[10*MAX_PATH];
		  strcpy(nadd,addstr);
		  strcat(nadd,fd.cFileName);
		  strcat(nadd,"\\");
		  strcpy(ppth,dir);
		  strcat(ppth,fd.cFileName);
		  strcat(ppth,"\\");
		  LookInDir(ppth,nadd,cnt,writeAt,wrt);
		 }
	  }
	done=!FindNextFile(handle,&fd);
   }
 if(handle!=INVALID_HANDLE_VALUE) FindClose(handle);
}

int main(int argc, char *argv[])
{
 if(argc!=3)
   {
    printf("Usage: makedat pack_dir add_str\n");
	return 1;
   }
 char path[10*MAX_PATH];
 strcpy(path,argv[1]);
 int i,j;
 i=0;j=-1;
 while(path[i]!=0&&i<sizeof(path))
   {
    if(path[i]=='\\') j=i;
    i++;
   }
 if(j!=int(strlen(path))) strcat(path,"\\");
 char addstr[10*MAX_PATH];
 strcpy(addstr,argv[2]);
 i=0;j=-1;
 while(addstr[i]!=0&&i<sizeof(addstr))
   {
    if(addstr[i]=='\\') j=i;
    i++;
   }
 if(j!=int(strlen(addstr))) strcat(addstr,"\\");

 DWORD writeAt=0;
 int cnt=0;
 LookInDir(path,addstr,cnt,writeAt,NULL);
 printf("Celkem nalezeno: %d\n",cnt);

 int pathlen=strlen(path);
 strcat(path,"..\\berusky1.predat");
 if(!SaveToFile(path)) printf("Nepovedlo ulozeny");
  else printf("Soubor byl ulozen");
 printf(" %s\n",path);

 ClearData();

 cnt=0;
 writeAt=strlen(DATFILEHEAD)+1+4+EvalFileSize(path)+1;
 path[pathlen]=0;
 strcat(path,"..\\berusky1.predat2");
 FILE *wrt=fopen(path,"wb");
 if(wrt)
   {
    path[pathlen]=0;
    LookInDir(path,addstr,cnt,writeAt,wrt);
    strcat(path,"..\\berusky1.predat");
    if(!SaveToFile(path)) printf("Nepovedlo ulozeny");
     else printf("Soubor byl ulozen");
    fclose(wrt);
   }
 path[pathlen]=0;
 strcat(path,"..\\berusky1.dat");
 wrt=fopen(path,"wb");
 if(wrt)
   {
    path[pathlen]=0;
    strcat(path,"..\\berusky1.predat");
	writeAt=EvalFileSize(path);
    path[pathlen]=0;

	fprintf(wrt,DATFILEHEAD);
	fputc(15,wrt);
	fwrite(&writeAt,sizeof(DWORD),1,wrt);
	AppendFileContent(path,"..\\berusky1.predat",wrt);
	fputc(16,wrt);
	AppendFileContent(path,"..\\berusky1.predat2",wrt);
    fclose(wrt);
   }
  else
   {
    printf("Nemohu zapsat do %s\n",path);
   }
 return 0;
}