#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>

#include <windows.h>
#include <stdio.h>
#include <vector>
#include <string.h>

#include "resource.h"

using namespace std;

const char *GetDataDir(void);

const char *GetApplicationTitle(void)
{
 return "Beruky";
}

HINSTANCE hInstance=NULL;
char ExeDir[MAX_PATH]="";

const char *GetPathDelimiter(void)
{
 return "\\";
}

const char *GetExeDir(void)
{
 if(ExeDir[0]==0)
   {
    GetModuleFileName(hInstance,ExeDir,MAX_PATH-1);
	int i,j;
	i=0;j=-1;
	while(ExeDir[i]!=0&&ExeDir[i]<MAX_PATH)
	  {
	   if(ExeDir[i]=='\\') j=i;
	   i++;
	  }
	if(j>0)
	  {
	   ExeDir[j+1]=0;
	  }
   }
 return ExeDir;
}

bool GetNewBitmapFileName(char *ch, int max)
{
 if(!ch) return false;
 char buff[3*MAX_PATH];
 char flnm[20];
 DWORD len=GetModuleFileName(NULL,buff,3*MAX_PATH);
 if(!len) return false;
 while(len>0&&buff[len-1]!='\\') len--;
 //buff[len]='\\'; len++;
 DWORD count=0;
 bool done=false;
 FILE *f=NULL;
 while(!done)
   {
    sprintf(flnm,"ber%05d.bmp",count);
    buff[len]=0;
	count++;
	if(count>99999) break;
    strcat(buff,flnm);
	f=fopen(buff,"r");
	if(!f)
	  {
	   done=true;
	  }
	 else
	  {
	   fclose(f);
	  }
   }
 if(done)
   {
    if(int(strlen(buff))<max-1)
	  {
	   strcpy(ch,buff);
	  }
	 else done=false;
   }
 return done;
}

void WriteToLog(const char *format,...)
{
 if(!format) return;
 va_list margs;
 char file[1024];
 strcpy(file,GetExeDir());
 strcat(file,"error.log");
 FILE *f=fopen(file,"a+t");
 if(f)
   {
    va_start(margs,format);
    SYSTEMTIME st;
    GetLocalTime(&st);
    fprintf(f,"%02d.%02d.%04d %02d:%02d.%02d ",st.wDay, st.wMonth, st.wYear, st.wHour, st.wMinute, st.wSecond);
	vfprintf(f,format,margs);
	fprintf(f,"\n");
    fclose(f);
	va_end(margs);
   }
}

int RunApplication(void);

int WINAPI WinMain(HINSTANCE phInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
 ExeDir[0]=0;
 _CrtSetDbgFlag( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
 //_CrtSetBreakAlloc(468);
 hInstance=phInstance;

 #ifdef _DEBUG
 strcpy(ExeDir,"E:\\Berdy1\\");
 #endif

 return RunApplication();
}

const char *GetMainWindowTitle(void);

/*
BOOL CALLBACK enumthread(HWND hwnd,LPARAM lParam)
{
 char str[51];
 if(hwnd&&GetWindowText(hwnd,str,50)&&strcmp(str,GetMainWindowTitle())==0)
   {
    //SetWindowLong(hwnd,
    return FALSE;
   }
 return TRUE;
}

void AfterCreateWindow(void)
{
 /*HWND wnd=GetTopWindow(NULL);
 if(wnd)
   {
    char str[1024];
    GetWindowText(wnd,str,1024);
	str[0]=0;
    //SetWindowText(wnd,"AJA");
   }* /
 EnumThreadWindows(GetCurrentThreadId(),enumthread,0);
 SetCursor(LoadCursor(hInstance, MAKEINTRESOURCE(IDC_MAINCURSOR)));
 ShowCursor(TRUE);
}
*/
void SystemEvalFiles(vector<char*> *files,const char *dir, const char *filemask)
{
 if(!files||!filemask) return;
 char fl[1024];
 if(dir&&dir[0]) strcpy(fl,dir);
  else strcpy(fl,GetDataDir());
 strcat(fl,filemask);

 WIN32_FIND_DATA fd;
 HANDLE handle;
 bool done=false;
 handle=FindFirstFile(fl,&fd);
 while(handle!=INVALID_HANDLE_VALUE&&!done)
   {
    if(!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
	  {
	   if(fd.cAlternateFileName[0]) files->push_back(strdup(fd.cAlternateFileName));
	    else files->push_back(strdup(fd.cFileName));
	  }
	done=!FindNextFile(handle,&fd);
   }
 if(handle!=INVALID_HANDLE_VALUE) FindClose(handle);
}
