#include "berdy.h"
#include "datafile.h"

//---------------------------------------------------------------------------------------
#define h_levelu  "Level 3 (C) Anakreon 1999"
#define SLEPEJ_PRVEK ((unsigned short)0xffff)
#define SLEPEJ_SPRIT ((unsigned short)0xffff)
#define NENI_PODLAHA ((unsigned short)0xffff)

#define PRVNI_GLOBAL_LEVEL          0
#define POSLEDNI_GLOBAL_LEVEL       99
#define PRVNI_KLASIK_LEVEL          100
#define POSLEDNI_KLASIK_LEVEL       299
#define PRVNI_KYBER_LEVEL           300
#define POSLEDNI_KYBER_LEVEL        499
#define PRVNI_ANIMACE_HRACE         500
#define PRVNI_POZADI                580
#define PRVNI_OSTATNI               600
#define PRVNI_HRAC                  700

#define PRVEK       0
#define VARIANTA    1
#define ROTACE      2
#define ANIMACE     3

#define P_ZEME      0
#define P_HRAC_1    1
#define P_HRAC_2    2
#define P_HRAC_3    3
#define P_HRAC_4    4
#define P_HRAC_5    5
#define P_BEDNA     6
#define P_TNT       7
#define P_STENA     8
#define P_EXIT      9
#define P_KAMEN     10
#define P_KLIC      11
#define P_KRUMPAC   12
#define P_KLIC1     13
#define P_KLIC2     14
#define P_KLIC3     15
#define P_KLIC4     16
#define P_KLIC5     17

//dvere na barevne klice
#define P_DVERE1_H_O    18
#define P_DVERE2_H_O    19
#define P_DVERE3_H_O    20
#define P_DVERE4_H_O    21
#define P_DVERE5_H_O    22
#define P_DVERE1_H_Z    23
#define P_DVERE2_H_Z    24
#define P_DVERE3_H_Z    25
#define P_DVERE4_H_Z    26
#define P_DVERE5_H_Z    27
#define P_DVERE1_V_O    28
#define P_DVERE2_V_O    29
#define P_DVERE3_V_O    30
#define P_DVERE4_V_O    31
#define P_DVERE5_V_O    32
#define P_DVERE1_V_Z    33
#define P_DVERE2_V_Z    34
#define P_DVERE3_V_Z    35
#define P_DVERE4_V_Z    36
#define P_DVERE5_V_Z    37
//dvere pro danou berusku
#define P_ID_DVERE1_H_O 38
#define P_ID_DVERE2_H_O 39
#define P_ID_DVERE3_H_O 40
#define P_ID_DVERE4_H_O 41
#define P_ID_DVERE5_H_O 42
#define P_ID_DVERE1_H_Z 43
#define P_ID_DVERE2_H_Z 44
#define P_ID_DVERE3_H_Z 45
#define P_ID_DVERE4_H_Z 46
#define P_ID_DVERE5_H_Z 47
#define P_ID_DVERE1_V_O 48
#define P_ID_DVERE2_V_O 49
#define P_ID_DVERE3_V_O 50
#define P_ID_DVERE4_V_O 51
#define P_ID_DVERE5_V_O 52
#define P_ID_DVERE1_V_Z 53
#define P_ID_DVERE2_V_Z 54
#define P_ID_DVERE3_V_Z 55
#define P_ID_DVERE4_V_Z 56
#define P_ID_DVERE5_V_Z 57
//dvere jedinkrat pruchozi
#define P_DV_H_O        58
#define P_DV_H_Z        59
#define P_DV_V_O        60
#define P_DV_V_Z        61
//???
#define P_DV_H          62
#define P_DV_V          63

//---------------------------------------------------------------------------------------
int DecodeVarianta(WORD varianta,const WORD *anak_prvky,const int *frameCols,const int *frameRows,const char **files, UINT &themeID,int &frameCol,int &frameRow,char *file)
{
 if(!anak_prvky) return -1;
 int i=0,idx=-1;
 while(i<varianta&&anak_prvky[i]!=SLEPEJ_PRVEK)
   {
    i++;
   }
 if(i!=varianta||anak_prvky[i]==SLEPEJ_PRVEK) return -1;
 WORD prvek=anak_prvky[i];
 if((prvek>=PRVNI_KLASIK_LEVEL&&prvek<=POSLEDNI_KLASIK_LEVEL)||(/*prvek>=PRVNI_GLOBAL_LEVEL&&*/prvek<=POSLEDNI_GLOBAL_LEVEL)) themeID=1;
  else
   {
    if(prvek>=PRVNI_KYBER_LEVEL&&prvek<=POSLEDNI_KYBER_LEVEL) themeID=2;
	 else themeID=(UINT)-1;
   }
 frameCol=i; if(frameCols) frameCol=frameCols[i];
 frameRow=0; if(frameRows) frameRow=frameRows[i];
 if(file) file[0]=0; if(files&&files[i]) strcpy(file,files[i]);
 return i;
}

bool GetPrvekThemeAndOther(WORD prvek,WORD varianta, UINT &themeID, int &frameCol, int &frameRow,char *file)
{
 if(file) file[0]=0;
 bool res=false;
 switch(prvek)
   {
	case P_ZEME:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL+81,PRVNI_KLASIK_LEVEL+92,PRVNI_KLASIK_LEVEL+83,PRVNI_KLASIK_LEVEL+82,PRVNI_KLASIK_LEVEL+84, PRVNI_KYBER_LEVEL+27,PRVNI_KYBER_LEVEL,PRVNI_KYBER_LEVEL+26,PRVNI_KYBER_LEVEL+25,PRVNI_KYBER_LEVEL+28,SLEPEJ_PRVEK};
	   int frameCols[]={3,4,1,2,0, 3,4,1,2,0,-1};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,NULL,NULL,themeID,frameCol,frameRow,NULL);
	  }
	  break;
	case P_HRAC_1:
	case P_HRAC_2:
	case P_HRAC_3:
	case P_HRAC_4:
	case P_HRAC_5:
	  break;
	case P_BEDNA:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL+4,PRVNI_KLASIK_LEVEL+90,PRVNI_KLASIK_LEVEL+5,PRVNI_GLOBAL_LEVEL+2,PRVNI_KLASIK_LEVEL+6,PRVNI_KLASIK_LEVEL+7,PRVNI_KYBER_LEVEL+5,PRVNI_KYBER_LEVEL+6,SLEPEJ_PRVEK};
	   res=-1!=DecodeVarianta(varianta,anak,NULL,NULL,NULL,themeID,frameCol,frameRow,NULL);
	   themeID=(UINT)-1;
	  }
	  break;
	case P_TNT:
	  {
	   WORD anak[]={PRVNI_GLOBAL_LEVEL+0,PRVNI_KLASIK_LEVEL+91,PRVNI_GLOBAL_LEVEL+3,PRVNI_GLOBAL_LEVEL+4,PRVNI_GLOBAL_LEVEL+1,SLEPEJ_PRVEK};
	   res=-1!=DecodeVarianta(varianta,anak,NULL,NULL,NULL,themeID,frameCol,frameRow,NULL);
	   themeID=(UINT)-1;
	  }
	  break;
	case P_STENA:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL+23,PRVNI_KLASIK_LEVEL+25,PRVNI_KLASIK_LEVEL+26,PRVNI_KLASIK_LEVEL+27,PRVNI_KLASIK_LEVEL+13,
				  PRVNI_KLASIK_LEVEL+14,PRVNI_KLASIK_LEVEL+15,PRVNI_KLASIK_LEVEL+16,PRVNI_KLASIK_LEVEL+17,PRVNI_KLASIK_LEVEL+18,
				  PRVNI_KLASIK_LEVEL+19,PRVNI_KLASIK_LEVEL+20,PRVNI_KLASIK_LEVEL+24,PRVNI_KLASIK_LEVEL+31,PRVNI_KLASIK_LEVEL+33,
				  PRVNI_KLASIK_LEVEL+21,PRVNI_KLASIK_LEVEL+22,PRVNI_KLASIK_LEVEL+28,PRVNI_KLASIK_LEVEL+29,PRVNI_KLASIK_LEVEL+30,
				  PRVNI_KLASIK_LEVEL+32,PRVNI_KLASIK_LEVEL+34,PRVNI_KLASIK_LEVEL+35,PRVNI_KLASIK_LEVEL+46,PRVNI_KLASIK_LEVEL+47,
				  PRVNI_KLASIK_LEVEL+85,PRVNI_KLASIK_LEVEL+86,PRVNI_KLASIK_LEVEL+87,PRVNI_KLASIK_LEVEL+88,PRVNI_KLASIK_LEVEL+89,
				  PRVNI_KLASIK_LEVEL+52,PRVNI_KLASIK_LEVEL+55,PRVNI_KLASIK_LEVEL+53,PRVNI_KLASIK_LEVEL+54,PRVNI_KLASIK_LEVEL+56,
				  PRVNI_KLASIK_LEVEL+61,PRVNI_KLASIK_LEVEL+63,PRVNI_KLASIK_LEVEL+64,PRVNI_KLASIK_LEVEL+65,PRVNI_KLASIK_LEVEL+66,
				  PRVNI_KLASIK_LEVEL+67,PRVNI_KLASIK_LEVEL+70,PRVNI_KLASIK_LEVEL+71,PRVNI_KLASIK_LEVEL+72,PRVNI_KLASIK_LEVEL+73,
				  PRVNI_KLASIK_LEVEL+74,PRVNI_KLASIK_LEVEL+75,PRVNI_KLASIK_LEVEL+77,PRVNI_KLASIK_LEVEL+78,PRVNI_KLASIK_LEVEL+80,
				  PRVNI_KLASIK_LEVEL+48,PRVNI_KLASIK_LEVEL+50,PRVNI_KYBER_LEVEL+2,PRVNI_KYBER_LEVEL+3,PRVNI_KYBER_LEVEL+4,
				  PRVNI_KYBER_LEVEL+14,PRVNI_KYBER_LEVEL+15,PRVNI_KYBER_LEVEL+16,PRVNI_KYBER_LEVEL+17,PRVNI_KYBER_LEVEL+18,
				  PRVNI_KYBER_LEVEL+19,PRVNI_KYBER_LEVEL+20,PRVNI_KYBER_LEVEL+21,PRVNI_KYBER_LEVEL+22,PRVNI_KYBER_LEVEL+23,
				  PRVNI_KYBER_LEVEL+24,PRVNI_KYBER_LEVEL+37,PRVNI_KYBER_LEVEL+50,PRVNI_KYBER_LEVEL+81,PRVNI_KYBER_LEVEL+83,
				  PRVNI_KYBER_LEVEL+85,PRVNI_KYBER_LEVEL+55,PRVNI_KYBER_LEVEL+69,PRVNI_KYBER_LEVEL+29,PRVNI_KYBER_LEVEL+33,
				  PRVNI_KYBER_LEVEL+34,PRVNI_KYBER_LEVEL+35,PRVNI_KYBER_LEVEL+36,PRVNI_KYBER_LEVEL+72,PRVNI_KYBER_LEVEL+32,
				  PRVNI_KYBER_LEVEL+53,PRVNI_KYBER_LEVEL+82,PRVNI_KYBER_LEVEL+84,PRVNI_KYBER_LEVEL+54,PRVNI_KYBER_LEVEL+56,
				  PRVNI_KYBER_LEVEL+71,PRVNI_KYBER_LEVEL+45,PRVNI_KYBER_LEVEL+68,PRVNI_KYBER_LEVEL+61,PRVNI_KYBER_LEVEL+63,
				  PRVNI_KYBER_LEVEL+65,PRVNI_KYBER_LEVEL+57,PRVNI_KYBER_LEVEL+75,PRVNI_KYBER_LEVEL+41,PRVNI_KYBER_LEVEL+38,
				  PRVNI_KYBER_LEVEL+42,PRVNI_KYBER_LEVEL+43,PRVNI_KYBER_LEVEL+44,PRVNI_KYBER_LEVEL+78,PRVNI_KYBER_LEVEL+40,
				  PRVNI_KYBER_LEVEL+66,PRVNI_KYBER_LEVEL+67,PRVNI_KYBER_LEVEL+64,PRVNI_KYBER_LEVEL+62,PRVNI_KYBER_LEVEL+59,
				  PRVNI_KYBER_LEVEL+80,SLEPEJ_PRVEK};
	   int frameCols[]={10,12,13,14,0,
				  1,2,3,4,5,
				  6,7,11,18,20,
				  8,9,15,16,17,
				  19,21,22,23,24,
				  0,0,0,0,0,
				  0,1,2,3,4,
				  0,0,1,2,3,
				  4,0,1,2,3,
				  4,0,0,1,1,
				  0,0,
				  0,1,2,
				  3,4,5,6,7,
				  8,9,10,11,12,
				  13,0,0,1,2,
				  3,4,0,0,1,
				  2,3,4,1,0,
				  0,1,2,3,4,
				  0,0,0,1,2,
				  3,4,0,0,1,
				  2,3,4,1,0,
				  0,1,2,3,4,
				  1,-1};
	   int frameRows[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				  0,0,0,0,0,
				  2,2,2,2,2,
				  0,3,3,3,3,
				  3,1,1,1,1,
				  1,0,1,2,3,
				  1,0,
				  0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				  1,2,2,2,
				  2,2,0,0,0,
				  0,0,0,0,2,
				  3,3,3,3,3,
				  1,5,0,0,0,
				  0,0,2,4,4,
				  4,4,4,2,6,
				  1,1,1,1,1,
				  3,-1};
	   const char *files[]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
				  "HRAC1","HRAC2","HRAC3","HRAC4","HRAC5",
				  "DOORKEY","DOORKEY","DOORKEY","DOORKEY","DOORKEY",
				  "DOORCOLS","DOORCOLS","DOORCOLS","DOORCOLS","DOORCOLS",
				  "DOORCOLS","DOORCOLS","DOORCOLS","DOORCOLS","DOORCOLS",
				  "DOORCOLS","DOOROT","DOOROT","DOOROT","DOOROT",
				  "DOORKEY","DOORKEY",
				  NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
				  "DOORKEY","DOORCOLS","DOORCOLS","DOORCOLS",
				  "DOORCOLS","DOORCOLS","DOOROT","DOORKEY","DOORKEY",
				  "DOORKEY","DOORKEY","DOORKEY","DOOROT","DOORKEY",
				  "DOORCOLS","DOORCOLS","DOORCOLS","DOORCOLS","DOORCOLS",
				  "DOOROT","DOORKEY","DOORCOLS","DOORCOLS","DOORCOLS",
				  "DOORCOLS","DOORCOLS","DOOROT","DOORKEY","DOORKEY",
				  "DOORKEY","DOORKEY","DOORKEY","DOOROT","DOORKEY",
				  "DOORCOLS","DOORCOLS","DOORCOLS","DOORCOLS","DOORCOLS",
				  "DOOROT",NULL};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,frameRows,files,themeID,frameCol,frameRow,file);
	  }
	  break;
	case P_EXIT:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL+36,PRVNI_KLASIK_LEVEL+37,PRVNI_KLASIK_LEVEL+38,PRVNI_KLASIK_LEVEL+39,
	              PRVNI_KLASIK_LEVEL+40,PRVNI_KLASIK_LEVEL+41,PRVNI_KLASIK_LEVEL+42,PRVNI_KYBER_LEVEL+13,
				  PRVNI_KYBER_LEVEL+12,SLEPEJ_PRVEK};
	   int frameCols[]={0,1,0,1,0,1,0,0,1,-1};
	   int frameRows[]={0,0,1,1,2,2,0,0,0,-1};
	   int idx=DecodeVarianta(varianta,anak,frameCols,frameRows,NULL,themeID,frameCol,frameRow,NULL);
	   if(idx<6&&idx!=-1) themeID=(UINT)-1;
	   res=idx!=-1;
      }
	  break;
	case P_KAMEN:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL,PRVNI_KYBER_LEVEL+46,SLEPEJ_PRVEK};
	   int frameCols[]={0,0,-1};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,NULL,NULL,themeID,frameCol,frameRow,NULL);
	  }
	  break;
	case P_KLIC:
	  {
	   WORD anak[]={PRVNI_GLOBAL_LEVEL+5,SLEPEJ_PRVEK};
	   int frameCols[]={0,-1};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,NULL,NULL,themeID,frameCol,frameRow,NULL);
	   themeID=(UINT)-1;
	  }
	  break;
	case P_KRUMPAC:
	  {
	   WORD anak[]={PRVNI_GLOBAL_LEVEL+6,PRVNI_KYBER_LEVEL+1,SLEPEJ_PRVEK};
	   int frameCols[]={0,0,-1};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,NULL,NULL,themeID,frameCol,frameRow,NULL);
	  }
	  break;
	case P_KLIC1:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL+8,PRVNI_KYBER_LEVEL+8,SLEPEJ_PRVEK};
	   int frameCols[]={1,1,-1};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,NULL,NULL,themeID,frameCol,frameRow,NULL);
	  }
	  break;
	case P_KLIC2:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL+9,PRVNI_KYBER_LEVEL+7,SLEPEJ_PRVEK};
	   int frameCols[]={2,2,-1};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,NULL,NULL,themeID,frameCol,frameRow,NULL);
	  }
	  break;
	case P_KLIC3:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL+10,PRVNI_KYBER_LEVEL+9,SLEPEJ_PRVEK};
	   int frameCols[]={3,3,-1};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,NULL,NULL,themeID,frameCol,frameRow,NULL);
	  }
	  break;
	case P_KLIC4:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL+11,PRVNI_KYBER_LEVEL+10,SLEPEJ_PRVEK};
	   int frameCols[]={4,4,-1};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,NULL,NULL,themeID,frameCol,frameRow,NULL);
	  }
	  break;
	case P_KLIC5:
	  {
	   WORD anak[]={PRVNI_KLASIK_LEVEL+12,PRVNI_KYBER_LEVEL+11,SLEPEJ_PRVEK};
	   int frameCols[]={5,5,-1};
	   res=-1!=DecodeVarianta(varianta,anak,frameCols,NULL,NULL,themeID,frameCol,frameRow,NULL);
	  }
	  break;
	case P_DVERE1_H_O:
	case P_DVERE2_H_O:
	case P_DVERE3_H_O:
	case P_DVERE4_H_O:
	case P_DVERE5_H_O:
	case P_DVERE1_V_O:
	case P_DVERE2_V_O:
	case P_DVERE3_V_O:
	case P_DVERE4_V_O:
	case P_DVERE5_V_O:
	  themeID=1;
	  res=true;
	  break;
	case P_DVERE1_H_Z:
	case P_DVERE2_H_Z:
	case P_DVERE3_H_Z:
	case P_DVERE4_H_Z:
	case P_DVERE5_H_Z:
	case P_DVERE1_V_Z:
	case P_DVERE2_V_Z:
	case P_DVERE3_V_Z:
	case P_DVERE4_V_Z:
	case P_DVERE5_V_Z:
	  if(varianta==0) themeID=1; else themeID=2;
	  res=true;
	  break;
	case P_ID_DVERE1_H_O:
	case P_ID_DVERE2_H_O:
	case P_ID_DVERE3_H_O:
	case P_ID_DVERE4_H_O:
	case P_ID_DVERE5_H_O:
	case P_ID_DVERE1_V_O:
	case P_ID_DVERE2_V_O:
	case P_ID_DVERE3_V_O:
	case P_ID_DVERE4_V_O:
	case P_ID_DVERE5_V_O:
	case P_ID_DVERE1_H_Z:
	case P_ID_DVERE2_H_Z:
	case P_ID_DVERE3_H_Z:
	case P_ID_DVERE4_H_Z:
	case P_ID_DVERE5_H_Z:
	case P_ID_DVERE1_V_Z:
	case P_ID_DVERE2_V_Z:
	case P_ID_DVERE3_V_Z:
	case P_ID_DVERE4_V_Z:
	case P_ID_DVERE5_V_Z:
	  if(varianta==0) themeID=1; else themeID=2;
	  res=true;
	  break;
	case P_DV_H_O:
	case P_DV_V_O:
	case P_DV_H_Z:
	case P_DV_V_Z:
	  if(varianta==0) themeID=1; else themeID=2;
	  res=true;
	  break;
	case P_DV_H:
	case P_DV_V:
	  themeID=2;
	  res=true;
	  break;
   }
 return res;
}

bool IsInSeznam(const WORD *sez, WORD val)
{
 if(!sez) return false;
 bool res=false;
 for(int i=0;sez[i]!=SLEPEJ_PRVEK;i++)
   {
    if(sez[i]==val) return true;
   }
 return false;
}

//---------------------------------------------------------------------------------------

typedef struct  {
   //unsigned char  signum[30];    //	 -> retezec "Berusky (C) Anakreon 1998"
   unsigned char  pozadi;    // -> cislo pozadi
   unsigned char  hudba;    // -> cislo hudby k tomuto levelu
   unsigned char  natoceni[5];    // -> natoceni hracu
   unsigned char  rezerved[100];    // -> pro pozdejsi pouziti
   unsigned short podlaha[YPOLI][XPOLI][10];     // -> podlaha
   unsigned short level[YPOLI][XPOLI][10];      //-> herni plocha (dnesni level)
   unsigned short hraci[YPOLI][XPOLI];      //-> mapa hracu (dneska sou hraci n levelu)
} DISK_LEVEL;

//---------------------------------------------------------------------------------------
bool LoadAnakLevel(MStream *f, MGameMap *map)
{
 if(!f||!map) return false;
 /*char buff[MAX_PATH];
 strcpy(buff,GetDataDir());
 strcat(buff,pfile);
 strcat(buff,".LV3");
 FILE *f=fopen(buff,"rb");*/
 if(!f) return false;
 DISK_LEVEL dl;
 //fread(&dl,1,sizeof(DISK_LEVEL),f);
 //if((sizeof(DISK_LEVEL))!=f->read(&dl,sizeof(DISK_LEVEL)))
 #define read_piece_of_data(d,sz) ( sz!=f->read(&d,sz) )
 if(read_piece_of_data(dl.pozadi,1)||
    read_piece_of_data(dl.hudba,1)||
    read_piece_of_data(dl.natoceni,5)||
    read_piece_of_data(dl.rezerved,100)||
    read_piece_of_data(dl.podlaha,2*YPOLI*XPOLI*10)||
    read_piece_of_data(dl.level,2*YPOLI*XPOLI*10)||
    read_piece_of_data(dl.hraci,2*YPOLI*XPOLI))
   {
    WriteToLog("LoadAnakLevel file too small");
    //fclose(f);
	return false;
   }
 bool res=true;
 //res=!(strcmp((const char *)(dl.signum),h_levelu));

 int x,y;
 WORD prvek;
 UINT themeID;
 int frameCol, frameRow;
 char file[50];

 if(res)
   {
	myPOINT off;
	map->GetOffset(off);
    res=map->Create(XPOLI,YPOLI,off,dl.pozadi+1);
	if(!res) WriteToLog("LoadAnakLevel Create map failed");
   }
 if(res)
   {
    for(x=0;res&&x<XPOLI;x++)
	  {
	   for(y=0;res&&y<YPOLI;y++)
	     {
		  if(SLEPEJ_PRVEK!=dl.hraci[y][x])
		    {
			 MPlayerType pt=MPlayerType(dl.hraci[y][x]+1);
			 if(pt==ptRed||pt==ptGreen||pt==ptBlue||pt==ptYellow||pt==ptMagenta)
			   {
			    MPlayerRotation prot=prUp;
			    switch(dl.natoceni[dl.hraci[y][x]])
				  {
				   case 0: prot=prUp; break;
				   case 2: prot=prDown; break;
				   case 3: prot=prLeft; break;
				   case 1: prot=prRight; break;
				  }
			    res=map->AddPlayer(x,y,pt,prot);
				if(!res) WriteToLog("LoadAnakLevel Add player at %d,%d failed",x,y);
			   }
			  else 
			   {
			    res=false;
				WriteToLog("LoadAnakLevel Wrong player type");
			   }
			}
		  prvek=dl.level[y][x][PRVEK];
		  if(dl.podlaha[y][x][PRVEK]!=NENI_PODLAHA&&dl.podlaha[y][x][VARIANTA]!=SLEPEJ_SPRIT)
		    {
		     res=GetPrvekThemeAndOther(P_ZEME,dl.podlaha[y][x][VARIANTA],themeID,frameCol,frameRow,file);
		     if(res) 
			   {
			    res=map->SetGround(x,y,themeID,frameCol,frameRow,file);
				if(!res) WriteToLog("LoadAnakLevel SetGround failed");
			   }
			  else
			   {
			    WriteToLog("LoadAnakLevel Ground not found");
			   }
		    }
		  switch(prvek)
		    {
		     case P_ZEME:
			   //break;
		     case P_HRAC_1:
		     case P_HRAC_2:
		     case P_HRAC_3:
		     case P_HRAC_4:
		     case P_HRAC_5:
			   res=true;
			   break;
		     case P_BEDNA:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  res=map->AddItemBox(x,y,themeID,frameCol,frameRow);
				  if(!res) WriteToLog("LoadAnakLevel Add box at %d,%d failed",x,y);
				 }
			    else WriteToLog("LoadAnakLevel Box not found");
			   break;
		     case P_TNT:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  res=map->AddItemTNT(x,y,themeID,frameCol,frameRow);
				  if(!res) WriteToLog("LoadAnakLevel Add TNT at %d,%d failed",x,y);
				 }
			    else WriteToLog("LoadAnakLevel TNT not found");
			   break;
		     case P_STENA:
			   {
			    if(map->HaveDoorOn(x,y)) break;
			    res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,file);
			    if(res) 
				  {
				   res=map->AddItemWall(x,y,themeID,frameCol,frameRow,file,dl.level[y][x][ROTACE]);
				   if(!res) WriteToLog("LoadAnakLevel Add wall at %d,%d failed",x,y);
				  }
				 else WriteToLog("LoadAnakLevel Wall not found");
			   }
			   break;
		     case P_EXIT:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  res=map->AddItemExit(x,y,themeID,frameCol,frameRow);
				  if(!res) WriteToLog("LoadAnakLevel Add exit at %d,%d failed",x,y);
				 }
			    else WriteToLog("LoadAnakLevel Exit not found");
			   break;
		     case P_KAMEN:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  res=map->AddItemStone(x,y,themeID,frameCol,frameRow);
				  if(!res) WriteToLog("LoadAnakLevel Add stone at %d,%d failed",x,y);
				 }
			    else WriteToLog("LoadAnakLevel Stone not found");
			   break;
		     case P_KLIC:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  res=map->AddItemExitKey(x,y,themeID,frameCol,frameRow);
				  if(!res) WriteToLog("LoadAnakLevel Add exit key at %d,%d failed",x,y);
				 }
			    else WriteToLog("LoadAnakLevel ExitKey not found");
			   break;
		     case P_KRUMPAC:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  res=map->AddItemTool(x,y,themeID,frameCol,frameRow);
				  if(!res) WriteToLog("LoadAnakLevel Add tool at %d,%d failed",x,y);
				 }
			    else WriteToLog("LoadAnakLevel Tool not found");
			   break;
		     case P_KLIC1:
		     case P_KLIC2:
		     case P_KLIC3:
		     case P_KLIC4:
		     case P_KLIC5:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  MPlayerType pt=ptAll;
				  switch(prvek)
				    {
					 case P_KLIC1: pt=ptRed; break;
					 case P_KLIC2: pt=ptGreen; break;
					 case P_KLIC3: pt=ptBlue; break;
					 case P_KLIC4: pt=ptYellow; break;
					 case P_KLIC5: pt=ptMagenta; break;
					}
				  res=map->AddItemColorKey(x,y,pt,themeID);
				  if(!res) WriteToLog("LoadAnakLevel Add color key at %d,%d failed",x,y);
				 }
				else WriteToLog("LoadAnakLevel Color key not found");
			   break;
			 case P_DVERE1_H_O:
			 case P_DVERE2_H_O:
			 case P_DVERE3_H_O:
			 case P_DVERE4_H_O:
			 case P_DVERE5_H_O:
			 case P_DVERE1_H_Z:
			 case P_DVERE2_H_Z:
			 case P_DVERE3_H_Z:
			 case P_DVERE4_H_Z:
			 case P_DVERE5_H_Z:
			 case P_DVERE1_V_O:
			 case P_DVERE2_V_O:
			 case P_DVERE3_V_O:
			 case P_DVERE4_V_O:
			 case P_DVERE5_V_O:
			 case P_DVERE1_V_Z:
			 case P_DVERE2_V_Z:
			 case P_DVERE3_V_Z:
			 case P_DVERE4_V_Z:
			 case P_DVERE5_V_Z:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  MPlayerType pt=ptAll;
				  switch(prvek)
				    {
					 case P_DVERE1_H_O:
					 case P_DVERE1_H_Z:
					 case P_DVERE1_V_O:
					 case P_DVERE1_V_Z:
					    pt=ptRed;
						break;
					 case P_DVERE2_H_O:
					 case P_DVERE2_H_Z:
					 case P_DVERE2_V_O:
					 case P_DVERE2_V_Z:
					    pt=ptGreen;
						break;
					 case P_DVERE3_H_O:
					 case P_DVERE3_H_Z:
					 case P_DVERE3_V_O:
					 case P_DVERE3_V_Z:
					    pt=ptBlue;
						break;
					 case P_DVERE4_H_O:
					 case P_DVERE4_H_Z:
					 case P_DVERE4_V_O:
					 case P_DVERE4_V_Z:
					    pt=ptYellow;
						break;
					 case P_DVERE5_H_O:
					 case P_DVERE5_H_Z:
					 case P_DVERE5_V_O:
					 case P_DVERE5_V_Z:
					    pt=ptMagenta;
						break;
					}
				  WORD locked[]={P_DVERE1_H_Z,P_DVERE2_H_Z,P_DVERE3_H_Z,P_DVERE4_H_Z,P_DVERE5_H_Z,P_DVERE1_V_Z,P_DVERE2_V_Z,P_DVERE3_V_Z,P_DVERE4_V_Z,P_DVERE5_V_Z,SLEPEJ_PRVEK};
				  WORD horz[]={P_DVERE1_H_O,P_DVERE2_H_O,P_DVERE3_H_O,P_DVERE4_H_O,P_DVERE5_H_O,P_DVERE1_H_Z,P_DVERE2_H_Z,P_DVERE3_H_Z,P_DVERE4_H_Z,P_DVERE5_H_Z,SLEPEJ_PRVEK};
				  res=map->AddItemLockDoor(x,y,pt,IsInSeznam(locked,prvek),!IsInSeznam(horz,prvek),themeID);
				  if(!res) WriteToLog("LoadAnakLevel Add lock door at %d,%d failed",x,y);
				 }
				else WriteToLog("LoadAnakLevel Lock door not found");
			   break;
			 case P_ID_DVERE1_H_O:
			 case P_ID_DVERE2_H_O:
			 case P_ID_DVERE3_H_O:
			 case P_ID_DVERE4_H_O:
			 case P_ID_DVERE5_H_O:
			 case P_ID_DVERE1_V_O:
			 case P_ID_DVERE2_V_O:
			 case P_ID_DVERE3_V_O:
			 case P_ID_DVERE4_V_O:
			 case P_ID_DVERE5_V_O:
			 case P_ID_DVERE1_H_Z:
			 case P_ID_DVERE2_H_Z:
			 case P_ID_DVERE3_H_Z:
			 case P_ID_DVERE4_H_Z:
			 case P_ID_DVERE5_H_Z:
			 case P_ID_DVERE1_V_Z:
			 case P_ID_DVERE2_V_Z:
			 case P_ID_DVERE3_V_Z:
			 case P_ID_DVERE4_V_Z:
			 case P_ID_DVERE5_V_Z:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  MPlayerType pt=ptAll;
				  switch(prvek)
				    {
					 case P_ID_DVERE1_H_O:
					 case P_ID_DVERE1_H_Z:
					 case P_ID_DVERE1_V_O:
					 case P_ID_DVERE1_V_Z:
					    pt=ptRed;
						break;
					 case P_ID_DVERE2_H_O:
					 case P_ID_DVERE2_H_Z:
					 case P_ID_DVERE2_V_O:
					 case P_ID_DVERE2_V_Z:
					    pt=ptGreen;
						break;
					 case P_ID_DVERE3_H_O:
					 case P_ID_DVERE3_H_Z:
					 case P_ID_DVERE3_V_O:
					 case P_ID_DVERE3_V_Z:
					    pt=ptBlue;
						break;
					 case P_ID_DVERE4_H_O:
					 case P_ID_DVERE4_H_Z:
					 case P_ID_DVERE4_V_O:
					 case P_ID_DVERE4_V_Z:
					    pt=ptYellow;
						break;
					 case P_ID_DVERE5_H_O:
					 case P_ID_DVERE5_H_Z:
					 case P_ID_DVERE5_V_O:
					 case P_ID_DVERE5_V_Z:
					    pt=ptMagenta;
						break;
					}
				  //WORD locked[]={P_ID_DVERE1_H_Z,P_ID_DVERE2_H_Z,P_ID_DVERE3_H_Z,P_ID_DVERE4_H_Z,P_ID_DVERE5_H_Z,P_ID_DVERE1_V_Z,P_ID_DVERE2_V_Z,P_ID_DVERE3_V_Z,P_ID_DVERE4_V_Z,P_ID_DVERE5_V_Z,SLEPEJ_PRVEK};
				  WORD horz[]={P_ID_DVERE1_H_O,P_ID_DVERE2_H_O,P_ID_DVERE3_H_O,P_ID_DVERE4_H_O,P_ID_DVERE5_H_O,P_ID_DVERE1_H_Z,P_ID_DVERE2_H_Z,P_ID_DVERE3_H_Z,P_ID_DVERE4_H_Z,P_ID_DVERE5_H_Z,SLEPEJ_PRVEK};
				  res=map->AddItemColorWay(x,y,pt,!IsInSeznam(horz,prvek),themeID);
				  if(!res) WriteToLog("LoadAnakLevel Add color door at %d,%d failed",x,y);
				 }
				else WriteToLog("LoadAnakLevel Color door not found");
			   break;
			 case P_DV_H_O:
			 case P_DV_H_Z:
			 case P_DV_V_O:
			 case P_DV_V_Z:
			   res=GetPrvekThemeAndOther(prvek,dl.level[y][x][VARIANTA],themeID,frameCol,frameRow,NULL);
			   if(res) 
			     {
				  WORD locked[]={P_DV_H_Z,P_DV_V_Z,SLEPEJ_PRVEK};
				  WORD horz[]={P_DV_H_Z,P_DV_H_O,SLEPEJ_PRVEK};
				  res=map->AddItemOnceDoor(x,y,IsInSeznam(locked,prvek),!IsInSeznam(horz,prvek),themeID);
				  if(!res) WriteToLog("LoadAnakLevel Add once door at %d,%d failed",x,y);
				 }
				else WriteToLog("LoadAnakLevel Once door not found");
			   break;
			 case P_DV_H:
			 case P_DV_V:
			   //res=false;
			   break;
			}
		 }
	  }
   }

 //fclose(f);
 return res;
}

bool LoadAJALevel(MStream *f,MGameMap *map)
{
 if(!f||!map) return false;
 bool res=true;
 MGameMapSave sv;
 res=sv.LoadFromStream(f);
 if(res) res=sv.Load(map);
 return res;
}

#ifndef MAX_PATH
#define MAX_PATH 1024
#endif

void ToLower(char *buff);

bool LoadLevel(const char *file, MGameMap *map)
{
 char sign[30];
 char buff[MAX_PATH];
 
 MStream *strm=NULL;
 bool clear_strm=false;

 if(strchr(file,'.')!=NULL)
   {
    strcpy(buff,file);
   }
  else
   {
    strcpy(buff,"Data\\");
    //strcpy(buff,GetDataDir());
    strcat(buff,file);
    strcat(buff,".LV3");
	strm=GetDataFileStream(buff);
	if(!strm)
	  {
       strcpy(buff,GetDataDir());
	   char *pf=strdup(file);
	   if(pf)
	     {
		  ToLower(pf);
		  strcat(buff,pf);
		  free(pf);
		 }
		else strcat(buff,file);
       strcat(buff,".lv3");
	  }
   }
 if(!strm) 
   {
    strm=new MFileStream(buff,foBinRead);
	clear_strm=true;
   }
 //FILE *f=fopen(buff,"rb");
 if(!strm||!strm->is_open()) 
   {
    WriteToLog("LoadLevel '%s' failed, file not found",buff);
    return false;
   }
 bool res=false;
 //fread(sign,1,30,f);
 strm->read(sign,30);
 if(!(strcmp(sign,h_levelu))) res=LoadAnakLevel(strm,map);
  else
   {
    if(!(strcmp(sign,AJA_LEVEL_HEADER))) res=LoadAJALevel(strm,map);
	 else WriteToLog("LoadLevel: Unknown file format '%s'",buff);
   }
 //fclose(f);
 if(strm&&clear_strm) delete strm;
 return res;
}
