
#include "berdy.h"
#include "menu.h"
#include "MBitmaps.h"
#include <vector>
#include "datafile.h"
#include "sound.h"

using namespace std;

//-------------------------------------------------------------------------------
#ifndef FreePtr
#define FreePtr(x) if(x) free(x); (x)=NULL;
#endif

#ifdef COMPILE_LINUX
int stricmp(const char *str1, const char *str2);
#endif

MGame *GameResp=NULL;
void SetGameMenuRespons(MGame *Game){GameResp=Game;}

void SetLevelInEpisode(int episode, int level);

void OnMenuActivate(UINT menuID)
{
 if(GetMainResponder()) GetMainResponder()->MenuClick(menuID);
 switch(menuID)
   {
    /*case MENU_QUIT_YES:
	  QuitGame();
	  break;*/
	case MENU_GAME_RESTART: if(GameResp) GameResp->Restart(); break;
	case MENU_GAME_LOAD:    if(GameResp) GameResp->MemLoad(); break;
	case MENU_GAME_SAVE:    if(GameResp) GameResp->MemSave(); break;
	case MENU_MAIN_HELP:    ShowHelpMenu(GetMainMenu()); break;
	case MENU_MAIN_OPTIONS: ShowOptionsMenu(GetMainMenu()); break;
	case MENU_NEWGAME_TRENINK: SetLevelInEpisode(1,1); break;
	case MENU_NEWGAME_LEHKA: SetLevelInEpisode(2,1); break;
	case MENU_NEWGAME_STREDNI: SetLevelInEpisode(3,1); break;
	case MENU_NEWGAME_TEZKA: SetLevelInEpisode(4,1); break;
	case MENU_NEWGAME_NEMOZNA: SetLevelInEpisode(5,1); break;
   }
}

//-------------------------------------------------------------------------------

bool GetNewBitmapFileName(char *ch, int max);

//-------------------------------------------------------------------------------

bool InitGame(void)
{
 //if(!LoadDataFile(NULL)) return false;
 ScreenDrawBitmap("MENU_055",70,50);
 ScreenPaint();
 InitFont();
 InitSoundAndMusic();
 LoadSetup();
 InitOci();
 RunIntro(GetMainMenu());
 return true;
}

MAnimationBitmap oci[POCET_OCI];
BYTE wait[POCET_OCI];

void InitOci(void)
{
 for(int i=0;i<POCET_OCI;i++)
   {
    LoadBitmap(&(oci[i].Bitmap),"oci");
    myRECT at;
	oci[i].frameOffset.x=0; oci[i].frameOffset.y=0;
	oci[i].frameSize.cx=12; oci[i].frameSize.cy=10;
	at.top=rand()%470;
	if(at.top>409+20) at.left=rand()%(640-12);
	 else 
	  {
	   at.left=rand()%(13);
	   if(rand()%2) at.left+=405+110;
	  }
	at.right=at.left+oci[i].frameSize.cx;
	at.bottom=at.top+oci[i].frameSize.cy;
    oci[i].Initialize(&at);
	//for(int j=0;j<POCET_OCI;j++) oci[j].Next();
	wait[i]=rand()%13;
   }
}

void DoOciAnim(void)
{
 for(int i=0;i<POCET_OCI;i++)
   {
    if(oci[i].Next())
	  {
	   MBitmap bmp;
	   bmp.Create(oci[i].frameSize.cx, oci[i].frameSize.cy);
	   oci[i].DrawStep(&bmp,oci[i].Step,NULL);
	   ScreenDrawBitmap(&bmp,oci[i].DrawAt.left, oci[i].DrawAt.top);
	  }
	 else
	  {
       if(wait[i]>0) wait[i]--;
	    else
		 {
	      myRECT at;
	      at.top=rand()%470;
	      if(at.top>409+20) at.left=rand()%(640-12);
	       else 
	        {
	         at.left=rand()%(13);
	         if(rand()%2) at.left+=405+110;
	        }
	      at.right=at.left+oci[i].frameSize.cx;
	      at.bottom=at.top+oci[i].frameSize.cy;
	      oci[i].Initialize(&at);
		  wait[i]=rand()%13;
		 }
	  }
   }
}

bool ExistThemeBitmap(UINT themeID, const char *file)
{
 if(!file) return false;
 char mfile[128];
 if(themeID==(UINT)-1) strcpy(mfile,file);
  else sprintf(mfile,"Theme%03d\\%s",themeID,file);
 MBitmap bmp;
 return LoadBitmap(&bmp,mfile,false,true);
}

bool LoadThemeBitmap(UINT themeID, MBitmap *bmp, const char *file, bool createMask)
{
 if(!bmp||!file) return false;
 //pruhledna barva 167,107,107
 char mfile[128];
 if(themeID==(UINT)-1) strcpy(mfile,file);
  else sprintf(mfile,"Theme%03d\\%s",themeID,file);
 bool have=LoadBitmap(bmp,mfile,false,true);
 if(!have&&themeID!=(UINT)-1)
   {
	have=LoadBitmap(bmp,file,false,true);
   }
 if(have)
   {
    if(bmp&&createMask)
	  {
	   bmp->UpdateMask(TRANSPARENT_COLOR);
	  }
   }
 return have;
}

//---------------------------------------------------------------------------------------

MMapObject::MMapObject()
{
 Map=NULL;
 item=NULL;
 
 themeID=(UINT)-1;
 frameCol=-1; frameRow=-1;
 file=NULL;


 X=-1; Y=-1;
 locked=false;
 playerHere=false;
 rect.left=0; rect.top=0; rect.right=0; rect.bottom=0;
 bmp=new MBitmap;
 if(bmp) bmp->Create(MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT);
}

MMapObject::~MMapObject()
{
 if(bmp) delete bmp; bmp=NULL;
 if(item) delete item; item=NULL;
 if(file) free(file); file=NULL;
 Map=NULL;
 locked=false;
 playerHere=false;
}

void MMapObject::SetMap(MGameMap *pmap)
{
 Map=pmap;
}

/*void MMapObject::Draw(MPlayer *withPlayer)
{
 if(!withPlayer) ScreenDrawBitmap(bmp,&rect);
  else
   {
    MBitmap b;
	b.Assign(bmp);
	withPlayer->DrawAt(&b,0,0);
	ScreenDrawBitmap(&b,&rect);
   }
}*/

void MMapObject::DrawAt(MBitmap *des,int offsetx, int offsety)
{
 if(!bmp||!des) return;
 MyHDC dc=des->BeginPaint();
 mySIZE sz;
 bmp->GetSize(sz);
 myRECT r={offsetx,offsety,offsetx+sz.cx,offsety+sz.cy};
 bmp->Draw(dc,&r);
 if(item)
   {
	item->DrawAt(des,&r);
   }
 des->EndPaint();
}

bool MMapObject::CanGoOn(MMapItem *pitem, int dx, int dy)
{
 return (!locked&&!playerHere)&&((!item)||item->CanGoOn(Map,pitem,dx,dy));
}

//---------------------------------------------------------------------------------------

MPlayer::MPlayer(MMapObject *obj):MMapItem(obj)
{
 SetPosition(-1,-1);
 Rotation=prUp;
 typ=ptAll;
 haveKey=false;
 haveTool=0;
 out=false;
 animated=false;
 //bmp=new MAnimationBitmap;
}

MPlayer::~MPlayer()
{
 //if(bmp) delete bmp; bmp=NULL;
}

void MPlayer::DrawAt(MBitmap *des,int offsetx, int offsety)
{
 if(!des||!bitmap) return;
 myRECT r={offsetx,offsety,offsetx+bitmap->frameSize.cx,offsety+bitmap->frameSize.cy};
 bitmap->DrawFrame(des,0,&r,Rotation);
}

void MPlayer::SetPosition(int px, int py)
{
 X=px; Y=py;
 newX=X; newY=Y;
}

bool MPlayer::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 return false;
}

//---------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------

MGame::MGame()
{
 Map=NULL;
 Menu=NULL;
 File=NULL;
 haveSaves=1;
 needsave=false;
 
 statuswait=0;
 demoNoSave=NULL;
 noSaves=NULL;
 Saving=NULL;
 demoNoLoad=NULL;
 emptyLoad=NULL;
 Loading=NULL;
}

MGame::~MGame()
{
 Map=NULL;
 Menu=NULL;
 if(File) free(File); File=NULL;
 FreePtr(demoNoSave);
 FreePtr(noSaves);
 FreePtr(Saving);
 FreePtr(demoNoLoad);
 FreePtr(emptyLoad);
 FreePtr(Loading);
}

void MGame::InitMenu(void)
{
 Menu=GetInGameMenu();
 if(Menu!=NULL)
   {
    MMenuPolozka *p;
	Menu->Parent=this;
	for(UINT i=0;i<Menu->Count();i++)
	  {
	   p=Menu->Get(i);
	   if(p&&p->ID!=MENU_GAME_KONEC)
	     {
		  p->NextMenu=this;
		 }
	  }
   }
 if(!demoNoSave) demoNoSave=LoadText("GAME",2,2,true,false);
 if(!noSaves) noSaves=LoadText("GAME",2,3,true,false);
 if(!Saving) Saving=LoadText("GAME",2,4,true,false);
 if(!demoNoLoad) demoNoLoad=LoadText("GAME",2,5,true,false);
 if(!emptyLoad) emptyLoad=LoadText("GAME",2,6,true,false);
 if(!Loading) Loading=LoadText("GAME",2,7,true,false);
}

void MGame::ManageGameMenu(void)
{
 if(!Menu) SetMainResponder(Parent);
  else 
   {
    SetGameMenuRespons(this);
    SetMainResponder(Menu);
   }
}

void MGame::SetFile(const char *file)
{
 if(File) free(File);
 File=NULL;
 if(file) File=strdup(file);
}

const char *MGame::GetFile(void){return File;}

bool MGame::Load(const char *file, int SaveLimit)
{
 haveSaves=SaveLimit;
 needsave=false;
 Save.Clear();
 statuswait=0;

 if(!file||!Map) return false;
 if(file!=GetFile()) SetFile(file);
 if(!LoadLevel(GetFile(),Map))
   {
	return false;
   }
 Map->SortPlayers();
 InitMenu();
 return true;
}

void MGame::Restart(void)
{
 needsave=false;
 if(!Map||!GetFile()) return;
 if(!LoadLevel(GetFile(),Map))
   {
    SetMainResponder(Parent);
   }
}

void MGame::MemLoad(void)
{
 if(!Map) return;
 statuswait=20;
 char *txt;
 if(!Save.Load(Map)) txt=(emptyLoad);
  else txt=(Loading);
 Map->Draw();
 Map->OpenExit();
 Map->DrawStatusText(txt);
 SetAnimTimerEnabled(ANIM_TIMER1,true);
}

void MGame::MemSave(void)
{
 if(!Map) return;
 if(Map->HavePlayerAnims())
   {
    needsave=true;
	return;
   }
 needsave=false;
 statuswait=20;
 /*
 if(haveSaves<=0)
   {
    Map->DrawStatusText(noSaves);
    SetAnimTimerEnabled(ANIM_TIMER1,true);
    return;
   }*/
 if(!Save.Save(Map)) Map->DrawStatusText(noSaves);
  else Map->DrawStatusText(Saving);
 SetAnimTimerEnabled(ANIM_TIMER1,true);
}

#ifndef MAX_PATH
#define MAX_PATH 1024
#endif

void MGame::KeyPress(UINT Key,UINT butts)
{
 if(!Map)
   {
    if(Key==KEY_ESCAPE) SetMainResponder(Parent);
    return;
   }
 switch(Key)
   {
    case KEY_UP: Map->MovePlayer(prUp,(butts&MOUSE_BUTT_SHIFT)!=0); break;
    case KEY_DOWN: Map->MovePlayer(prDown,(butts&MOUSE_BUTT_SHIFT)!=0); break;
    case KEY_LEFT: Map->MovePlayer(prLeft,(butts&MOUSE_BUTT_SHIFT)!=0); break;
    case KEY_RIGHT: Map->MovePlayer(prRight,(butts&MOUSE_BUTT_SHIFT)!=0); break;
	case KEY_TAB: Map->NextPlayer(); break;
	case KEY_ESCAPE: 
	  {
	   ManageGameMenu();
	  }
	  break;
	case KEY_F1: ShowHelpMenu(this); break;
	case KEY_F2: MemSave(); break;
	case KEY_F3: MemLoad(); break;
	case KEY_F4: ShowOptionsMenu(this); break;
	case KEY_F9: //tipni obrazek
	  {
	   mySIZE sz;
	   ScreenGetSize(sz);
	   myRECT r={0,0,sz.cx,sz.cy};
	   MBitmap bmp;
	   ScreenGetBitmap(&bmp,&r);
	   char file[3*MAX_PATH];
	   if(GetNewBitmapFileName(file, 3*MAX_PATH))
	     {
	      bmp.SaveToFile(file);
		 }
	  }
	  break;
	//case KEY_D: //nahravani dema
	case KEY_N: //dalsi skladba
	  hraj_hudbu_levelu();
	  break;
   }
 TryEndLevel();
}

void MGame::TryEndLevel(void)
{
 if(LevelDone()) 
   {
    SetAnimTimerEnabled(ANIM_TIMER1,false);
    SetAnimTimerEnabled(ANIM_TIMER2,false);
    DoShowBitmapShut(this, NULL, false, false);
   }
}

void MGame::MouseMove(int x, int y, UINT butts)
{
 TryEndLevel();
}

void MGame::MouseLeft(int x, int y, UINT butts)
{
 TryEndLevel();
}

void MGame::MouseMiddle(int x, int y, UINT butts)
{
 TryEndLevel();
}

void MGame::MouseRight(int x, int y, UINT butts)
{
 TryEndLevel();
}

void MGame::OnAnimTimer(UINT timerID)
{
 if(Map) 
   {
    Map->OnAnimTimer(timerID);
	if(needsave) MemSave();
	if(timerID==ANIM_TIMER1)
	  {
	   if(statuswait)
	     {
		  statuswait--;
		  if(!statuswait)
		    {
			 Map->RedrawStatusText();
			 Map->UpdateTimers();
			}
		 }
	  }
   }
}

void MGame::Draw(void)
{
 if(Map) Map->Draw();
}

#define BERDA_MOVE_TIMERANIM 30
#define ITEM_ANIMS_TIMERANIM 40

void MGame::OnActivate(MResponder *resp)
{
 if(LevelDone())
   {
    SetMainResponder(Parent);
   }
  else
   {
    SetAnimTimerElapsed(ANIM_TIMER1,BERDA_MOVE_TIMERANIM);
    SetAnimTimerElapsed(ANIM_TIMER2,ITEM_ANIMS_TIMERANIM);
    ScreenClearRect();
    Draw();
	ScreenPaint();
	hraj_hudbu_levelu();
   }
}

void MGame::OnDeactivate(MResponder *resp)
{
 if(resp==Parent) 
   {
    SetAnimTimerEnabled(ANIM_TIMER1,false);
    SetAnimTimerEnabled(ANIM_TIMER2,false);
    ScreenClearRect();
   }
}

bool MGame::LevelDone(void)
{
 if(!Map) return false;
 return Map->IsLevelDone();
}

//---------------------------------------------------------------------------------------

MMapItem::MMapItem(MMapObject *obj)
{
 Parent=obj;
 bitmap=NULL;
 FrameRow=0; FrameCol=0;
 themeID=(UINT)-1;
}

MMapItem::~MMapItem()
{
 bitmap=NULL;
 Parent=NULL;
}

MMapObject *MMapItem::GetParent(void){return Parent;}
void MMapItem::SetParent(MMapObject *obj){Parent=obj;}

bool MMapItem::DrawAt(MBitmap *des,const myLPRECT r)
{
 if(!bitmap||!des||!r) return false;
 return bitmap->DrawFrame(des,FrameCol,r,FrameRow);
}

bool MMapItem::OnAnimTimer(MBitmap *des)
{
 return false;
}

//---------------------------------------------------------------------------------------

class MMapItemWall:public MMapItem
{
 private:
   //int rotation;
   char *file;
 public:
   MMapItemWall(MMapObject *obj, int rot, const char *pfile);
   virtual ~MMapItemWall();

   const char *getFile(void){return file;}
   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
};

MMapItemWall::MMapItemWall(MMapObject *obj,int rot, const char *pfile):MMapItem(obj)
{
 //rotation=rot;
 file=NULL;
 if(pfile&&pfile[0]) file=strdup(pfile);
}
MMapItemWall::~MMapItemWall()
{
 FreePtr(file);
 //if(rotation!=0) delete bitmap;
}

bool MMapItemWall::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy){return false;}

//---------------------------------------------------------------------------------------

class MMapItemBox:public MMapItem
{
 private:
 public:
   MMapItemBox(MMapObject *obj);
   virtual ~MMapItemBox();

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
};

MMapItemBox::MMapItemBox(MMapObject *obj):MMapItem(obj){}
MMapItemBox::~MMapItemBox(){}


//---------------------------------------------------------------------------------------

class MMapItemTNT:public MMapItemBox
{
 private:
 public:
   MMapItemTNT(MMapObject *obj);
   virtual ~MMapItemTNT();

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
};

bool MMapItemBox::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 MMapItemTNT *tnt=dynamic_cast<MMapItemTNT *>(item);
 if(!plr&&!tnt) return false;
 if(tnt) return true;
 return map->CanGoOn(this,GetParent()->X+dx,GetParent()->Y+dy);
}

MMapItemTNT::MMapItemTNT(MMapObject *obj):MMapItemBox(obj){}
MMapItemTNT::~MMapItemTNT(){}
bool MMapItemTNT::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 if(!plr) return false;
 return map->CanGoOn(this,GetParent()->X+dx,GetParent()->Y+dy);
}

//---------------------------------------------------------------------------------------

class MMapItemExitKey:public MMapItem
{
 private:
 public:
   MMapItemExitKey(MMapObject *obj);
   virtual ~MMapItemExitKey();

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
};

MMapItemExitKey::MMapItemExitKey(MMapObject *obj):MMapItem(obj){}
MMapItemExitKey::~MMapItemExitKey(){}
bool MMapItemExitKey::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 return (plr!=NULL)&&map->CanPickExitKey();
}

//---------------------------------------------------------------------------------------

class MMapItemExit:public MMapItem
{
 private:
   UINT timerPause;
 public:
   MMapItemExit(MMapObject *obj);
   virtual ~MMapItemExit();

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
   virtual bool OnAnimTimer(MBitmap *des);
};

MMapItemExit::MMapItemExit(MMapObject *obj):MMapItem(obj){timerPause=0;}
MMapItemExit::~MMapItemExit(){}
bool MMapItemExit::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 if(plr) 
   {
    map->ExitPlayer(this,plr);
   }
 return false;
}

bool MMapItemExit::OnAnimTimer(MBitmap *des)
{
 timerPause=(timerPause+1)%7;
 if((!timerPause)&&des&&bitmap)
   {
    FrameCol++;
	if(!bitmap->HaveFrame(FrameCol,FrameRow)) FrameCol=0;
	mySIZE sz; des->GetSize(sz);
	myRECT r={0,0, sz.cx,sz.cy};
	DrawAt(des,&r);
    return true;
   }
 return false;
}

//---------------------------------------------------------------------------------------

class MMapItemStone:public MMapItem
{
 private:
 public:
   MMapItemStone(MMapObject *obj);
   virtual ~MMapItemStone();

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
};

MMapItemStone::MMapItemStone(MMapObject *obj):MMapItem(obj){}
MMapItemStone::~MMapItemStone(){}
bool MMapItemStone::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 if(plr&&plr->haveTool>0)
   {
    map->DestroyStone(this,plr);
   }
 return false;
}

//---------------------------------------------------------------------------------------

class MMapItemTool:public MMapItem
{
 private:
 public:
   MMapItemTool(MMapObject *obj);
   virtual ~MMapItemTool();

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
};

MMapItemTool::MMapItemTool(MMapObject *obj):MMapItem(obj){}
MMapItemTool::~MMapItemTool(){}
bool MMapItemTool::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 return plr!=NULL&&(plr->haveTool<9);
}

//---------------------------------------------------------------------------------------

class MMapItemColorKey:public MMapItem
{
 private:
   MPlayerType keyType;
 public:
   MMapItemColorKey(MMapObject *obj, MPlayerType pkeyType);
   virtual ~MMapItemColorKey();

   MPlayerType getKeyType(void){return keyType;}
   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
};

MMapItemColorKey::MMapItemColorKey(MMapObject *obj,MPlayerType pkeyType):MMapItem(obj)
{
 keyType=pkeyType;
}

MMapItemColorKey::~MMapItemColorKey(){}
bool MMapItemColorKey::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 return plr&&(plr->typ==keyType);
}

//---------------------------------------------------------------------------------------

class MMapItemDoorWing:public MMapItemWall
{
 private:
 public:
   MMapItemDoorWing(MMapObject *obj,MMapItem *pdoor);
   virtual ~MMapItemDoorWing();

   MMapItem *door; //ukazatel na dvere, jen pujcenej, ze komu patri tato cast dveri, pri mazani se zavola mazani na tohoto, kdyz neni NULL
};

MMapItemDoorWing::MMapItemDoorWing(MMapObject *obj,MMapItem *pdoor):MMapItemWall(obj,0,NULL){door=pdoor;}
MMapItemDoorWing::~MMapItemDoorWing(){door=NULL;}

//---------------------------------------------------------------------------------------

class MMapItemDoorTmpl:public MMapItem
{
 private:
   UINT timerPause;
   bool anim_doorlocked;
 protected:
   bool doorlocked;
 public:
   MMapItemDoorTmpl(MMapObject *obj, bool locked);
   virtual ~MMapItemDoorTmpl();

   bool getDoorLocked(void){return doorlocked;}
   void setDoorLocked(bool pval){doorlocked=pval; anim_doorlocked=pval;}

   MMapItemDoorWing *wing1;
   MMapItemDoorWing *wing2;

   virtual void BeforeEnter(MGameMap *map, MMapItem *item)=0; //volana pred vstupem na prvek, vraci jestli vec muze do dveri
   virtual void AfterExit(MGameMap *map, MMapItem *item)=0; //volana po opusteni veci dveri
   virtual bool OnAnimTimer(MBitmap *des);

};

MMapItemDoorTmpl::MMapItemDoorTmpl(MMapObject *obj, bool locked) :MMapItem(obj)
{
 doorlocked=locked;
 anim_doorlocked=locked;
 timerPause=0;
 wing1=NULL;
 wing2=NULL;
}

MMapItemDoorTmpl::~MMapItemDoorTmpl()
{
 wing1=NULL; 
 wing2=NULL;
}

bool MMapItemDoorTmpl::OnAnimTimer(MBitmap *des)
{
 if(!doorlocked) return false;
 if(timerPause>0) timerPause--;
 if(timerPause>100) timerPause=100;
 if((!timerPause)&&des&&bitmap)
   {
    timerPause=(rand()%7)+3;
	anim_doorlocked=!anim_doorlocked;
	if(anim_doorlocked) FrameCol--;
	 else FrameCol++;
	mySIZE sz; des->GetSize(sz);
	myRECT r={0,0, sz.cx,sz.cy};
	DrawAt(des,&r);
	if(anim_doorlocked) FrameCol++;
	 else FrameCol--;
    return true;
   }
 return false;
}

//-----------------------------------------------------------------------------

class MMapItemLockDoor:public MMapItemDoorTmpl
{
 private:
   MPlayerType keyType;
 public:

   MMapItemLockDoor(MMapObject *obj, MPlayerType pkeyType, bool locked);
   virtual ~MMapItemLockDoor();

   MPlayerType getKeyType(void){return keyType;}

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
   void BeforeEnter(MGameMap *map, MMapItem *item); //volana pred vstupem na prvek, vraci jestli vec muze do dveri
   void AfterExit(MGameMap *map, MMapItem *item); //volana po opusteni veci dveri
};

MMapItemLockDoor::MMapItemLockDoor(MMapObject *obj,MPlayerType pkeyType, bool locked):MMapItemDoorTmpl(obj,locked)
{
 keyType=pkeyType;
}

MMapItemLockDoor::~MMapItemLockDoor()
{
}

bool MMapItemLockDoor::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 return plr&&/*(plr->typ==keyType)&&*/!doorlocked;
}

void MMapItemLockDoor::BeforeEnter(MGameMap *map, MMapItem *item)
{
 MPlayer *plr=dynamic_cast<MPlayer *>(item);
 if(plr&&plr->haveKey&&plr->typ==keyType&&map&&doorlocked)
   {
    plr->haveKey=false;
	doorlocked=false;
	FrameCol++;
	if(wing1) wing1->FrameRow++;
	if(wing2) wing2->FrameRow++;
	map->DoorStateChanged(this);
	map->PlayerStateChanged(plr);
	PlaySfx(SFX_ODEMYK,SFX_PRIORITY2);
	PlaySfx(SFX_OTEVRENI_DVERI,SFX_PRIORITY3);

	if(wing1) wing1->door=NULL;
	if(wing2) wing2->door=NULL;
	wing1=NULL;
	wing2=NULL;
   //map->SetGround(GetParent()->X,GetParent()->Y, GetParent()->themeID, FrameCol, FrameRow, "DOOR");
	map->DelItem(this->GetParent()->X, this->GetParent()->Y,true);
   }
}

void MMapItemLockDoor::AfterExit(MGameMap *map, MMapItem *item)
{
}

//---------------------------------------------------------------------------------------

class MMapItemColorWay:public MMapItemDoorTmpl
{
 private:
   MPlayerType keyType;
 public:

   MMapItemColorWay(MMapObject *obj, MPlayerType pkeyType);
   virtual ~MMapItemColorWay();

   MPlayerType getKeyType(void){return keyType;}

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
   void BeforeEnter(MGameMap *map, MMapItem *item); //volana pred vstupem na prvek, vraci jestli vec muze do dveri
   void AfterExit(MGameMap *map, MMapItem *item); //volana po opusteni veci dveri
};

MMapItemColorWay::MMapItemColorWay(MMapObject *obj,MPlayerType pkeyType):MMapItemDoorTmpl(obj,true)
{
 keyType=pkeyType;
}

MMapItemColorWay::~MMapItemColorWay()
{
}

bool MMapItemColorWay::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 return plr&&(plr->typ==keyType)&&!doorlocked;
}

void MMapItemColorWay::BeforeEnter(MGameMap *map, MMapItem *item)
{
 MPlayer *plr=dynamic_cast<MPlayer *>(item);
 if(plr&&plr->typ==keyType&&map)
   {
	doorlocked=false;
	FrameCol++;
	map->DoorStateChanged(this);
	PlaySfx(SFX_MODRY_BLESK,SFX_PRIORITY2);
   }
}

void MMapItemColorWay::AfterExit(MGameMap *map, MMapItem *item)
{
 MPlayer *plr=dynamic_cast<MPlayer *>(item);
 if(plr&&plr->typ==keyType&&map)
   {
	doorlocked=true;
	FrameCol--;
	map->DoorStateChanged(this);
	PlaySfx(SFX_ZAVRENI,SFX_PRIORITY2);
   }
}

//---------------------------------------------------------------------------------------

class MMapItemOnceDoor:public MMapItemDoorTmpl
{
 private:
 public:

   MMapItemOnceDoor(MMapObject *obj, bool locked);
   virtual ~MMapItemOnceDoor();

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);
   void BeforeEnter(MGameMap *map, MMapItem *item); //volana pred vstupem na prvek, vraci jestli vec muze do dveri
   void AfterExit(MGameMap *map, MMapItem *item); //volana po opusteni veci dveri
};

MMapItemOnceDoor::MMapItemOnceDoor(MMapObject *obj,bool locked):MMapItemDoorTmpl(obj,locked)
{
}

MMapItemOnceDoor::~MMapItemOnceDoor()
{
}

bool MMapItemOnceDoor::CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)
{
 if(!map||!item||!GetParent()) return false;
 MPlayer *plr=dynamic_cast<MPlayer*>(item);
 return plr&&!doorlocked;
}

void MMapItemOnceDoor::BeforeEnter(MGameMap *map, MMapItem *item)
{
}

void MMapItemOnceDoor::AfterExit(MGameMap *map, MMapItem *item)
{
 if(doorlocked) return;
 MPlayer *plr=dynamic_cast<MPlayer *>(item);
 if(plr&&map)
   {
	doorlocked=true;
	FrameCol--;
	if(wing1) wing1->FrameCol++;
	if(wing2) wing2->FrameCol++;
	map->DoorStateChanged(this);
	PlaySfx(SFX_ZAVRENI,SFX_PRIORITY2);
   }
}

//---------------------------------------------------------------------------------------

MGameMap::MGameMap()
{
 objects=NULL;
 ActPlayer=NULL;
 mapSize.cx=0; mapSize.cy=0;
 mapOffset.x=0; mapOffset.y=40;
 themeID=1;
 animbuff=new MBitmap;
 if(animbuff) animbuff->Create(MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT);
 beract=NULL;
 steps=0;
 levelDone=false;
 krokuText=NULL;
 delItemUpdatesScreen=false;
}

MGameMap::~MGameMap()
{
 Clear();
 if(animbuff) delete animbuff; animbuff=NULL;
}

void MGameMap::PlayerAnimsChanged(void)
{
 SetAnimTimerEnabled(ANIM_TIMER1,!playeranims.empty());
}

void MGameMap::ItemAnimsChanged(void)
{
 SetAnimTimerEnabled(ANIM_TIMER2,!itemanims.empty());
}

bool MGameMap::HavePlayerAnims(void)
{
 return !playeranims.empty();
}

bool MGameMap::Create(int szx, int szy,myPOINT offset, UINT mapThemeID)
{
 Clear();
 mapSize.cx=szx; mapSize.cy=szy;
 mapOffset.x=offset.x; mapOffset.y=offset.y;
 objects=new MMapObject[mapSize.cx*mapSize.cy];
 if(!objects) return false;
 themeID=mapThemeID;

 beract=new MBitmap;
 if(!LoadThemeBitmap(themeID,beract,"BERACT",true)&&beract) 
   {
    if(!LoadThemeBitmap(UINT(-1),beract,"BERACT",true))
	  {
       delete beract;
	   beract=NULL;
	  }
   }
 krokuText=LoadText("GAME",2,1,true,false);
 ChangeBackgroundTheme(mapThemeID,true);

 return true;
}

void MGameMap::ChangeBackgroundTheme(UINT newThemeID, bool initobjs)
{
 if(!objects/*||newThemeID==themeID*/) return;
 themeID=newThemeID;
 MBitmap back;
 myRECT vysek,rr={0,0,MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT};
 LoadThemeBitmap(themeID,&back,"BACKGROUND",false);
 const char *file=NULL;

 for(int x=0;x<mapSize.cx;x++)
   {
    for(int y=0;y<mapSize.cy;y++)
	  {
	   MMapObject *obj=GetObject(x,y);
	   if(obj)
	     {
		  if(initobjs)
		    {
		     obj->SetMap(this);
	         obj->X=x; obj->Y=y;
	         obj->rect.left=mapOffset.x+x*MAP_OBJ_WIDTH; obj->rect.top=mapOffset.y+y*MAP_OBJ_HEIGHT;
	         obj->rect.right=mapOffset.x+(x+1)*MAP_OBJ_WIDTH; obj->rect.bottom=mapOffset.y+(y+1)*MAP_OBJ_HEIGHT;
			}
	      if(obj->bmp)
	        {
		     vysek.left=obj->rect.left-mapOffset.x; vysek.top=obj->rect.top-mapOffset.y;
		     vysek.right=obj->rect.right-mapOffset.x; vysek.bottom=obj->rect.bottom-mapOffset.y;
		     MyHDC dc=obj->bmp->BeginPaint();
		     if(!back.Draw(dc,&rr,&vysek))
		       {
			    DrawRect(&back);
			   }
			 if(obj->themeID!=UINT(-1))
			   {
			    if(obj->file) file=obj->file; else file="GROUND";
				MAnimationBitmap *bitmap=FindItemsBitmap(obj->themeID,file);
				if(bitmap)
			      {
				   bitmap->DrawFrame(obj->bmp,obj->frameCol,NULL,obj->frameRow);
				  }
			   }
		     obj->bmp->EndPaint();
			}
		 }
	  }
   }
}

UINT MGameMap::GetBackgroundTheme(void){ return themeID;}

void MGameMap::Clear(void)
{
 playeranims.clear();
 itemanims.clear();
 PlayerAnimsChanged();
 ItemAnimsChanged();

 while(!players.empty())
   {
    ActPlayer=players[0];
	players.erase(players.begin());
	if(ActPlayer) delete ActPlayer;
   }
 ActPlayer=NULL;
 ClearItemsBitmaps();
 if(objects) delete [] objects;
 objects=NULL;
 mapSize.cx=0; mapSize.cy=0;
 mapOffset.x=0; mapOffset.y=40;
 if(beract) delete beract; beract=NULL;

 haveExitKeys=0;
 steps=0;
 levelDone=false;
 if(krokuText) free(krokuText); krokuText=NULL;
}

MAnimationBitmap *MGameMap::FindItemsBitmap(UINT themeID, const char *file)
{
 if(!file) return NULL;
 MItemBitmaps ib;
 for(UINT i=0;i<items.size();i++)
   {
    ib=items[i];
    if(ib.themeID==themeID&&stricmp(ib.file,file)==0)
	  {
	   return ib.bmp;
	  }
   }
 ib.themeID=themeID;
 ib.bmp=new MAnimationBitmap;
 if(!ib.bmp) return NULL;
 if(!LoadThemeBitmap(themeID,&(ib.bmp->Bitmap),file,true))
   {
    if(ib.bmp) delete ib.bmp;
	return NULL;
   }
 ib.file=strdup(file);
 if(!ib.file)
   {
    delete ib.bmp;
	return NULL;
   }
 ib.bmp->frameOffset.x=0;
 ib.bmp->frameOffset.y=0;
 ib.bmp->frameSize.cx=MAP_OBJ_WIDTH;
 ib.bmp->frameSize.cy=MAP_OBJ_HEIGHT;
 items.push_back(ib);
 return ib.bmp;
}

MPlayer *MGameMap::FindPlayer(MPlayerType pt)
{
 MPlayer *p;
 for(UINT i=0;i<players.size();i++)
   {
    p=players[i];
	if(p&&p->typ==pt) return p;
   }
 return NULL;
}

void MGameMap::SortPlayers(void)
{
 MPlayer *p;
 MPlayerType pt=ptAll;
 UINT i=0;
 while(i<players.size())
   {
    p=players[i];
	if(p)
	  {
	   if(p->typ<pt&&i>0)
	     {
		  players[i]=players[i-1];
		  players[i-1]=p;
		  i=(UINT)-1;
		 }
		else
		 {
		  pt=p->typ;
		 }
	  }
	i++;
   }
}

void MGameMap::ClearItemsBitmaps(void)
{
 MItemBitmaps ib;
 while(!items.empty())
   {
    ib=items[0]; items.erase(items.begin());

	if(ib.bmp) delete ib.bmp;
	if(ib.file) free(ib.file);
   }
}

MMapObject *MGameMap::GetObject(int x, int y)
{
 if(!objects||x<0||x>=mapSize.cx||y<0||y>=mapSize.cy) return NULL;
 return &(objects[x+mapSize.cx*y]);
}
   
bool MGameMap::AddPlayer(int x, int y, MPlayerType plr,MPlayerRotation prot)
{
 MPlayer *p=new MPlayer(NULL);
 if(!p) return false;
 char fl[50];
 sprintf(fl,"HRAC%d",int(plr));
 //if(!LoadThemeBitmap(themeID,&(p->bmp->Bitmap),fl,true))
 if(!InitItem(p,x,y,themeID,fl,0,0))
   {
    delete p;
	return false;
   }
 UINT i=0;
 while(i<players.size())
   {
    if(players[i]&&players[i]->typ==plr)
	  {
	   int px,py;
	   px=players[i]->X; py=players[i]->Y;
	   delete players[i];
	   players.erase(players.begin()+i);
	   MMapObject *o=GetObject(px,py);
	   if(o)
	     {
		  o->playerHere=false;
		  if(delItemUpdatesScreen) DrawObject(px,py);
		 }
	   break;
	  }
	i++;
   }
 players.push_back(p);
 if(!ActPlayer) ActPlayer=p;
 p->typ=plr;
 p->Rotation=prot;
 p->X=x;
 p->Y=y;
 MMapObject *obj=GetObject(x,y);
 if(obj) obj->playerHere=true;
 /*p->bmp->frameOffset.x=0; p->bmp->frameOffset.y=0;
 p->bmp->frameSize.cx=MAP_OBJ_WIDTH; p->bmp->frameSize.cy=MAP_OBJ_HEIGHT;*/
 return true;
}

MPlayer *MGameMap::GetPlayer(MPlayerType plr)
{
 MPlayer *p;
 for(UINT i=0;i<players.size();i++)
   {
    p=players[i];
	if(p&&p->typ==plr) return p;
   }
 return NULL;
}

void MGameMap::DelPlayerAt(int x,int y)
{
 MMapObject *obj=GetObject(x,y);
 if(!obj||!obj->playerHere) return;
 bool nastav=false;
 for(UINT i=0;i<players.size();i++)
   {
	if(players[i]&&players[i]->X==x&&players[i]->Y==y)
	  {
	   nastav=(ActPlayer==players[i]);
	   delete players[i];
	   players.erase(players.begin()+i);
	   obj->playerHere=false;
	   break;
	  }
   }
 if(nastav)
   {
    if(players.size()>0) ActPlayer=players[0];
     else ActPlayer=NULL;
   }
}


bool MGameMap::CanGoOn(MMapItem *item, int px, int py)
{
 MMapObject *obj=GetObject(px,py);
 return obj&&obj->CanGoOn(item,0,0);
 //return px>=0&&px<mapSize.cx&&py>=0&&py<mapSize.cy;
}

bool MGameMap::InitItem(MMapItem *item, int x, int y, UINT themeID, const char *file, int frameCol, int frameRow, int rot)
{
 if(!item||!file) return false;
 MMapObject *obj=GetObject(x,y);
 if(!obj) return false;
 item->themeID=themeID;
 item->bitmap=FindItemsBitmap(themeID,file);
 if(!item->bitmap)
   {
	return false;
   }
 if(!item->bitmap->HaveFrame(frameCol)) frameCol=0;
 if(!item->bitmap->HaveFrame(frameCol,frameRow)) frameRow=0;
 item->FrameCol=frameCol;
 item->FrameRow=frameRow;
 if(obj->item)
   {
    if((!(dynamic_cast<MPlayer *>(item))) )
	  {
       DelItem(x,y,delItemUpdatesScreen);
      }
	 else
	  {
	   MMapItemDoorTmpl *door=dynamic_cast<MMapItemDoorTmpl*>(obj->item);
	   if(door)
	     {
		  door->setDoorLocked(false);
		 }
		else
		 {
		  DelItem(x,y,delItemUpdatesScreen);
		 }
	  }
   }
  else
   {
    if(obj->playerHere) DelPlayerAt(x,y);
   }
 if(!(dynamic_cast<MPlayer *>(item))) obj->item=item;
 return true;
}

void MGameMap::DelItem(int x,int y,bool updateScreen)
{
 MMapObject *obj=GetObject(x,y);
 if(!obj||!obj->item) return;
 MMapItemDoorWing *wing=dynamic_cast<MMapItemDoorWing *>(obj->item);
 if(wing&&wing->door&&wing->door->GetParent())
   {
    obj=wing->door->GetParent();
    DelItem(obj->X,obj->Y,updateScreen);
   }
  else
   {
    MMapItemDoorTmpl *door=dynamic_cast<MMapItemDoorTmpl *>(obj->item);
	if(door)
	  {
	   if(door->wing1)
	     {
		  obj=door->wing1->GetParent();
		  if(obj&&obj->item) { delete obj->item; obj->item=NULL;if(updateScreen) DrawObjectWithPlayer(obj->X,obj->Y);}
		 }
	   if(door->wing2)
	     {
		  obj=door->wing2->GetParent();
		  if(obj&&obj->item) { delete obj->item; obj->item=NULL;if(updateScreen) DrawObjectWithPlayer(obj->X,obj->Y);}
		 }
	   obj=GetObject(x,y);
	   if(obj&&obj->item) {delete obj->item; obj->item=NULL; if(updateScreen) DrawObjectWithPlayer(obj->X,obj->Y);}
	  }
	 else
	  {
       delete obj->item;
       obj->item=NULL;
	   if(updateScreen) DrawObjectWithPlayer(obj->X,obj->Y);
	  }
   }
}

bool MGameMap::AddItemWall(int x, int y, UINT themeID, int frameCol, int frameRow, const char *file, int rot)
{
 MMapItemWall *o=new MMapItemWall(GetObject(x,y),0,file);
 if(!file||!file[0]) file="WALL";
 if(!InitItem(o,x,y,themeID,file,frameCol,frameRow))
   {
    if(o) delete o;
	return false;
   }
 /*MMapObject *obj=GetObject(x,y);
 if(o->bitmap!=NULL&&obj&&obj->bmp)
   {
    MBitmap bmp;
	if(bmp.Create(MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT))
	  {
	   myRECT r={0,0,MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT};
	   o->DrawAt(&bmp,&r);
	   if(rot!=0)
	     {
		  bmp.RotateBitmap(false,rot);
		 }
	   bmp.Draw(obj->bmp->BeginPaint(),&r);
	   obj->bmp->EndPaint();
	   o->bitmap=NULL;
	  }
   }*/
 return true;
}

bool MGameMap::AddItemBox(int x, int y, UINT themeID, int frameCol, int frameRow)
{
 MMapItemBox *o=new MMapItemBox(GetObject(x,y));
 if(!InitItem(o,x,y,themeID,"BOXES",frameCol,frameRow))
   {
    if(o) delete o;
	return false;
   }
 return true;
}

bool MGameMap::AddItemTNT(int x, int y, UINT themeID, int frameCol, int frameRow)
{
 MMapItemTNT *o=new MMapItemTNT(GetObject(x,y));
 if(!InitItem(o,x,y,themeID,"TNT",frameCol,frameRow))
   {
    if(o) delete o;
	return false;
   }
 return true;
}

bool MGameMap::AddItemExitKey(int x, int y, UINT themeID, int frameCol, int frameRow)
{
 MMapItemExitKey *o=new MMapItemExitKey(GetObject(x,y));
 if(!InitItem(o,x,y,themeID,"KEYS",frameCol,frameRow))
   {
    if(o) delete o;
	return false;
   }
 return true;
}

bool MGameMap::AddItemExit(int x, int y, UINT themeID, int frameCol, int frameRow)
{
 MMapItemExit *o=new MMapItemExit(GetObject(x,y));
 if(!InitItem(o,x,y,themeID,"EXIT",frameCol,frameRow))
   {
    if(o) delete o;
	return false;
   }
 return true;
}

bool MGameMap::AddItemStone(int x, int y, UINT themeID, int frameCol, int frameRow)
{
 MMapItemStone *o=new MMapItemStone(GetObject(x,y));
 if(!InitItem(o,x,y,themeID,"STONE",frameCol,frameRow))
   {
    if(o) delete o;
	return false;
   }
 return true;
}

bool MGameMap::AddItemTool(int x, int y, UINT themeID, int frameCol, int frameRow)
{
 MMapItemTool *o=new MMapItemTool(GetObject(x,y));
 if(!InitItem(o,x,y,themeID,"TOOL",frameCol,frameRow))
   {
    if(o) delete o;
	return false;
   }
 return true;
}

bool MGameMap::AddItemColorKey(int x, int y, MPlayerType keyType, UINT themeID)
{
 MMapItemColorKey *o=new MMapItemColorKey(GetObject(x,y),keyType);
 if(!InitItem(o,x,y,themeID,"KEYS",int(keyType),0))
   {
    if(o) delete o;
	return false;
   }
 return true;
}

bool MGameMap::AddItemLockDoor(int x, int y, MPlayerType keyType, bool doorlocked, bool horz, UINT themeID)
{
 MMapItemLockDoor *door=new MMapItemLockDoor(GetObject(x,y),keyType,doorlocked);
 int mx=0,my=0; if(horz) mx=1; else my=1;
 MMapItemDoorWing *w1=new MMapItemDoorWing(GetObject(x-mx,y-my),door);
 MMapItemDoorWing *w2=new MMapItemDoorWing(GetObject(x+mx,y+my),door);

 if(!InitItem(w1  ,x-mx,y-my,themeID,"DOORKEY",int(keyType)-1,(doorlocked?0:1)+(horz?0:4))||
    !InitItem(door,x   ,y   ,themeID,"DOOR",(doorlocked?0:1),horz?0:1)||
	!InitItem(w2  ,x+mx,y+my,themeID,"DOORKEY",int(keyType)-1,2+(doorlocked?0:1)+(horz?0:4))
   )
   {
    if(door) delete door;
	if(w1) delete w1;
	if(w2) delete w2;
	return false;
   }
 door->wing1=w1;
 door->wing2=w2;
 if(themeID==2)
   {
    MMapObject *obj=GetObject(x,y);
	if(obj)
	  {
	   MItemAnimation ai;
	   ai.x=x; ai.y=y;
	   ai.bmp=door->bitmap;
	   ai.item=door;
	   if(ai.bmp) ai.bmp->Initialize(&(obj->rect));
	   itemanims.push_back(ai);
	   ItemAnimsChanged();
	  }
   }
 return true;
}

bool MGameMap::AddItemColorWay(int x, int y, MPlayerType keyType, bool horz, UINT themeID)
{
 MMapItemColorWay *door=new MMapItemColorWay(GetObject(x,y),keyType);
 int mx=0,my=0; if(horz) mx=1; else my=1;
 MMapItemDoorWing *w1=new MMapItemDoorWing(GetObject(x-mx,y-my),door);
 MMapItemDoorWing *w2=new MMapItemDoorWing(GetObject(x+mx,y+my),door);

 if(!InitItem(w1  ,x-mx,y-my,themeID,"DOORCOLS",int(keyType)-1,  (horz?2:0))||
    !InitItem(door,x   ,y   ,themeID,"DOOR", 0,horz?0:1)||
	!InitItem(w2  ,x+mx,y+my,themeID,"DOORCOLS",int(keyType)-1,1+(horz?2:0))
   )
   {
    if(door) delete door;
	if(w1) delete w1;
	if(w2) delete w2;
	return false;
   }
 door->wing1=w1;
 door->wing2=w2;
 if(themeID==2)
   {
    MMapObject *obj=GetObject(x,y);
	if(obj)
	  {
	   MItemAnimation ai;
	   ai.x=x; ai.y=y;
	   ai.bmp=door->bitmap;
	   ai.item=door;
	   if(ai.bmp) ai.bmp->Initialize(&(obj->rect));
	   itemanims.push_back(ai);
	   ItemAnimsChanged();
	  }
   }
 return true;
}

bool MGameMap::AddItemOnceDoor(int x, int y, bool doorlocked, bool horz, UINT themeID)
{
 MMapItemOnceDoor *door=new MMapItemOnceDoor(GetObject(x,y),doorlocked);
 int mx=0,my=0; if(horz) mx=1; else my=1;
 MMapItemDoorWing *w1=new MMapItemDoorWing(GetObject(x-mx,y-my),door);
 MMapItemDoorWing *w2=new MMapItemDoorWing(GetObject(x+mx,y+my),door);

 if(!InitItem(w1  ,x-mx,y-my,themeID,"DOOROT",(doorlocked?1:0),  (horz?0:2))||
    !InitItem(door,x   ,y   ,themeID,"DOOR",(doorlocked?0:1),2+(horz?0:1))||
	!InitItem(w2  ,x+mx,y+my,themeID,"DOOROT",(doorlocked?1:0),1+(horz?0:2))
   )
   {
    if(door) delete door;
	if(w1) delete w1;
	if(w2) delete w2;
	return false;
   }
 door->wing1=w1;
 door->wing2=w2;
 if(themeID==2)
   {
    MMapObject *obj=GetObject(x,y);
	if(obj)
	  {
	   MItemAnimation ai;
	   ai.x=x; ai.y=y;
	   ai.bmp=door->bitmap;
	   ai.item=door;
	   if(ai.bmp) ai.bmp->Initialize(&(obj->rect));
	   itemanims.push_back(ai);
	   ItemAnimsChanged();
	  }
   }
 return true;
}

bool MGameMap::SetGround(int x,int y,UINT themeID, int frameCol, int frameRow, const char *file)
{
 MMapObject *obj=GetObject(x,y);
 if(!obj||!obj->bmp) return false;
 if(!file||!file[0]) file="GROUND";
 MAnimationBitmap *bitmap=FindItemsBitmap(themeID,file);
 if(!bitmap)
   {
    ClearGround(x,y);
	return false;
   }
 if(!bitmap->HaveFrame(frameCol)) frameCol=0;
 if(!bitmap->HaveFrame(frameCol,frameRow)) frameRow=0;
 if(bitmap->DrawFrame(obj->bmp,frameCol,NULL,frameRow))
   {
    obj->themeID=themeID;
    obj->frameCol=frameCol;
	obj->frameRow=frameRow;
    FreePtr(obj->file);
	if(stricmp(file,"GROUND")!=0) obj->file=strdup(file);
	return true;
   }
 obj->themeID=UINT(-1);
 obj->frameCol=-1; obj->frameRow=-1;
 FreePtr(obj->file);
 ClearGround(x,y);
 return false;
}

void MGameMap::ClearGround(int x, int y)
{
 MMapObject *obj=GetObject(x,y);
 if(!obj||!obj->bmp) return;
 obj->themeID=UINT(-1);
 obj->frameCol=-1; obj->frameRow=-1;
 FreePtr(obj->file);
 MBitmap back;
 myRECT vysek,rr={0,0,MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT};
 LoadThemeBitmap(themeID,&back,"BACKGROUND",false);
 vysek.left=obj->rect.left-mapOffset.x; vysek.top=obj->rect.top-mapOffset.y;
 vysek.right=obj->rect.right-mapOffset.x; vysek.bottom=obj->rect.bottom-mapOffset.y;
 MyHDC dc=obj->bmp->BeginPaint();
 if(!back.Draw(dc,&rr,&vysek))
   {
    DrawRect(&back);
   }
 obj->bmp->EndPaint();
}

void MGameMap::BeforePlayerMove(MPlayer *player, int movex, int movey)
{
 if(!player) return;
 MMapObject *obj=GetObject(player->X+movex, player->Y+movey);
 if(!obj) return;
 MMapItemDoorTmpl *ld=dynamic_cast<MMapItemDoorTmpl *>(obj->item);
 if(ld) ld->BeforeEnter(this,player);
}

bool MGameMap::HaveDoorOn(int x, int y)
{
 MMapObject *o=GetObject(x,y);
 if(o&&o->item)
   {
	if(dynamic_cast<MMapItemDoorTmpl*>(o->item)||dynamic_cast<MMapItemDoorWing*>(o->item)) return true;
   }
 return false;
}

void MGameMap::AfterPlayerMove(MPlayer *player, bool canResendKey)
{
 steps++; RedrawStatusText();

 if(!player) 
   {
    ScreenPaint();
    return;
   }
 if(canResendKey&&(player->X!=player->newX||player->Y!=player->newY))
   {
    int mx=player->newX-player->X,my=player->newY-player->Y;
	UINT key=0;
	if(mx==0)
	  {
	   if(my<0) key=KEY_UP;
	    else key=KEY_DOWN;
	  }
	 else
	  {
	   if(mx<0) key=KEY_LEFT;
	    else key=KEY_RIGHT;
	  }
	bool can=IsKeyDown(key);
	if(!can) {key=KEY_UP; can=IsKeyDown(key);}
	if(!can) {key=KEY_DOWN; can=IsKeyDown(key);}
	if(!can) {key=KEY_LEFT; can=IsKeyDown(key);}
	if(!can) {key=KEY_RIGHT; can=IsKeyDown(key);}
	if(can)
	  {
	   SendKeyDown(key);
	  }
   }
 MMapObject *obj=GetObject(player->X,player->Y);
 if(obj)
   {
    MMapItemDoorTmpl *door=dynamic_cast<MMapItemDoorTmpl*>(obj->item);
    if(door) door->AfterExit(this,player);
   }
 player->SetPosition(player->newX,player->newY);

 obj=GetObject(player->X,player->Y);
 if(!obj||!obj->item) return;
 bool needupdate=false;
 if((dynamic_cast<MMapItemExitKey*>(obj->item))&&CanPickExitKey())
   {
    delete obj->item; obj->item=NULL;
	needupdate=true;
	haveExitKeys++;
	RedrawKeys();
	//if(haveExitKeys==5)
	  {
	   OpenExit();
	  }
   }
  else
   {
 if((dynamic_cast<MMapItemTool*>(obj->item))&&(player->haveTool<9))
   {
    delete obj->item; obj->item=NULL;
	player->haveTool++;
	PlayerStateChanged(player);
	needupdate=true;
   }
  else
   {
 if((dynamic_cast<MMapItemColorKey*>(obj->item))&&(!player->haveKey))
   {
    delete obj->item; obj->item=NULL;
	needupdate=true;
	player->haveKey=true;
	PlayerStateChanged(player);
   }

   } }

 if(needupdate) 
   {
    PlaySfx(SFX_SEBRANI,SFX_PRIORITY2);
    DrawPlayer(player->X, player->Y,player);
   }
 ScreenPaint();
}

void MGameMap::OpenExit(void)
{
 if(haveExitKeys!=5) return;

 MMapItemExit *e;
 MMapObject *obj;
 int x,y;
 for(x=0;x<mapSize.cx;x++)
   {
    for(y=0;y<mapSize.cy;y++)
	  {
	   obj=GetObject(x,y);
	   if(obj&&obj->item)
	     {
		  e=dynamic_cast<MMapItemExit*>(obj->item);
		  if(e&&e->bitmap)
		    {
			 if(e->bitmap->HaveFrame(2))
			   {
			    MItemAnimation ai;
				ai.x=x; ai.y=y;
				ai.bmp=e->bitmap;
				ai.item=e;
				if(ai.bmp) ai.bmp->Initialize(&(obj->rect));
				itemanims.push_back(ai);
				ItemAnimsChanged();
			   }
			  else
			   {
			    if(!e->FrameCol) e->FrameCol++;
				DrawObject(x,y);
			   }
			}
		 }
	  }
   }
 PlaySfx(SFX_OTEVRENI_EXITU,SFX_PRIORITY1);
}

void MGameMap::PlayerStateChanged(MPlayer *player)
{
 if(!player) return;
 MAnimationBitmap *ab=FindItemsBitmap(themeID,"INGAME");
 if(!ab) return;
 ab->frameSize.cx=32; ab->frameSize.cy=37;
 MBitmap buff;
 if(!buff.Create(ab->frameSize.cx, ab->frameSize.cy)) return;
 MAnimationBitmap *bermask=FindItemsBitmap(themeID,"BERMASK");
 MPlayerType ptl[]={ptRed, ptGreen, ptBlue, ptYellow, ptMagenta};
 myRECT r;
 r.top=2; r.bottom=r.top+ab->frameSize.cy;
 int frm;
 int i=int(player->typ)-1;
   {
    MPlayer *plr=player;
    r.left=i*100+31; r.right=r.left+ab->frameSize.cx;
	frm=0;
	if(plr&&plr->haveTool>0) frm=2;
	if(ActPlayer&&plr==ActPlayer) frm+=4;
	DrawRect(&buff);
	ab->DrawFrame(&buff,frm,NULL,i);
	ScreenDrawBitmap(&buff,&r);

	r.left+=ab->frameSize.cx; r.right=r.left+ab->frameSize.cx;
	frm=1;
	if(plr&&plr->haveKey) frm=3;
	if(ActPlayer&&plr==ActPlayer) frm+=4;
	DrawRect(&buff);
	ab->DrawFrame(&buff,frm,NULL,i);
	ScreenDrawBitmap(&buff,&r);

	if(plr==NULL&&bermask)
	  {
	   r.left=r.left-ab->frameSize.cx; r.right=r.left+2*ab->frameSize.cx;
	   ScreenDrawBitmap(&(bermask->Bitmap),r.left,r.top);
	  }
   }
 if(player==ActPlayer) RedrawStatusText();
}

void MGameMap::DoorStateChanged(MMapItem *item)
{
 MMapItemDoorTmpl *door=dynamic_cast<MMapItemDoorTmpl *>(item);
 if(door)
   {
    MMapObject *obj=NULL;
	if(door->wing1&&door->wing1->GetParent()) obj=door->wing1->GetParent();
    if(obj){DrawObject(obj->X,obj->Y);} obj=NULL;
    obj=door->GetParent();
    if(obj){DrawObject(obj->X,obj->Y);} obj=NULL;
	if(door->wing2&&door->wing2->GetParent()) obj=door->wing2->GetParent();
    if(obj){DrawObject(obj->X,obj->Y);} obj=NULL;
   }
}

bool MGameMap::CanPickExitKey(void)
{
 return haveExitKeys<5;
}

void MGameMap::ExitPlayer(MMapItem *exititem, MPlayer *player)
{
 if(haveExitKeys==5) 
   {
    levelDone=true;
	PlaySfx(SFX_SAMPL_OK,SFX_PRIORITY1);
   }
}

bool MGameMap::IsLevelDone(void){return levelDone;}
UINT MGameMap::GetSteps(void){return steps;}
void MGameMap::SetSteps(UINT cnt){steps=cnt;}

void MGameMap::DestroyStone(MMapItem *stone, MPlayer *player)
{
 if(!stone||!player) return;
 if(player->haveTool<=0) return;
 MMapObject *obj=stone->GetParent();
 if(!obj) return;
 unsigned char sfxID=SFX_MODRY_KAMEN;
 if(stone->themeID==1) sfxID=SFX_ZELEZNY_KAMEN;
 MItemAnimation ai;
 ai.bmp=stone->bitmap;
 ai.x=obj->X; ai.y=obj->Y;
 ai.item=NULL;
 obj->locked=true;
 if(obj->item) delete obj->item; obj->item=NULL;
 player->haveTool--;
 if(ai.bmp) ai.bmp->Initialize(&(obj->rect));
 itemanims.push_back(ai);
 ItemAnimsChanged();
 PlayerStateChanged(player);
 PlaySfx(sfxID,SFX_PRIORITY1);
}

void MGameMap::DestroyBox(int x, int y)
{
 MMapObject *obj=GetObject(x,y);
 if(!obj) return;
 MAnimationBitmap *ab=FindItemsBitmap(themeID,"VYBUCH");
 PlaySfx(SFX_VYBUCH,SFX_PRIORITY1);
 if(!ab) return;
 obj->locked=true;
 ab->Initialize(&(obj->rect));
 MItemAnimation ai;
 ai.bmp=ab;
 ai.x=x; ai.y=y;
 ai.item=NULL;
 itemanims.push_back(ai);
 ItemAnimsChanged();
}

void MGameMap::DrawObject(int x, int y, MBitmap *des)
{
 MMapObject *obj=GetObject(x,y);
 if(!obj) return;
 MBitmap *pdes=des;
 if(!pdes) pdes=animbuff;
 if(pdes)
   {
    obj->DrawAt(pdes);
	/*if(obj->itemPos>=0&&obj->itemPos<items.size())
	  {
	   MAnimationBitmap *ab=items[obj->itemPos];
	   if(ab)
	     {
		  ab->DrawFrame(pdes,obj->frameCol,NULL,obj->frameRow);
		 }
	  }*/
   }
 if(!des)
   {
	ScreenDrawBitmap(pdes,&(obj->rect));
   }
}

void MGameMap::DrawPlayer(int x, int y, MPlayer *player, MBitmap *des)
{
 if(!player)
   {
    DrawObject(x,y,des);
	return;
   }
 MMapObject *obj=GetObject(x,y);
 if(!obj) return;
 MBitmap *pdes=des;
 if(!pdes) pdes=animbuff;
 if(pdes)
   {
    DrawObject(x,y,pdes);
	player->DrawAt(pdes,0,0);
   }
 if(!des)
   {
	ScreenDrawBitmap(pdes,&(obj->rect));
   }
}

void MGameMap::DrawObjectWithPlayer(int x, int y)
{
 MMapObject *obj=GetObject(x,y);
 if(obj)
   {
    if(obj->playerHere)
	  {
	   MPlayer *p=NULL;
	   for(UINT i=0;i<players.size()&&!p;i++)
	     {
		  if(players[i]&&players[i]->X==x&&players[i]->Y==y)
		    {
			 p=players[i];
			}
		 }
	   DrawPlayer(x,y,p);
	  }
	 else
	  {
	   DrawObject(x,y);
	  }
   }
}


void MGameMap::RedrawKeys(void)
{
 MAnimationBitmap *ab=FindItemsBitmap(themeID,"HAVEKEYS");
 if(!ab) return;
 ab->frameSize.cx=60; ab->frameSize.cy=40;
 MBitmap bmp;
 if(!bmp.Create(60,40)) return;
 DrawRect(&bmp);
 int frm=0;
 if(haveExitKeys>=0&&haveExitKeys<=5) frm+=haveExitKeys;
 ab->DrawFrame(&bmp,frm,NULL,0);
 ScreenDrawBitmap(&bmp,550,0);
}

void MGameMap::DrawTopPanel(void)
{
 MMapObject *obj=GetObject(0,0);
 if(!obj) return;
 mySIZE sz;
 ScreenGetSize(sz);
 myRECT r={0,0,sz.cx,obj->rect.top-1};
 ScreenClearRect(&r);
 MAnimationBitmap *ab=FindItemsBitmap(themeID,"INGAME");
 if(!ab) return;
 ab->frameSize.cx=32; ab->frameSize.cy=37;
 MBitmap buff;
 if(!buff.Create(ab->frameSize.cx, ab->frameSize.cy)) return;
 MAnimationBitmap *bermask=FindItemsBitmap(themeID,"BERMASK");
 MPlayerType ptl[]={ptRed, ptGreen, ptBlue, ptYellow, ptMagenta};
 r.top=2; r.bottom=r.top+ab->frameSize.cy;
 int frm;
 for(int i=0;i<5;i++)
   {
    MPlayer *plr=FindPlayer(ptl[i]);
    r.left=i*100+31; r.right=r.left+ab->frameSize.cx;
	frm=0;
	if(plr&&plr->haveTool>0) frm=2;
	if(ActPlayer&&plr==ActPlayer) frm+=4;
	DrawRect(&buff);
	ab->DrawFrame(&buff,frm,NULL,i);
	ScreenDrawBitmap(&buff,&r);

	r.left+=ab->frameSize.cx; r.right=r.left+ab->frameSize.cx;
	frm=1;
	if(plr&&plr->haveKey) frm=3;
	if(ActPlayer&&plr==ActPlayer) frm+=4;
	DrawRect(&buff);
	ab->DrawFrame(&buff,frm,NULL,i);
	ScreenDrawBitmap(&buff,&r);

	if(plr==NULL&&bermask) 
	  {
	   r.left=r.left-ab->frameSize.cx; r.right=r.left+ab->frameSize.cx*2;
	   ScreenDrawBitmap(&(bermask->Bitmap),&r);
	  }
   }
 RedrawKeys();
}

void MGameMap::DrawMap(void)
{
 if(!objects) return;
 int i,x,y;
 for(x=0;x<mapSize.cx; x++)
   {
    for(y=0;y<mapSize.cy;y++)
      {
	   DrawObject(x,y);
	  }
   }
 MPlayer *plr;
 for(i=0;i<players.size();i++)
   {
    plr=players[i];
	if(plr)
	  {
	   DrawPlayer(plr->X,plr->Y,plr);
	  }
   }
}

void MGameMap::Draw(void)
{
 DrawMap();
 DrawTopPanel();
 if(ActPlayer&&beract)
   {
    MMapObject *obj=GetObject(ActPlayer->X,ActPlayer->Y);
    if(obj)
      {
	   ScreenDrawBitmap(beract,&(obj->rect));
	  }
   }
 RedrawStatusText();
 UpdateTimers();
}

void MGameMap::UpdateTimers(void)
{
 PlayerAnimsChanged();
 ItemAnimsChanged();
}

void MGameMap::ChangePlayer(MPlayer *old)
{
 if(old) 
   {
    PlayerStateChanged(old);
	DrawPlayer(old->X,old->Y,old);
   }
 if(ActPlayer) 
   {
    PlayerStateChanged(ActPlayer);
	if(beract)
	  {
	   MMapObject *obj=GetObject(ActPlayer->X,ActPlayer->Y);
	   if(obj)
	     {
		  ScreenDrawBitmap(beract,&(obj->rect));
		 }
	  }
	PlaySfx(SFX_PREPNI,SFX_PRIORITY2);
   }
}

void MGameMap::FirstPlayer(void)
{
 MPlayer *old=ActPlayer;
 ActPlayer=NULL;
 if(players.size()>0) ActPlayer=players[0];
 ChangePlayer(old);
}

void MGameMap::NextPlayer(void)
{
 if(ActPlayer==NULL) FirstPlayer();
  else
   {
    MPlayer *old=ActPlayer;
    UINT i,j=(UINT)-1;
    for(i=0;i<players.size()&&j==UINT(-1);i++)
	  {
	   if(ActPlayer==players[i]) j=i;
	  }
	if(j==UINT(-1)) FirstPlayer();
	 else
	  {
	   j++;
	   if(j>=players.size()) j=0;
	   if(j<players.size()) ActPlayer=players[j];
	  }
	ChangePlayer(old);
   }
}

void MGameMap::PrevPlayer(void)
{
 if(ActPlayer==NULL) FirstPlayer();
  else
   {
    MPlayer *old=ActPlayer;
    UINT i,j=(UINT)-1;
    for(i=0;i<players.size()&&j==UINT(-1);i++)
	  {
	   if(ActPlayer==players[i]) j=i;
	  }
	if(j==UINT(-1)) FirstPlayer();
	 else
	  {
	   j++;
	   if(j>=players.size()) j=players.size()-1;
	   if(j<players.size()) ActPlayer=players[j];
	  }
    ChangePlayer(old);
   }
}

void MGameMap::SetPlayerNum(int num)
{
 MPlayer *old=ActPlayer;
 if(num>=0&&num<players.size()) ActPlayer=players[num];
 ChangePlayer(old);
}

void MGameMap::SetPlayer(MPlayerType plr)
{
 MPlayer *p,*old=ActPlayer;
 for(UINT i=0;i<players.size();i++)
   {
    p=players[i];
	if(p&&p->typ==plr)
	  {
	   ActPlayer=p;
       ChangePlayer(old);
	   return;
	  }
   }
 if(int(plr)<5) SetPlayer(MPlayerType(int(plr)+1));
  else SetPlayerNum(0);
}

void MGameMap::MovePlayer(MPlayerRotation where, bool quickMove)
{
 if(!ActPlayer||ActPlayer->animated||ActPlayer->out) return;
 int mx=0, my=0;
 switch(where)
   {
    case prUp: my=-1; break;
	case prDown: my=+1; break;
	case prLeft: mx=-1; break;
	case prRight: mx=+1; break;
   }
 BeforePlayerMove(ActPlayer,mx,my);
 MMapObject *obj=GetObject(ActPlayer->X+mx,ActPlayer->Y+my);
 if(/*ActPlayer->X+mx>=0&&ActPlayer->X+mx<mapSize.cx&&
    ActPlayer->Y+my>=0&&ActPlayer->Y+my<mapSize.cy*/
	obj&&obj->CanGoOn(ActPlayer,mx,my))
   {
    unsigned char sfxID=SFX_KROKY_POZADI;
	bool sfxPosuv=false;

    ActPlayer->Rotation=where;
	//if(!quickMove)
	  {
	   ActPlayer->animated=true;
	   myRECT at,to;
	   obj=GetObject(ActPlayer->X,ActPlayer->Y); 
	   if(obj)
	     {
		  obj->playerHere=false;
		  obj->locked=true;
	      at=obj->rect;
		  obj=GetObject(ActPlayer->X+mx,ActPlayer->Y+my);
		  if(obj)
		    {
		     if(obj->themeID!=UINT(-1)) //je tam nastavenej ground
		       {
			    if(obj->themeID==1) sfxID=SFX_KROKY_BLATO;
			     else sfxID=SFX_KROKY_MRAMOR;
			   }
			 obj->locked=true;
			 obj->playerHere=true;
			 to=obj->rect;
			 ActPlayer->bitmap->frameOffset.y=where*ActPlayer->bitmap->frameSize.cy;
		     ActPlayer->bitmap->Initialize(&at,&to);
			 MPlayerAnim anm;
			 if(obj->item&&dynamic_cast<MMapItemBox *>(obj->item))
			   {
			    sfxPosuv=true;
			    anm.item=obj->item;
				obj->item=NULL;
				MMapObject *obj2=GetObject(ActPlayer->X+(2*mx),ActPlayer->Y+(2*my));
				if(obj2) 
				  {
				   if(dynamic_cast<MMapItemBox *>(obj2->item)&&(
				      (dynamic_cast<MMapItemTNT*>(anm.item)&&(!dynamic_cast<MMapItemTNT*>(obj2->item)))
					  ))
				     {
					  obj2->locked=true;
				  	  DestroyBox(obj2->X,obj2->Y);
					  delete obj2->item; obj2->item=NULL;
					  delete anm.item;  anm.item=NULL;
					 }
				  }
			   }
			  else anm.item=NULL;
			 anm.quickMove=quickMove;
			 anm.item_mvx=mx;
			 anm.item_mvy=my;
			 anm.Player=ActPlayer;
			 if(quickMove){
			 	ActPlayer->bitmap->Next();
			 }
			 playeranims.push_back(anm);
			 ActPlayer->newX=ActPlayer->X+mx;
			 ActPlayer->newY=ActPlayer->Y+my;
			 PlayerAnimsChanged();
			}
		   else
		    {
			 obj=GetObject(ActPlayer->X,ActPlayer->Y);
			 obj->locked=false;
			 obj->playerHere=true;
			}
		 }
	  }
	 /*else
	  {
	   obj=GetObject(ActPlayer->X+mx,ActPlayer->Y+my);
	   if(obj)
	     {
		  if(obj->themeID!=UINT(-1)) //je tam nastavenej ground
		    {
			 if(obj->themeID==1) sfxID=SFX_KROKY_BLATO;
			  else sfxID=SFX_KROKY_MRAMOR;
			}
		 }
	   if(obj&&obj->item&&obj->item&&dynamic_cast<MMapItemBox *>(obj->item))
	     {
		  sfxPosuv=true;
		  MMapObject *obj2=GetObject(ActPlayer->X+2*mx,ActPlayer->Y+2*my);
		  if(obj2&&dynamic_cast<MMapItemBox *>(obj2->item)&&(
		      ((!dynamic_cast<MMapItemTNT *>(obj2->item))&&dynamic_cast<MMapItemTNT*>(obj->item))
			  ))
		    {
			 obj2->locked=true;
			 DestroyBox(obj2->X,obj2->Y);
			 delete obj2->item; obj2->item=NULL;
			 delete obj->item;  obj->item=NULL;
			}
		   else
		    {
			 if(obj2)
			   {
			    if(obj2->item) delete obj2->item; 
				obj2->item=obj->item; 
				obj->item=NULL;
				obj2->item->SetParent(obj2);
				obj2->locked=false;
				DrawObject(obj2->X,obj2->Y);
			   }
			}
		 }
	   DrawPlayer(ActPlayer->X,ActPlayer->Y,NULL);
	   obj=GetObject(ActPlayer->X, ActPlayer->Y);
	   if(obj) obj->playerHere=false;
	   ActPlayer->newX=ActPlayer->X+mx;
	   ActPlayer->newY=ActPlayer->Y+my;
       //ActPlayer->SetPosition(ActPlayer->X+mx,ActPlayer->Y+my);
	   DrawPlayer(ActPlayer->newX,ActPlayer->newY,ActPlayer);
	   obj=GetObject(ActPlayer->newX, ActPlayer->newY);
	   if(obj) obj->playerHere=true;
	   AfterPlayerMove(ActPlayer,false);
	  }*/
	PlaySfx(sfxID,SFX_PRIORITY3);
	if(sfxPosuv) PlaySfx(SFX_POSUN,SFX_PRIORITY2);
   }
  else
   {
    ActPlayer->Rotation=where;
	DrawPlayer(ActPlayer->X,ActPlayer->Y,ActPlayer);
	if(!levelDone) PlaySfx(SFX_NARAZ,SFX_PRIORITY3);
   }
}

void MGameMap::OnAnimTimer(UINT timerID)
{
 UINT i;
 switch(timerID)
   {
    case ANIM_TIMER1:
	  {
	   MPlayer *p;
	   MPlayerAnim anm;
	   for(i=0;i<playeranims.size();i++)
	     {
		  anm=playeranims[i];
		  p=playeranims[i].Player;
		  if(p&&p->bitmap)
		    {
			 if(p->bitmap->Done()) 
			   {
			    playeranims.erase(playeranims.begin()+i);
				i--;
				p->animated=false;
				if(anm.item)
				  {
				   MMapObject *obj2=GetObject(p->X+(2*anm.item_mvx),p->Y+(2*anm.item_mvy));
				   if(obj2)
				     {
					  /*if(dynamic_cast<MMapItemBox *>(obj2->item)&&dynamic_cast<MMapItemTNT*>(anm.item))
					    {
						 DestroyBox(p->X+(2*anm.item_mvx),p->Y+(2*anm.item_mvy));
						 delete obj2->item; obj2->item=NULL;
						 delete anm.item; anm.item=NULL;
						}
					   else*/
					    {
					     if(obj2->item) delete obj2->item;
					     obj2->item=anm.item;
					     obj2->item->SetParent(obj2);
					     obj2->locked=false;
						}
					  DrawObject(p->X+(2*anm.item_mvx),p->Y+(2*anm.item_mvy));
					 }
					else
					 {
					  delete anm.item;
					 }
				  }
				MMapObject *obj=GetObject(p->X,p->Y);
				if(obj) 
				  {
				   obj->locked=false;
				   obj->playerHere=false;
				  }
				DrawPlayer(p->X,p->Y,NULL);
				//p->SetPosition(p->newX,p->newY);
				DrawPlayer(p->newX,p->newY,p);
				obj=GetObject(p->newX,p->newY);
				if(obj) 
				  {
				   obj->locked=false;
				   obj->playerHere=true;
				  }
				PlayerAnimsChanged();
				AfterPlayerMove(p,true);
			   }
			  else
			   {
			    if(animbuff)
				  {
				   MMapObject *o;
				   o=GetObject(p->X,p->Y);
				   if(o) 
				     {
					  o->DrawAt(animbuff);
				      p->bitmap->DrawFrame(animbuff,o->rect.left,o->rect.top);
					  ScreenDrawBitmap(animbuff,&(o->rect));
					 }
				   o=GetObject(p->newX,p->newY);
				   if(o)
				     {
					  o->DrawAt(animbuff);
					  if(anm.item)
					    {
						 myRECT r;
						 r.left=p->bitmap->DrawAt.left-o->rect.left+(MAP_OBJ_WIDTH*anm.item_mvx);
						 r.top=p->bitmap->DrawAt.top-o->rect.top+(MAP_OBJ_HEIGHT*anm.item_mvy);
						 r.right=r.left+MAP_OBJ_WIDTH;
						 r.bottom=r.top+MAP_OBJ_HEIGHT;
						 anm.item->DrawAt(animbuff, &r);
						}
				      p->bitmap->DrawFrame(animbuff,o->rect.left,o->rect.top);
					  ScreenDrawBitmap(animbuff,&(o->rect));
					 }
				   if(anm.item)
					 {
					  o=GetObject(p->newX+anm.item_mvx,p->newY+anm.item_mvy);
					  if(o)
					    {
						 o->DrawAt(animbuff);
					     myRECT r;
					     r.left=p->bitmap->DrawAt.left-o->rect.left+(MAP_OBJ_WIDTH*anm.item_mvx);
						 r.top=p->bitmap->DrawAt.top-o->rect.top+(MAP_OBJ_HEIGHT*anm.item_mvy);
						 r.right=r.left+MAP_OBJ_WIDTH;
						 r.bottom=r.top+MAP_OBJ_HEIGHT;
						 anm.item->DrawAt(animbuff, &r);
					     ScreenDrawBitmap(animbuff,&(o->rect));
						}
					 }
				  }
				p->bitmap->Next();
				if(anm.quickMove){
					//p->bitmap->Next();
					p->bitmap->Next();
				}
			   }
			}
		 }
	  }
	  break;
	case ANIM_TIMER2:
	  {
	   MAnimationBitmap *ab;
	   MItemAnimation ia;
	   for(UINT i=0;i<itemanims.size();i++)
	     {
		  ia=itemanims[i];
		  if(ia.item)
		    {
			 if(animbuff)
			   {
			    MMapObject *o;
			    o=GetObject(ia.x,ia.y);
			    if(o) 
			      {
			 	   o->DrawAt(animbuff);
				   if(ia.item->OnAnimTimer(animbuff)) ScreenDrawBitmap(animbuff,&(o->rect));
				  }
			   }
			}
		   else
		    {
		     ab=ia.bmp;
		     if(ab)
		       {
			    if(ab->Done())
			      {
			       itemanims.erase(itemanims.begin()+i);
				   i--;
				   MMapObject *obj=GetObject(ia.x,ia.y);
			       if(obj) 
				     {
				      obj->locked=false;
				      if(obj->item)
				        {
					     delete obj->item;
					     obj->item=NULL;
					    }
				     }
				   DrawObject(ia.x,ia.y);
				   ItemAnimsChanged();
			      }
			     else
			      {
			       if(animbuff)
				     {
				      MMapObject *o;
				      o=GetObject(ia.x,ia.y);
				      if(o) 
				        {
					     o->DrawAt(animbuff);
				         ab->DrawFrame(animbuff,o->rect.left,o->rect.top);
					     ScreenDrawBitmap(animbuff,&(o->rect));
					    }
				     }
			       ab->Next();
				  }
			   }
			}
		 }
	  }
	  break;
   }
}


void MGameMap::ClearStatusRect(void)
{
 myRECT r={0,460,640,480};
 ScreenClearRect(&r);
}

void MGameMap::DrawStatusText(const char *txt)
{
 ClearStatusRect();
 if(!txt) 
   {
    RedrawStatusText();
    return;
   }
 PrintText(10,460,txt);
}

void MGameMap::RedrawStatusText(void)
{
 ClearStatusRect();
 PrintTextFmt(10,460,"%s %d",(krokuText?krokuText:""),steps);
 if(ActPlayer)
   {
    if(animbuff&&ActPlayer->haveTool)
	  {
       MAnimationBitmap *abmp=FindItemsBitmap(themeID,"TOOL");
	   if(abmp)
	     {
		  myRECT r={640-20,460,640,480};
	      DrawRect(animbuff);
	      abmp->DrawFrame(animbuff,0,NULL,0);
	      for(int i=0;i<ActPlayer->haveTool;i++)
	        {
		     ScreenDrawBitmap(animbuff,&(r));
			 r.left-=20; r.right-=20;
			}
		 }
	  }
   }
}

void MGameMap::GetOffset(myPOINT &off)
{
 off.x=mapOffset.x; off.y=mapOffset.y;
}

//---------------------------------------------------------------------------------------

class MEndEpisode:public MTextScroller
{
 private:
   int hudba;
 public:
   MEndEpisode();
   virtual ~MEndEpisode();

   void Initialize(MResponder *parent, int episode);
   virtual void OnActivate(MResponder *resp);
};

MEndEpisode::MEndEpisode()
{
 hudba=0;
}

MEndEpisode::~MEndEpisode()
{
}

void MEndEpisode::Initialize(MResponder *parent, int episode)
{
 Clear();
 Parent=parent;
 const char *efile=NULL;
 switch(episode)
   {
    case 1: SetBackground("END_003"); efile="EPIZODA1"; hudba=27; break;
    case 2: SetBackground("END_001"); efile="EPIZODA2"; hudba=28; break;
    case 3: SetBackground("END_002"); efile="EPIZODA3"; hudba=27; break;
    case 4: SetBackground("END_000"); efile="EPIZODA4"; hudba=28; break;
    case 5: SetBackground(NULL); efile="EPIZODA5"; hudba=29; break;
   }
 if(!efile) return;
 backoffset.x=0;
 backoffset.y=0;
 mySIZE sz;
 ScreenGetSize(sz);
 MTextScroller::Initialize(NULL,0,0,0,0,sz.cx,sz.cy,efile);
}

void MEndEpisode::OnActivate(MResponder *resp)
{
 MTextScroller::OnActivate(resp);
 hraj_hudbu_outro(hudba);
}


MEndEpisode EndEpisode;

//---------------------------------------------------------------------------------------

MEpisodes::MEpisodes(int pepisoda):MResponder()
{
 episoda=pepisoda;
 switch(episoda)
   {
    case 1:  strcpy(passfile,"S_TREN");  break;
    case 2:  strcpy(passfile,"S_LEHKY"); break;
    case 3:  strcpy(passfile,"S_STRED"); break;
    case 4:  strcpy(passfile,"S_TEZKY"); break;
    case 5:  strcpy(passfile,"S_NEMOZ"); break;
	default: strcpy(passfile,""); break;
   }
 level=1;
 maxlevel=-1;
 Game.Parent=this;
 Game.Map=&Map;
}

MEpisodes::~MEpisodes()
{
}

void MEpisodes::CountMaxLevels(void)
{
 char *pass=LoadText(passfile,0,0,false,false);
 maxlevel=0;
 if(pass) 
   {
    UINT pos=0;
	bool cancnt=true;
	bool nextcomm=true;
    while(pass[pos]!=0)
	  {
	   if(nextcomm)
	     {
		  nextcomm=false;
		  cancnt=pass[pos]!=';';
		 }
	   if(pass[pos]==0x0a&&cancnt) maxlevel++;
	   if(pass[pos]==0x0a) nextcomm=true;
	   pos++;
	  }
    free(pass);
	maxlevel=maxlevel/2;
   }
}

char *MEpisodes::GetPassword(void)
{
 char *pass=LoadText(passfile,0,0,false,false);
 char *res=NULL;
 if(pass)
   {
    UINT pos=0,cnt=0,lookon=level*2-1;
	bool cancnt=true;
	bool nextcomm=true;
    while(pass[pos]!=0)
	  {
	   if(nextcomm)
	     {
		  nextcomm=false;
		  cancnt=pass[pos]!=';';
		 }
	   if(pass[pos]==0x0a&&cancnt)
	     {
		  cnt++;
		  if(cnt==lookon)
		    {
			 char z[6];
			 strncpy(z,pass+pos+1,5);
			 z[5]=0;
			 res=strdup(z);
			 break;
			}
		 }
	   if(pass[pos]==0x0a) 
	     {
		  nextcomm=true;
		 }
	   pos++;
	  }
    free(pass);
   }
 return res;
}

#ifndef FreePtr
#define FreePtr(x) if(x)free(x); (x)=NULL;
#endif

void MEpisodes::BeforeLevel(void)
{
 ScreenClearRect();
 ScreenDrawBitmap("MENU_056",0,0);

 char txt[128];

 char *t1,*t2;
 t1=LoadText("GAME",1,7);
 if(t1&&strlen(t1)<120) sprintf(txt,"#%s %d",(t1?t1:""),level);
  else sprintf(txt,"#%d",level);
 PrintTextAlign(20,100,txt);
 FreePtr(t1);

 t1=LoadText("GAME",1,8);
 t2=GetPassword();
 PrintTextFmt(30,130,"%s %s",(t1?t1:""),(t2?t2:""));
 FreePtr(t1); FreePtr(t2);

 t1=LoadText("GAME",1,1);
 t2=LoadText("GAME",1,episoda+1);
 if(t1&&t2&&strlen(t1)+strlen(t2)<120)sprintf(txt,"$%s %s",(t1?t1:""),(t2?t2:""));
  else
   {
    txt[0]=0;
   }
 PrintTextAlign(30,130,txt);
 FreePtr(t1); FreePtr(t2);

 myPOINT lxy;
 hlavniMenu.left=50;
 hlavniMenu.top=450;
 hlavniMenu.bottom=hlavniMenu.top+20;

 t1=LoadText("GAME",1,9);
 if(PrintText(hlavniMenu.left,hlavniMenu.top,t1,-1,NULL,NULL,NULL,&lxy,NULL))
   {
    hlavniMenu.right=lxy.x;
   }
  else hlavniMenu.right=hlavniMenu.left+120;
 FreePtr(t1);

 startLevelu.left=400;
 startLevelu.top=450;
 startLevelu.bottom=startLevelu.top+20;
 
 t1=LoadText("GAME",1,10);
 if(PrintText(startLevelu.left,startLevelu.top,t1,-1,NULL,NULL,NULL,&lxy,NULL))
   {
    startLevelu.right=lxy.x;
   }
  else startLevelu.right=startLevelu.left+120;
 FreePtr(t1);

 t1=LoadText("TEXTY",episoda,level);
 PrintText(20,180,t1);
 FreePtr(t1);
 
 ScreenPaint();
}

void MEpisodes::Start(void)
{
 StopSfx();
 stop_modul();
 if(maxlevel<0) CountMaxLevels();
 if(maxlevel==0)
   {
	if(Parent) SetMainResponder(Parent->Parent);
	 else SetMainResponder(Parent);
	return;
   }
 if(level>maxlevel)
   {
    level=1;
   }
 BeforeLevel();
 char fl[10];
 const char *ech="RJSTN";
 Map.Clear();
 if(episoda<6&&episoda>0)
   {
    int limity[] = {4*2,4*2,3*2,2*2,2*2,800};
    sprintf(fl,"%c%02d",ech[episoda-1],level);
	if(!Game.Load(fl,limity[episoda-1]))
	  {
	   SetMainResponder(Parent);
	  }
   }
  else
   {
    SetMainResponder(Parent);
   }
}

void MEpisodes::KeyPress(UINT Key,UINT butts)
{
 switch(Key)
   {
    case KEY_ESCAPE:
	  SetMainResponder(Parent);
	  break;
	case KEY_SPACE:
	case KEY_RETURN:
	case KEY_SELECT:
	  SetMainResponder(&Game);
	  break;
   }
}

void MEpisodes::MouseMove(int x, int y, UINT butts)
{
}

void MEpisodes::MouseLeft(int x, int y, UINT butts)
{
 if(x>=startLevelu.left&&x<=startLevelu.right&&y>=startLevelu.top&&y<=startLevelu.bottom) SetMainResponder(&Game);
  else
   {
    if(x>=hlavniMenu.left&&x<=hlavniMenu.right&&y>=hlavniMenu.top&&y<=hlavniMenu.bottom) SetMainResponder(Parent);
   }
}

void MEpisodes::MouseMiddle(int x, int y, UINT butts)
{
}

void MEpisodes::MouseRight(int x, int y, UINT butts)
{
}

void MEpisodes::OnAnimTimer(UINT timerID)
{
}

void MEpisodes::OnActivate(MResponder *resp)
{
 ScreenClearRect();
 /*if(resp==Parent||resp==GetNewGameMenu()) Start();
  else*/
   {
    if(resp==&Game)
	  {
	   if(Game.LevelDone())
	     {
		  stop_modul();
		  level++;
		  if(level>maxlevel)
		    {
			 EndEpisode.Initialize(Parent,episoda);
			 SetMainResponder(&EndEpisode);
			 //SetMainResponder(Parent);
			}
		   else Start();
		 }
		else
		 {
		  SetMainResponder(Parent);
		 }
	  }
	 else
	  {
	   Start();
	   //SetMainResponder(Parent);
	  }
   }
}

void MEpisodes::OnDeactivate(MResponder *resp)
{
 if(resp==Parent||resp==GetMainMenu())
   {
    ScreenClearRect();
	level=1;
	//Game.FreeMenu();
   }
  else
   {
    Map.SetPlayerNum(0);
   }
}

//-----------------------------------------------------------------------------

MGameMapSave::MGameMapSave()
{
 Clear();
}

MGameMapSave::~MGameMapSave()
{
 Clear();
}

void MGameMapSave::Clear(void)
{
 mapSize.cx=0; mapSize.cy=0;
 mapOffset.x=0; mapOffset.y=0;
 ActPlayer=-1;
 haveExitKeys=-1;
 steps=0;
 themeID=UINT(-1);
 Players.clear();
 MGameMapSaveItem itm;
 while(!Items.empty())
   {
    itm=Items[0];
	Items.erase(Items.begin());
	switch(itm.ident)
	  {
	   case iiBackground:
	   case iiWall:
	     FreePtr(itm.file);
	     break;
	  }
   }
}

bool MGameMapSave::Save(MGameMap *srcMap)
{
 if(!srcMap) return false;
 Clear();
 
 mapSize.cx=srcMap->mapSize.cx; mapSize.cy=srcMap->mapSize.cy;
 haveExitKeys=srcMap->haveExitKeys;
 steps=srcMap->steps;
 themeID=srcMap->themeID;
 mapOffset=srcMap->mapOffset;

 MMapObject *obj;
 int x,y;
 for(x=0;x<mapSize.cx;x++)
   {
    for(y=0;y<mapSize.cy;y++)
	  {
	   obj=srcMap->GetObject(x,y);
	   if(obj)
	     {
		  if(obj->themeID!=((UINT)(-1)))
		    {
			 MGameMapSaveItem itm;
			 itm.ident=iiBackground;
			 itm.x=x; itm.y=y; itm.themeID=obj->themeID;
			 itm.frameCol=obj->frameCol;
			 itm.frameRow=obj->frameRow;
			 itm.file=NULL; if(obj->file) itm.file=strdup(obj->file);
			 Items.push_back(itm);
			}
		  if(obj->item)
		    {
			 MMapItem *ii=obj->item;
			 if(dynamic_cast<MMapItemDoorWing *>(ii)){
			 }else
			 if(dynamic_cast<MMapItemWall *>(ii)){
			    MMapItemWall *w=dynamic_cast<MMapItemWall *>(ii);
			    MGameMapSaveItem itm;
			    itm.ident=iiWall;
			    itm.x=x; itm.y=y; itm.themeID=ii->themeID;
			    itm.frameCol=ii->FrameCol;
			    itm.frameRow=ii->FrameRow;
			    itm.file=NULL; if(w->getFile()) itm.file=strdup(w->getFile());
			    Items.push_back(itm);
			 }else
			 if(dynamic_cast<MMapItemTNT *>(ii)||
			    dynamic_cast<MMapItemBox *>(ii)||
			    dynamic_cast<MMapItemExitKey *>(ii)||
			    dynamic_cast<MMapItemExit *>(ii)||
			    dynamic_cast<MMapItemStone *>(ii)||
			    dynamic_cast<MMapItemTool *>(ii)
			   ){
			    MGameMapSaveItem itm;
			    if(dynamic_cast<MMapItemTNT *>(ii)) {itm.ident=iiTNT;} else
				if(dynamic_cast<MMapItemBox *>(ii)) {itm.ident=iiBox;} else
			    if(dynamic_cast<MMapItemExitKey *>(ii)) {itm.ident=iiExitKey;} else
			    if(dynamic_cast<MMapItemExit *>(ii)) {itm.ident=iiExit;} else
			    if(dynamic_cast<MMapItemStone *>(ii)) {itm.ident=iiStone;} else
			    if(dynamic_cast<MMapItemTool *>(ii)) {itm.ident=iiTool;}
			    itm.x=x; itm.y=y; itm.themeID=ii->themeID;
			    itm.frameCol=ii->FrameCol;
			    itm.frameRow=ii->FrameRow;
			    Items.push_back(itm);
			 }else
			 if(dynamic_cast<MMapItemColorKey *>(ii)){
			    MMapItemColorKey *o=dynamic_cast<MMapItemColorKey *>(ii);
			    MGameMapSaveItem itm;
			    itm.ident=iiColorKey;
			    itm.x=x; itm.y=y; itm.themeID=ii->themeID;
				itm.keyType=o->getKeyType();
			    Items.push_back(itm);
			 }else
			 if(dynamic_cast<MMapItemLockDoor *>(ii)){
			    MMapItemLockDoor *o=dynamic_cast<MMapItemLockDoor *>(ii);
			    MGameMapSaveItem itm;
			    itm.ident=iiLockDoor;
			    itm.x=x; itm.y=y; itm.themeID=ii->themeID;
				itm.keyType=o->getKeyType();
				itm.doorlocked=o->getDoorLocked();
				itm.horz=false;
				if(o->wing1&&o->wing1->GetParent())
				  {
				   MMapObject *par=o->wing1->GetParent();
				   itm.horz=par->X!=x;
				  }
			    Items.push_back(itm);
			 }else
			 if(dynamic_cast<MMapItemColorWay *>(ii)){
			    MMapItemColorWay *o=dynamic_cast<MMapItemColorWay *>(ii);
			    MGameMapSaveItem itm;
			    itm.ident=iiColorWay;
			    itm.x=x; itm.y=y; itm.themeID=ii->themeID;
				itm.keyType=o->getKeyType();
				itm.doorlocked=o->getDoorLocked();
				itm.horz=false;
				if(o->wing1&&o->wing1->GetParent())
				  {
				   MMapObject *par=o->wing1->GetParent();
				   itm.horz=par->X!=x;
				  }
			    Items.push_back(itm);
			 }else
			 if(dynamic_cast<MMapItemOnceDoor *>(ii)){
			    MMapItemOnceDoor *o=dynamic_cast<MMapItemOnceDoor *>(ii);
			    MGameMapSaveItem itm;
			    itm.ident=iiOnceDoor;
			    itm.x=x; itm.y=y; itm.themeID=ii->themeID;
				itm.doorlocked=o->getDoorLocked();
				itm.horz=false;
				if(o->wing1&&o->wing1->GetParent())
				  {
				   MMapObject *par=o->wing1->GetParent();
				   itm.horz=par->X!=x;
				  }
			    Items.push_back(itm);
			 }
			}
		 }
	  }
   }
 ActPlayer=-1;
 for(UINT a=0;a<srcMap->players.size();a++)
   {
    MPlayer *plr=srcMap->players[a];
	if(plr==srcMap->ActPlayer) ActPlayer=a;
	if(plr)
	  {
	   MGameMapSavePlayer p;
	   p.X=plr->X; p.Y=plr->Y;
	   p.typ=plr->typ;
	   p.Rotation=plr->Rotation;
       p.haveKey=plr->haveKey;
	   p.haveTool=plr->haveTool;
	   p.out=plr->out;
       Players.push_back(p);
	  }
   }
 if(Items.empty()) WriteToLog("There are no items on the map.");
 if(ActPlayer==-1) WriteToLog("No active player.");
 return !Items.empty()&&ActPlayer!=-1;
}

bool MGameMapSave::Load(MGameMap *desMap)
{
 if(!desMap||Items.empty()||ActPlayer==-1||Players.empty()) return false;
 if(ActPlayer>=Players.size()||ActPlayer<0) return false;
 mapOffset=desMap->mapOffset;
 desMap->Clear();
 if(!desMap->Create(mapSize.cx,mapSize.cy,mapOffset,themeID)) return false;
 UINT i;
 bool res=true;
 for(i=0;i<Items.size()&&res;i++)
   {
    MGameMapSaveItem itm=Items[i];
	switch(itm.ident)
	  {
	   case iiBackground: res=desMap->SetGround(itm.x,itm.y,itm.themeID,itm.frameCol,itm.frameRow,itm.file); break;
	   case iiWall: res=desMap->AddItemWall(itm.x,itm.y,itm.themeID,itm.frameCol,itm.frameRow,itm.file); break;
       case iiBox: res=desMap->AddItemBox(itm.x,itm.y,itm.themeID,itm.frameCol,itm.frameRow); break;
	   case iiTNT: res=desMap->AddItemTNT(itm.x,itm.y,itm.themeID,itm.frameCol,itm.frameRow); break;
	   case iiExitKey: res=desMap->AddItemExitKey(itm.x,itm.y,itm.themeID,itm.frameCol,itm.frameRow); break;
	   case iiExit: res=desMap->AddItemExit(itm.x,itm.y,itm.themeID,itm.frameCol,itm.frameRow); break;
	   case iiStone: res=desMap->AddItemStone(itm.x,itm.y,itm.themeID,itm.frameCol,itm.frameRow); break;
	   case iiTool: res=desMap->AddItemTool(itm.x,itm.y,itm.themeID,itm.frameCol,itm.frameRow); break;
       case iiColorKey: res=desMap->AddItemColorKey(itm.x,itm.y,itm.keyType,itm.themeID); break;
	   case iiLockDoor: res=desMap->AddItemLockDoor(itm.x, itm.y,itm.keyType,itm.doorlocked,itm.horz,itm.themeID); break;
	   case iiColorWay: res=desMap->AddItemColorWay(itm.x,itm.y,itm.keyType,itm.horz,itm.themeID); break;
	   case iiOnceDoor: res=desMap->AddItemOnceDoor(itm.x,itm.y,itm.doorlocked,itm.horz,itm.themeID); break;
	  }
   }
 MPlayerType actTyp=ptAll;
 for(i=0;i<Players.size()&&res;i++)
   {
    MGameMapSavePlayer plr=Players[i];
	res=desMap->AddPlayer(plr.X,plr.Y,plr.typ,plr.Rotation);
	if(res)
	  {
	   MPlayer *p=desMap->GetPlayer(plr.typ);
	   if(p)
	     {
		  p->haveKey=plr.haveKey;
		  p->haveTool=plr.haveTool;
		  p->out=plr.out;
		 }
		else res=false;
	  }
	if(i==ActPlayer) actTyp=plr.typ;
   }
 res=res&&actTyp!=ptAll;
 if(res)
   {
    desMap->SetPlayer(actTyp);
   }
 desMap->haveExitKeys=haveExitKeys;
 desMap->steps=steps;
 return res;
}

void ForceDirectories(const char *pDir);

bool MGameMapSave::SaveToFile(const char *FileName)
{
 if(!FileName) return false;
 if(Items.empty()||ActPlayer==-1||Players.empty())
   {
    if(Items.empty()) WriteToLog("There are no items on the map.");
	if(ActPlayer==-1) WriteToLog("No active player.");
	if(Players.empty()) WriteToLog("No player on the map.");
    return false;
   }
 if(ActPlayer>=Players.size()||ActPlayer<0)
   {
    WriteToLog("Bad active player.");
    return false;
   }
 
 ForceDirectories(FileName);

 FILE *f=fopen(FileName,"wb");
 if(!f)
   {
    WriteToLog("Write to file '%s' failed",FileName);
    return false;
   }
 char buff[30];
 memset(buff,0,30);
 strcpy(buff,AJA_LEVEL_HEADER);
 fwrite(buff,1,30,f);
 
 MGameMapSaveItem si;
 MGameMapSavePlayer sp;
 mDWORD i;
 BYTE bval;
 bval=0; fwrite(&bval,1,1,f); //cislo hudby levelu
 mDWORD dval;
 dval=themeID; fwrite(&dval,1,sizeof(mDWORD),f);
 dval=Items.size(); fwrite(&dval,1,sizeof(mDWORD),f);
 for(i=0;i<dval;i++)
   {
    si=Items[i];
	fwrite(&si,1,sizeof(si),f);
   }
 dval=Players.size(); fwrite(&dval,1,sizeof(mDWORD),f);
 for(i=0;i<dval;i++)
   {
    sp=Players[i];
	fwrite(&sp,1,sizeof(sp),f);
   }
 bval=mapSize.cx; fwrite(&bval,1,1,f); 
 bval=mapSize.cy; fwrite(&bval,1,1,f); 
 bval=mapOffset.x; fwrite(&bval,1,1,f); 
 bval=mapOffset.y; fwrite(&bval,1,1,f); 
 bval=ActPlayer; fwrite(&bval,1,1,f);
 bval=0; fwrite(&bval,1,1,f); //haveExitKeys
 bval=0; fwrite(&bval,1,1,f); //steps
 fclose(f);
 return true;
}

bool MGameMapSave::LoadFromFile(const char *FileName)
{
 if(!FileName) return false;
 char sign[30];
 //FILE *f=fopen(FileName,"rb");
 MFileStream strm;
 if(!strm.open(FileName,foBinRead)) return false;
 //fread(sign,1,30,f);
 strm.read(sign,30);
 bool res=false;
 if(!(strcmp(sign,AJA_LEVEL_HEADER))) res=LoadFromStream(&strm);
 //fclose(f);
 return res;
}

bool MGameMapSave::LoadFromStream(MStream *f)
{
 if(!f) return false;
 Clear();

 bool res=true;
 MGameMapSaveItem si;
 MGameMapSavePlayer sp;
 mDWORD i;
 BYTE bval;
 mDWORD dval;

 if(sizeof(BYTE)!=f->read(&bval,1)) //cislo hudby levelu
   {
    res=false;
   }
 if(res)
   {
    if(sizeof(mDWORD)!=f->read(&dval,sizeof(mDWORD))) res=false;
	 else themeID=dval;
   }
 if(res&&sizeof(mDWORD)!=f->read(&dval,sizeof(mDWORD))) res=false;
 if(res)
   {
    for(i=0;res&&i<dval;i++)
      {
	   if(sizeof(si)!=f->read(&si,sizeof(si))) res=false;
	    else Items.push_back(si);
      }
   }
 if(res&&sizeof(mDWORD)!=f->read(&dval,sizeof(mDWORD))) res=false;
 if(res)
   {
    for(i=0;res&&i<dval;i++)
      {
	   if(sizeof(sp)!=f->read(&sp,sizeof(sp))) res=false;
	    else Players.push_back(sp);
      }
   }
 if(res)
   {
    if(sizeof(BYTE)!=f->read(&bval,1)) res=false;
	 else mapSize.cx=bval;
   }
 if(res)
   {
    if(sizeof(BYTE)!=f->read(&bval,1)) res=false;
	 else mapSize.cy=bval;
   }
 
 if(res)
   {
    if(sizeof(BYTE)!=f->read(&bval,1)) res=false;
	 //else mapOffset.x=bval; //comment at mapOffset.y
   }
 if(res)
   {
    if(sizeof(BYTE)!=f->read(&bval,1)) res=false;
	 //else mapOffset.y=bval; //was a bug, user levels save offset.y 60, not 40; so go away with offset future
   }
 if(res)
   {
    if(sizeof(BYTE)!=f->read(&bval,1)) res=false;
	 else ActPlayer=bval;
   }
 if(res)
   {
    if(sizeof(BYTE)!=f->read(&bval,1)) res=false;
	 else haveExitKeys=bval;
   }
 if(res)
   {
    if(sizeof(BYTE)!=f->read(&bval,1)) res=false;
	 else steps=bval;
   }
 if(res)
   {
    res=steps==0&&haveExitKeys==0&&ActPlayer>=0&&ActPlayer<Players.size()&&Items.size()>0;
   } 
 if(!res) Clear();
 return res;
}

//-----------------------------------------------------------------------------
MGame UserGame;
MGameMap UserGameMap;

bool RunUserLevel(const char *file)
{
 if(!file) return false;
 char pth[1024];
 strcpy(pth,GetUserLevelDir());
 strcat(pth,file);
 UserGame.Parent=GetMainMenu();
 UserGame.Map=&UserGameMap;
 if(!UserGame.Load(pth,10)) return false;
 SetMainResponder(&UserGame);
 return true;
}
