#ifndef BERDY_HEADER
#define BERDY_HEADER

#ifdef COMPILE_SDL
#include "sdlwintypes.h"

#else
#include <windows.h>
#endif
#include <stdio.h>
#include <vector>

using namespace std;

#define AJA_LEVEL_HEADER "Level 4 AJA&Anakreon 2005"
#ifndef FreePtr
#define FreePtr(x) {if(x) free(x); x=NULL;}
#endif

void WriteToLog(const char *format,...); //zapise text do logu chyb, predsadi datem a casem, na konci udela novy radek.

class MBitmap;
class MAnimationBitmap;

bool LoadBitmap(MBitmap *bmp, const char *file, bool pCreateMask=false, bool nowriteerror=false); //nahraje bitmapu z datadiru
bool LoadThemeBitmap(UINT themeID, MBitmap *bmp, const char *file, bool createMask); //automaticky udela masku, pokud je themeID rovno -1, tak nacita mimo theme
bool ExistThemeBitmap(UINT themeID, const char *file); //vraci jen jestli exituje bitmapa
char *LoadText(const char *file, UINT major, UINT minor, bool canfromfile=true, bool canappendfromfile=false); //nacte text ze souboru file, pokud je major nebo minor roven nule, tak nacte cely soubor; kdyz je canfromfile, tak nacte nejdriv ze souboru, kdyz je canappendfromfile, tak na konce tohoto prida text z pripadneho souboru; vraci nove vznikly pointer, kdo volal funkci ho ma tex uvolnit; NULL kdyz nejaka chyba
void ScreenPaint(void); //vykresli vse, co ma zatim nacacheovane, ze ma vykreslit
void ScreenClearRect(myLPRECT rect=NULL, unsigned char r=0, unsigned char g=0, unsigned char b=0, const myLPRECT clipRegion=NULL);
void ScreenDrawBitmap(MBitmap *bmp, const myLPRECT where, const myLPRECT clipRegion=NULL);
void ScreenDrawBitmap(MBitmap *bmp, int x, int y, const myLPRECT clipRegion=NULL);
void ScreenDrawBitmap(const char *file, const myLPRECT where, const myLPRECT clipRegion=NULL);
void ScreenDrawBitmap(const char *file, int x, int y, const myLPRECT clipRegion=NULL);
bool ScreenGetBitmap(MBitmap *bmp, const myLPRECT where); //nacte do bmp obrazek z dane pozice, bmp podle velikosti inicializuje
void ScreenGetBitmap(MBitmap *bmp,int x, int y); //velikost podle velikosti bitmapy
void ScreenDrawCursor(int x, int y, bool pShow); //pShow rika, jestli ma ukazat, nebo schovat - vzdy muze byt jen jeden cursor na obrazovce, tedy show na jine misto puvodni schova
void ScreenGetSize(mySIZE &sz); //zjisti velikost obrazovky
void DrawRect(MBitmap *bmp, const myLPRECT rect=NULL, unsigned char r=0, unsigned char g=0, unsigned char b=0);
bool PrintTextFmt(int x, int y, const char *format,...);
bool PrintText(int x, int y, const char *buff,int maxchars=-1, int *fromPos=NULL, int *lastPos=NULL, myPOINT *startxy=NULL, myPOINT *lastxy=NULL, const myLPRECT clipRegion=NULL);
bool PrintTextAlign(int px, int py, const char *text); //vypise text se zarovnanim ve vysce py na obrazovce; ridi se podle prvniho znaku v text, kdyz je '#', tak zarovnava na stred, kdyz je $, tak doprava, kdyz neni nic, tak doleva; px udava pozadovane odsazeni zleva a z prava, ale je to jen pozadavek
bool PrintTextTwoColBlock(int px, int py, const char *text, const char *inter, int newrowplus=0, bool firstrowalign=false, char interznak='^'); //vypise text do bloku, znak interznak oddeluje dva sloupce a je nahrazen textem inter tolikrat, kolikrat se tam vejde

bool InitGame(void);
void QuitGame(void);
UINT GetInputableKey(UINT Key); //prekonvertuje znak Key na ekvivalentni vlozitelny, pokud jde, vraci 0 kdyz nejde, jinak kod znaku

void SetAnimTimerEnabled(UINT timerID, bool pVal);
bool GetAnimTimerEnabled(UINT timerID);
void SetAnimTimerElapsed(UINT timerID, UINT pVal);
UINT GetAnimTimerElapsed(UINT timerID);

const char *GetDataDir(void); //vraci misto, kde jsou ulozeny data vcetne lomitka na konci
const char *GetUserLevelDir(void); //kde jsou ulozeny levely hrace

//-------------------------------------------------------------------------------

#define MOUSE_BUTT_NONE     0
#define MOUSE_BUTT_CTRL     1 
#define MOUSE_BUTT_LEFT     2 
#define MOUSE_BUTT_MIDDLE   4 
#define MOUSE_BUTT_RIGHT    8 
#define MOUSE_BUTT_SHIFT   16

#ifdef COMPILE_SDL
#define KEY_LEFT		SDLK_LEFT
#define KEY_RIGHT		SDLK_RIGHT
#define KEY_UP			SDLK_UP
#define KEY_DOWN		SDLK_DOWN
#define KEY_ESCAPE		SDLK_ESCAPE
#define KEY_RETURN		SDLK_RETURN
#define KEY_SELECT		SDLK_KP_ENTER
#define KEY_SPACE		SDLK_SPACE
#define KEY_TAB			SDLK_TAB
#define KEY_BACKSPACE	SDLK_BACKSPACE
#define KEY_F1			SDLK_F1
#define KEY_F2			SDLK_F2
#define KEY_F3			SDLK_F3
#define KEY_F4			SDLK_F4
#define KEY_F5			SDLK_F5
#define KEY_F6			SDLK_F6
#define KEY_F7			SDLK_F7
#define KEY_F8			SDLK_F8
#define KEY_F9			SDLK_F9
#define KEY_F10			SDLK_F10
#define KEY_F11			SDLK_F11
#define KEY_F12			SDLK_F12
#define KEY_D		    SDLK_d
#define KEY_R		    SDLK_r
#define KEY_T		    SDLK_t
#define KEY_P		    SDLK_p
#define KEY_N		    SDLK_n
#define KEY_1			SDLK_1
#define KEY_2			SDLK_2
#define KEY_3			SDLK_3
#define KEY_4			SDLK_4
#define KEY_5			SDLK_5
#define KEY_6			SDLK_6
#define KEY_7			SDLK_7
#define KEY_8			SDLK_8
#define KEY_9			SDLK_9
#define KEY_0			SDLK_0
#else
#define KEY_LEFT		VK_LEFT
#define KEY_RIGHT		VK_RIGHT
#define KEY_UP			VK_UP
#define KEY_DOWN		VK_DOWN
#define KEY_ESCAPE		VK_ESCAPE
#define KEY_RETURN		VK_RETURN
#define KEY_SELECT		VK_SELECT
#define KEY_SPACE		VK_SPACE
#define KEY_TAB			VK_TAB
#define KEY_BACKSPACE	VK_BACK
#define KEY_F1			VK_F1
#define KEY_F2			VK_F2
#define KEY_F3			VK_F3
#define KEY_F4			VK_F4
#define KEY_F5			VK_F5
#define KEY_F6			VK_F6
#define KEY_F7			VK_F7
#define KEY_F8			VK_F8
#define KEY_F9			VK_F9
#define KEY_F10			VK_F10
#define KEY_F11			VK_F11
#define KEY_F12			VK_F12
#define KEY_D		    'D'
#define KEY_R		    'R'
#define KEY_T		    'T'
#define KEY_P		    'P'
#define KEY_N		    'N'
#define KEY_1			'1'
#define KEY_2			'2'
#define KEY_3			'3'
#define KEY_4			'4'
#define KEY_5			'5'
#define KEY_6			'6'
#define KEY_7			'7'
#define KEY_8			'8'
#define KEY_9			'9'
#define KEY_0			'0'
#endif
//-------------------------------------------------------------------------------

bool IsKeyDown(UINT key); //vraci jestli je klavesa stistena
void SendKeyDown(UINT key); //posle do fronty zprav message, ze je klavesa stistena

//-------------------------------------------------------------------------------

class MResponder //virtualni trida zajistujici user-input
{
 private:
 public:
   MResponder(){Parent=NULL;}
   virtual ~MResponder(){Parent=NULL;}

   MResponder *Parent; //preda se mu rizeni pri ukonceni respondera, je-li nejaky nastaven

   virtual void KeyPress(UINT Key,UINT butts)=0;
   virtual void MouseMove(int x, int y, UINT butts)=0; //butts je bitovy OR od MOUSE_BUTT_...
   virtual void MouseLeft(int x, int y, UINT butts)=0;
   virtual void MouseMiddle(int x, int y, UINT butts)=0;
   virtual void MouseRight(int x, int y, UINT butts)=0;

   virtual void OnAnimTimer(UINT timerID)=0;
   virtual void OnActivate(MResponder *resp)=0; //je zavolana, kdyz je tato nastavena jako hlavni responder
   virtual void OnDeactivate(MResponder *resp)=0; //je volana, kdyz je prenastavovana z hlavniho responderu

   virtual void MenuClick(UINT menuID){} //tento nedela nic, ale druzi muzou, vzdy po vyberu menu je aktivnimu responderu predano, co bylo stisknuto
};

//-------------------------------------------------------------------------------

void SetMainResponder(MResponder *resp); //nastavi toho, kdo bude odpovidat na user-input; predchozi se zapomene
MResponder *GetMainResponder(void); //vraci, kdo prave odpovida za klavesy

MResponder *GetLevelEditor(void); //vrati ukazatel na editor levelu

void OnMenuActivate(UINT menuID);

//-------------------------------------------------------------------------------

void InitFont(void);
void InitOci(void);
void DoOciAnim(void);
void RunIntro(MResponder *par);
void ClearIntro(void);
void DoShowBitmapShut(MResponder *parent, const char *bitmapname, bool up, bool canskip=true);
void ShowHelpMenu(MResponder *parent);
void ShowOptionsMenu(MResponder *parent);

//-------------------------------------------------------------------------------

#define HMF 20
#define POCET_OCI 3

#define ANIM_TIMER1 120
#define ANIM_TIMER2 121

#define OCI_ANIM_DELAY 150
#define TEXTSCROLL_DELAY 40
#define XPOLI     32
#define YPOLI     21
#define MAP_OBJ_WIDTH  20
#define MAP_OBJ_HEIGHT 20

#define TRANSPARENT_COLOR 167,107,107

class MTextScrollerLine
{
 private:
 public:
   MTextScrollerLine();
   ~MTextScrollerLine();

   const char *text; //text na radku; pointer nevlastnim, mam ho jen pujceny
   MBitmap *bmp; //bitmapa textu
   myRECT offset; //kde se kresli na obrazovce
};

class MTextScroller: public MResponder
{
 private:
   char *File;
   char *Text;
   char *backFile; //soubor pozadi
   vector<MTextScrollerLine *> lines;
   myPOINT upperbackoffset; //offset backgoundu
   MBitmap *upperbackbmp;
   MBitmap *headerbmp;
   MBitmap *backbmp;
   char *header;

   void BreakTextToLines(void); //rozbije Text do lines
   UINT lnfrom; //od ktereho radku kreslim
   void ClearLines(bool AlsoText); //uvolni Text kdyz je AlsoText na true; a uvolni i obsah vectoru lines

   myRECT *UseClipRegion;
 public:
   MTextScroller();
   MTextScroller(const char *hdr, int hdrx, int hdry, int clipx, int clipy, int clipwidth, int clipheight, const char *txtfile, UINT txtmajor=0, UINT txtminor=0, bool pcanfromfile=true, bool pcanappend=false);
   virtual ~MTextScroller();
   
   void Initialize(const char *hdr, int hdrx, int hdry, int clipx, int clipy, int clipwidth, int clipheight, const char *txtfile, UINT txtmajor=0, UINT txtminor=0, bool pcanfromfile=true, bool pcanappend=false);
   void Clear(void);

   myRECT clipRegion; //misto orezavani na obrazovce (primo v koordinatech obrazovky)

   myPOINT headeroffset;
   void SetHeader(const char *file); //header nad textem, zalezi na headeroffset
   const char *GetHeader(void);

   myPOINT backoffset; //offset backgoundu
   void SetBackground(const char *file); //bitmapa pozadi; kresli podle backoffset
   const char *GetBackground(void);

   void SetTextFile(const char *textFile);
   const char *GetTextFile(void);
   UINT major,minor; //verze textu, co se ma nahrat ze souboru GetTextFile()
   bool canfromfile, canappend; //parametru pro LoadText

   void DoStep(void); //udela jeden krok; kdyz dojde cely text, tak zavola sam Stop();
   void Stop(void); //ukonci se, preda rizeni parentu

   void KeyPress(UINT Key,UINT butts);
   void MouseMove(int x, int y, UINT butts); //butts je bitovy OR od MOUSE_BUTT_...
   void MouseLeft(int x, int y, UINT butts);
   void MouseMiddle(int x, int y, UINT butts);
   void MouseRight(int x, int y, UINT butts);

   void OnAnimTimer(UINT timerID);
   void OnActivate(MResponder *resp); //je zavolana, kdyz je tato nastavena jako hlavni responder
   void OnDeactivate(MResponder *resp); //je volana, kdyz je prenastavovana z hlavniho responderu
};

//---------------------------------------------------------------------------------------

enum MPlayerType{ptAll=0, ptRed=1, ptGreen=2, ptBlue=3, ptYellow=4, ptMagenta=5}; //u klice urcuje, pro koho je klic urceny

class MGameMap;
class MMapObject;
class MMapItem
{
 private:
   MMapObject *Parent; //ke komu patri, nesmi byt NULL; nevlastni, jen pujcuje z konstruktoru
 protected:
 public:
   MMapItem(MMapObject *obj);
   virtual ~MMapItem();
   
   MMapObject *GetParent(void);
   void SetParent(MMapObject *obj);

   virtual bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy)=0; //item je prvek, ktery se chce dostat na tuto pozici
   
   MAnimationBitmap *bitmap; //nevlastni, jen odkaz do MGameMap->items
   int FrameRow, FrameCol; //ktery obrazek se ma vykreslit
   UINT themeID;

   bool DrawAt(MBitmap *des, const myLPRECT r);
   
   virtual bool OnAnimTimer(MBitmap *des); //vraci, jestli byla zmena, jestli neco nakreslil do des
};

class MMapObject
{
 private:
   MGameMap *Map;
 public:
   MMapObject();
   ~MMapObject();

   void SetMap(MGameMap *pmap);

   myRECT rect; //kde je na obrazovce
   MBitmap *bmp; //obrazek prvku - jeho podklad

   int X,Y; //jake pozici na mape odpovida
   MMapItem *item; //jaka vec je na tomto poli, muze byt NULL, kdyz zadna

   //odkaz na background, pokud je themeID==-1, tak neni zadny pozadi
   UINT themeID;
   int frameCol, frameRow;
   char *file;

   void DrawAt(MBitmap *des,int offsetx=0, int offsety=0);
   
   bool playerHere; //rika, ze je na poli hrac, pak tam taky nikdo nesmi
   bool locked; //pokud je locked, tak na ten prvek nikdo nesmi
   bool CanGoOn(MMapItem *pitem, int dx, int dy);

};

enum MPlayerRotation{prUp=0, prDown=1, prLeft=2, prRight=3};

class MPlayer:public MMapItem
{
 private:
 public:
   MPlayer(MMapObject *obj);
   virtual ~MPlayer();

   bool CanGoOn(MGameMap *map, MMapItem *item, int dx, int dy);

   int X,Y; //pozice na mape
   MPlayerRotation Rotation;
   //MAnimationBitmap *bmp; //bitmapa berusky
   MPlayerType typ; //typ berusky, zadna nesmi mit typ ptAll
   bool haveKey; //jestli ma svuj klic
   int haveTool; //jestli ma nastroj - tedy krumpac
   bool out; //jestli uz je mimo mapu

   bool animated; //jestli se prave animuje, pak nemuze menit dalsi svuj smer
   int newX, newY; //kam se pri animaci posunuje
   void SetPosition(int px, int py); //nastavi newX,newY i X,Y zaroven

   //void Draw(void);
   void DrawAt(MBitmap *des,int offsetx, int offsety);
};


typedef struct
{
 MPlayer *Player;
 
 MMapItem *item; //kdyz neni NULL, tak pred sebou tahne tuto vec
 int item_mvx,item_mvy; //smer, kterym se item posouva
 bool quickMove; //jestli je rychly posuv
} MPlayerAnim;

/*class MGameItem
{
 private:
 public:
   MGameItem();
   ~MGameItem();
   
   MAnimationBitmap *items;
};*/

typedef struct
{
 UINT themeID;
 char *file;
 MAnimationBitmap *bmp;
}MItemBitmaps;

typedef struct
{
 int x,y; //kde se animuje
 MAnimationBitmap *bmp;
 MMapItem *item; //kdyz neni NULL, tak se mu preda rizeni animace - pro dvere
}MItemAnimation;

class MGameMap
{
 friend class MGameMapSave;
 friend class MLevelEditor;
 private:
   mySIZE mapSize;
   myPOINT mapOffset;
   MMapObject *objects;

   vector<MPlayer *> players;
   MPlayer *ActPlayer; //jen pujceny pointer z players

   vector<MPlayerAnim>playeranims; //animace, jen propujcene ukazatele
   void PlayerAnimsChanged(void); //zmenil se pocet animaci pro playera
   MBitmap *animbuff; //buffer na animace
   vector<MItemAnimation>itemanims; //animace veci, jen pujceny ukazatele
   void ItemAnimsChanged(void); //zmenil se pocet animaci u veci
   
   vector<MItemBitmaps> items; //veci co jsou na mape; tyto pointery uz vlastnim a taky mazu
   MAnimationBitmap *FindItemsBitmap(UINT themeID, const char *file); //kdyz nenasel v items, tak prida novy; kdyz chyba, tak vraci NULL
   void ClearItemsBitmaps(void); //vymaze obsah items

   bool InitItem(MMapItem *item, int x, int y, UINT themeID, const char *file, int frameCol, int frameRow, int rot=0); //vraci, jestli povedlo inicializovat item z parametru

   void DrawObject(int x, int y, MBitmap *des=NULL); //des rika, kam to chci vykreslit, NULL je primo do obrazovky
   void DrawPlayer(int x, int y, MPlayer *player, MBitmap *des=NULL); //player muze byt NULL, pak jen prekresli zpet prvek
   void BeforePlayerMove(MPlayer *player, int movex, int movey); //volana pred zacatkem pohybu - otevira dvere a podobne
   void AfterPlayerMove(MPlayer *player, bool canResendKey); //volana po dodelani pohybu, pak zveda veci a podobne
   MPlayer *FindPlayer(MPlayerType pt); //najde hrace daneho typu, jestli je na mape

   void DrawTopPanel(void); //nakresli horni listu s berdama
   void RedrawKeys(void); //prekresli na hornim panelu pocet klicu
   void ChangePlayer(MPlayer *old); //zmeni hrace a toho stareho prekresli

   MBitmap *beract; //kurzor, co se kresli pri zmene berdy pres ni, ze je aktivni (po TAB)
   UINT themeID;
   int haveExitKeys;
   UINT steps; //pocet kroku
   bool levelDone; //jestli uz je ukonceno kolo
   
   //texty
   char *krokuText;

   void DrawObjectWithPlayer(int x, int y); //vykresli object i s hracem, je-li tam
   bool delItemUpdatesScreen;
   void DelPlayerAt(int x,int y);
 public:
   MGameMap();
   ~MGameMap();

   void UpdateTimers(void); //obnovi nastaveni timeru
   void OpenExit(void); //otevre vsechny vychody na mape; pokud neni dostatek klicu, tak nic neudela

   bool Create(int szx, int szy,myPOINT offset, UINT mapThemeID); //vytvori novou mapu; mapThemeID rika, jakej ma byt prednostne pouzitej theme, muze byt -1; z tohoto theme bere bitmapy
   void ChangeBackgroundTheme(UINT newThemeID, bool initobjs=false);
   UINT GetBackgroundTheme(void);
   void GetOffset(myPOINT &off);

   void Clear(void);
   MMapObject *GetObject(int x, int y);
   
   bool AddPlayer(int x, int y, MPlayerType plr,MPlayerRotation prot=prUp); //prida noveho hrace
   MPlayer *GetPlayer(MPlayerType plr); //vraci ukazatel na daneho hrace - NULL kdyz neni v mape
   bool CanGoOn(MMapItem *item, int px, int py); //vraci, jestli muze vec item vstoupit na pole px,py mimo mapu

   void PlayerStateChanged(MPlayer *player); //udela update na obrazovce toho, co tento hrac zrovna ma (horni lista)
   void DoorStateChanged(MMapItem *item); //vyvola znovu nakresleni dveri po zmene stavu, item muze byt jen MMenuItemDoorTmpl, jinak nic neprovede
   bool HavePlayerAnims(void); //vraci, jesli se animuji nejaci hraci

   //pridavani/odebirani veci
   void DelItem(int x,int y,bool updateScreen=false);
   bool AddItemWall(int x, int y, UINT themeID, int frameCol, int frameRow=0, const char *file=NULL, int rot=0);
   bool AddItemBox(int x, int y, UINT themeID,  int frameCol, int frameRow=0);
   bool AddItemTNT(int x, int y, UINT themeID,  int frameCol, int frameRow=0);
   bool AddItemExitKey(int x, int y, UINT themeID, int frameCol, int frameRow=0);
   bool AddItemExit(int x, int y, UINT themeID, int frameCol, int frameRow=0);
   bool AddItemStone(int x, int y, UINT themeID, int frameCol, int frameRow=0);
   bool AddItemTool(int x, int y, UINT themeID, int frameCol, int frameRow=0);
   bool AddItemColorKey(int x, int y, MPlayerType keyType, UINT themeID); //keyType rika, jak barva klice to ma byt
   //u dveri se umistuje prostredek dveri
   bool AddItemLockDoor(int x, int y, MPlayerType keyType, bool doorlocked, bool horz, UINT themeID); //horz kdyz je true, tak josu dvere horizontalni, jinak vertikalni; toto jsou dvere otevirajici se na klic, jak se jednou otevrou, tak jsou furt otevreny
   bool AddItemColorWay(int x, int y, MPlayerType keyType, bool horz, UINT themeID); //dvere jako barevne pruchody, jen pro jednu berdu
   bool AddItemOnceDoor(int x, int y, bool doorlocked, bool horz, UINT themeID); //jdou projit jen jednou; libovolna berda
   bool SetGround(int x,int y,UINT themeID, int frameCol, int frameRow=0, const char *file=NULL);
   void ClearGround(int x, int y);
   bool HaveDoorOn(int x, int y); //vraci, jestli jsou na dane pozici dvere, nebo Wing od nejakych dveri

   void Draw(void); //vykresli mapu na obrazovku, vcetne horniho panelu a status textu
   void DrawMap(void); //vykresli pouze mapu

   void SortPlayers(void); //usporada hrace podle barev v seznamu, ne podle toho, jak sli pri nahravani za sebou
   //vyber aktivniho hrace
   void FirstPlayer(void);
   void NextPlayer(void);
   void PrevPlayer(void);
   void SetPlayerNum(int num); //vybere hrace podle poradi
   void SetPlayer(MPlayerType plr);

   //posuv hrace
   void MovePlayer(MPlayerRotation where, bool quickMove); //kam se ma posunout aktivni hrac; pokud je quickMove true, tak bez animace, jinak s animaci

   //animace
   void OnAnimTimer(UINT timerID);

   bool CanPickExitKey(void); //vraci, jestli jeste muze vzit ExitKey
   void ExitPlayer(MMapItem *exititem, MPlayer *player); //udela animaci odchodu hrace ze hry u exitu exititem
   void DestroyStone(MMapItem *stone, MPlayer *player); //hrac player rozbije stone, pokud ale ma tool, pak o nej prijde
   void DestroyBox(int x, int y); //znici bednu za pomoci TNT na pozici x,y

   bool IsLevelDone(void); //vraci, jestli uz je mapa hotova (jedna beruska vlezla do otevrenyho vychodu)
   UINT GetSteps(void); //vraci/nastavuje pocet zadim udelanych kroku
   void SetSteps(UINT cnt);

   void DrawStatusText(const char *txt); //vykresli dolu tento text, ale nezapamatuje si ho
   void RedrawStatusText(void);
   void ClearStatusRect(void);
};

//---------------------------------------------------------------------------------------

enum MGameMapSaveItemIdent{iiBackground=0, iiWall=1, //General+file
         iiBox=2,iiTNT=3,iiExitKey=4,iiExit=5,iiStone=6,iiTool=7, //General
         iiColorKey=8,iiLockDoor=9, iiColorWay=10, iiOnceDoor=11};

typedef struct
{
 MGameMapSaveItemIdent ident;
 int x,y;
 UINT themeID;
 union
   {
    struct
	  {
       int frameCol,frameRow;
       char *file;
	  };
	struct
	  {
	   MPlayerType keyType;
	   bool doorlocked;
	   bool horz;
	  };
   };
}MGameMapSaveItem;//General;

/*typedef struct
{
 int x,y;
 UINT themeID;
 MPlayerType keyType;
 bool doorlocked;
 bool horz;
}MGameMapSaveItemDoorThings;*/

typedef struct
{
 int X,Y;
 MPlayerType typ;
 MPlayerRotation Rotation;

 bool haveKey;
 int haveTool;
 bool out;
}MGameMapSavePlayer;

class MStream;

class MGameMapSave
{
 private:
   vector<MGameMapSaveItem>Items;
   vector<MGameMapSavePlayer>Players;

   mySIZE mapSize;
   myPOINT mapOffset;
   int ActPlayer;
   int haveExitKeys;
   UINT steps;
   UINT themeID;
 public:
   MGameMapSave();
   ~MGameMapSave();

   void Clear(void);
   bool Save(MGameMap *srcMap); //ulozi srcMap do save-u
   bool Load(MGameMap *desMap); //nacte do desMap ulozeny save

   bool SaveToFile(const char *FileName); //ulozi ulozenou pozici do souboru
   bool LoadFromFile(const char *FileName);//nacte ulozenou pozici ze souboru
   bool LoadFromStream(MStream *f); //nacte primo z disku/FILE
};
//---------------------------------------------------------------------------------------
class MMenu;
//hlavni trida, obsluhuje samotne hrani
class MGame:public MResponder
{
 private:
   MMenu *Menu;
   void ManageGameMenu(void); //zorbazi a ukonci GameMenu ve hre
   char *File;
   void SetFile(const char *file);
   const char *GetFile(void);

   int haveSaves; //kolik mi jeste zbyva save-u; kdyz <=0, tak uz nemuzu ukladat
   bool needsave;
   MGameMapSave Save; //ulozena pozice
   int statuswait; //napsal jsem svuj text a az bude toto <=0, tak ho vypinam

   //texty
   char *demoNoSave;
   char *noSaves;
   char *Saving;
   char *demoNoLoad;
   char *emptyLoad;
   char *Loading;

   void TryEndLevel(void);
 public:
   MGame();
   virtual ~MGame();

   MGameMap *Map; //mam jen pujcene, stara se o nej nekdo jiny
   void InitMenu(void); //pripravi menu, pokud jeste neni vytvoreny
   //void FreeMenu(void); //uvolni pamet, kterou drzi Menu

   bool Load(const char *file, int SaveLimit); //nahraje level jmena file; vraci jestli povedlo
   void Draw(void); //vykresli mapu a vse co k tomu patri na obrazovku
   bool LevelDone(void); //vraci, jestli byl level uspesne dokoncen; false, kdyz ukoncit epizodu bez pokracovani

   //odpovedi na menu polozky ve hre
   void Restart(void);
   void MemLoad(void);
   void MemSave(void);

   void KeyPress(UINT Key,UINT butts);
   void MouseMove(int x, int y, UINT butts);
   void MouseLeft(int x, int y, UINT butts);
   void MouseMiddle(int x, int y, UINT butts);
   void MouseRight(int x, int y, UINT butts);

   void OnAnimTimer(UINT timerID);
   void OnActivate(MResponder *resp);
   void OnDeactivate(MResponder *resp);
};

//---------------------------------------------------------------------------------------

//jednotlive epizody hrani
class MEpisodes:public MResponder
{
 private:
   int episoda; //cislo epizody, cislo 1..5, ukazuje na znak: "rjstn"
   int maxlevel; //maximalni cislo levelu
   char passfile[8]; //textovy soubor, kde se nachazi hesla - zaroven zde zjisti maximum levelu

   void BeforeLevel(void); //zobrazi okno pred 
   void CountMaxLevels(void);
   char *GetPassword(void);

   myRECT hlavniMenu, startLevelu; //jake misto zabiraji tyto volby v BeforeLevel

   MGameMap Map;
   MGame Game; //hra, dostane pak response
 public:
   MEpisodes(int pepisoda);
   virtual ~MEpisodes();

   int level; //aktualni level

   void Start(void); //spusteni episoda/level kola, i s "predoknem"


   void KeyPress(UINT Key,UINT butts);
   void MouseMove(int x, int y, UINT butts);
   void MouseLeft(int x, int y, UINT butts);
   void MouseMiddle(int x, int y, UINT butts);
   void MouseRight(int x, int y, UINT butts);

   void OnAnimTimer(UINT timerID);
   void OnActivate(MResponder *resp);
   void OnDeactivate(MResponder *resp);
};

//---------------------------------------------------------------------------------------

bool LoadLevel(const char *file, MGameMap *map); //file bez pripony a cesty, vraci jestli nacetl do map level file; kdyz je ve file znak '.', tak se bere jakoze je udana cela cesta
bool RunUserLevel(const char *file); //vrati, jestli se mu povedlo otevrit uzivatelsky soubor 

//---------------------------------------------------------------------------------------

void SystemEvalFiles(vector<char*> *files,const char *dir,const char *filemask); //pridava na konec seznamu files jmena souboru nalezene podle masky

void LoadSetup(void);
void SaveSetup(void);

#endif

