#include "berdy.h"
#include "MBitmaps.h"
#include "menu.h"
#include <vector>

using namespace std;

enum MEditing{eBackground=0, eGround=1, eWall=2, eBox=3, eTNT=4, eExit=5, eStone=6, eTool=7, eKeys=8, eDoors=9, ePlayer=10};

typedef struct
{
 int frameCol1, frameRow1; char *file1; //UINT themeID1; //prvni radek
 int frameCol2, frameRow2; char *file2; //UINT themeID2; //druhy radek
 int frameCol3, frameRow3; char *file3; //UINT themeID3; //treti radek
}MAvailThings;

class MLevelEditor:public MResponder
{
 private:
   MGameMap Map;
   myPOINT  mousepos;
   MEditing nowEditing;
   MBitmap Cursor;
   MBitmap tmpbmp;
   vector<MAvailThings> chooses;
   UINT chosen;
   UINT themeID; //pro veci
   UINT choosesfrom;
   BYTE rotation;

   bool toLoad;

   void ClearChooses(void);
   void ReinitChooses(void);
   bool UpdateMousePos(int x, int y,bool realpoint=false); //x,y jsou koordinaty mysi nad oknem
   void DoAddPrvek(void);
 public:
   MLevelEditor();
   virtual ~MLevelEditor();

   virtual void KeyPress(UINT Key,UINT butts);
   virtual void MouseMove(int x, int y, UINT butts);
   virtual void MouseLeft(int x, int y, UINT butts);
   virtual void MouseMiddle(int x, int y, UINT butts);
   virtual void MouseRight(int x, int y, UINT butts);

   virtual void OnAnimTimer(UINT timerID);
   virtual void OnActivate(MResponder *resp);
   virtual void OnDeactivate(MResponder *resp);

   void DrawTopPanel(void);
   void RedrawTopThings(void);
   void Draw(void);

   void DoLoad(void);
   void DoSave(void);
   void DoExit(void);
   void DoThing(void);
   void DoTheme(void);
   void DoRotate(void);
};

//-----------------------------------------------------------------------------

MLevelEditor::MLevelEditor()
{
 toLoad=false;
 mousepos.x=-1; mousepos.y=-1;
 nowEditing=eBackground;
 chosen=0;
 themeID=1;
 choosesfrom=0;
 rotation=0;
 Map.delItemUpdatesScreen=true;
}

MLevelEditor::~MLevelEditor()
{
 ClearChooses();
}

void MLevelEditor::KeyPress(UINT Key,UINT butts)
{
 bool things=false;
 switch(Key)
   {
    case KEY_ESCAPE: DoExit(); break;
	case KEY_0: nowEditing=eBackground; things=true; break;
	case KEY_1: nowEditing=eGround; things=true; break;
	case KEY_2: nowEditing=eWall; things=true; break;
	case KEY_3: nowEditing=eBox; things=true; break;
	case KEY_4: nowEditing=eTNT; things=true; break;
	case KEY_5: nowEditing=eExit; things=true; break;
	case KEY_6: nowEditing=eStone; things=true; break;
	case KEY_7: nowEditing=eTool; things=true; break;
	case KEY_8: nowEditing=eKeys; things=true; break;
	case KEY_9: nowEditing=eDoors; things=true; break;
	case KEY_P: nowEditing=ePlayer; things=true; break;
	case KEY_T: DoTheme(); break;
	case KEY_R: DoRotate(); break;
	case KEY_F2: DoSave(); break;
	case KEY_F3: DoLoad(); break;
   }
 if(things)
   {
    myPOINT mp=mousepos;
	UpdateMousePos(-1,-1,true);
    ReinitChooses();
	RedrawTopThings();
	UpdateMousePos(mp.x,mp.y,true);
   }
}

bool MLevelEditor::UpdateMousePos(int x, int y, bool realpoint)
{
 int px=x,py=y, ix=0,iy=0;
 if(!realpoint)
   {
    px=x/MAP_OBJ_WIDTH;
    py=(y-60)/MAP_OBJ_HEIGHT;
    if(y<60) py=-1;
   }

 bool have=false;
 MAvailThings t;
 t.file1=NULL; t.file2=NULL; t.file3=NULL;
 if(chosen>=0&&chosen<chooses.size())
   {
    t=chooses[chosen];
    have=(t.file1||t.file2||t.file3);
	if(t.file1&&t.file2&&t.file3)
	  {
	   if((rotation%2)==1) ix=1;
	    else iy=1;
	  }
   }
 
 if(mousepos.x!=px||mousepos.y!=py)
   {
    if(mousepos.x>=0&&mousepos.y>=0) Map.DrawObjectWithPlayer(mousepos.x,mousepos.y);
    if(/*t.file1&&*/mousepos.x-ix>=0&&mousepos.x-ix<Map.mapSize.cx&&mousepos.y-iy>=0&&mousepos.y-iy<Map.mapSize.cy) Map.DrawObjectWithPlayer(mousepos.x-ix,mousepos.y-iy);
    if(/*t.file3&&*/mousepos.x+ix>=0&&mousepos.x+ix<Map.mapSize.cx&&mousepos.y+iy>=0&&mousepos.y+iy<Map.mapSize.cy) Map.DrawObjectWithPlayer(mousepos.x+ix,mousepos.y+iy);
   }
 mousepos.x=px; mousepos.y=py;

 if(mousepos.x>=0&&mousepos.y>=0) 
   {
    MAnimationBitmap *abmp=NULL;
    MMapObject *o=Map.GetObject(mousepos.x,mousepos.y);
    if(o)
	  {
	   have=false;
	   if(!t.file1&&t.file2&&!t.file3)
	     {
	      abmp=Map.FindItemsBitmap(themeID,t.file2);
	      if(abmp)
	        {
		     o->DrawAt(&tmpbmp);
		     have=abmp->DrawFrame(&tmpbmp,t.frameCol2,NULL,t.frameRow2);
			}
		 }
	   if(!have) 
	     {
		  if(nowEditing==eBackground) ScreenDrawBitmap(&Cursor,&(o->rect));
		 }
		else ScreenDrawBitmap(&tmpbmp,&(o->rect));
	  }
	if(t.file1&&t.file2&&t.file3&&mousepos.x>=1&&mousepos.x<Map.mapSize.cx-1&&mousepos.y>=1&&mousepos.y<Map.mapSize.cy-1) //jde o dvere
	  {
	   if(ix) //horizontalni dvere
	     {
		  if(chosen>=0&&chosen<10)
		    {
			 //if(chosen<5) //doorlocked
			 t.frameRow1=((chosen<5)?0:1);
			 t.frameCol2=(chosen<5)?0:1; t.frameRow2=0;
			 t.frameRow3=2+((chosen<5)?0:1);
			}
		  if(chosen>=10&&chosen<15)
		    {
			 t.frameRow1=2;
			 t.frameRow2=0;
			 t.frameRow3=1+2;
			}
		  if(chosen>=15&&chosen<17)
		    {
			 t.frameCol1=((chosen==15)?1:0);t.frameRow1=0;
			 t.frameCol2=((chosen==15)?0:1);t.frameRow2=2;
			 t.frameCol3=((chosen==15)?1:0);t.frameRow3=1;
			}
		 }
	   o=Map.GetObject(mousepos.x-ix, mousepos.y-iy);
	   if(o)
	     {
		  abmp=Map.FindItemsBitmap(themeID,t.file1);
		  if(abmp)
		    {
			 o->DrawAt(&tmpbmp);
			 have=abmp->DrawFrame(&tmpbmp,t.frameCol1,NULL,t.frameRow1);
			}
	      if(!have) ScreenDrawBitmap(&Cursor,&(o->rect));
		   else ScreenDrawBitmap(&tmpbmp,&(o->rect));
		 }
	   o=Map.GetObject(mousepos.x, mousepos.y);
	   if(o)
	     {
		  abmp=Map.FindItemsBitmap(themeID,t.file2);
		  if(abmp)
		    {
			 o->DrawAt(&tmpbmp);
			 have=abmp->DrawFrame(&tmpbmp,t.frameCol2,NULL,t.frameRow2);
			}
	      if(!have) ScreenDrawBitmap(&Cursor,&(o->rect));
		   else ScreenDrawBitmap(&tmpbmp,&(o->rect));
		 }
	   o=Map.GetObject(mousepos.x+ix, mousepos.y+iy);
	   if(o)
	     {
		  abmp=Map.FindItemsBitmap(themeID,t.file3);
		  if(abmp)
		    {
			 o->DrawAt(&tmpbmp);
			 have=abmp->DrawFrame(&tmpbmp,t.frameCol3,NULL,t.frameRow3);
			}
	      if(!have) ScreenDrawBitmap(&Cursor,&(o->rect));
		   else ScreenDrawBitmap(&tmpbmp,&(o->rect));
		 }
	  }
   }
 return realpoint||y>60&&y<480;
}

void MLevelEditor::MouseMove(int x, int y, UINT butts)
{
 UpdateMousePos(x,y);
}

void MLevelEditor::MouseLeft(int x, int y, UINT butts)
{
 if(!(butts&MOUSE_BUTT_LEFT)) return;
 if(x>=0&&x<40)
   {
    if(y>=0&&y<20)
	  {
	   DoLoad();
	  }
	if(y>=20&&y<40)
	  {
	   DoSave();
	  }
	if(y>=40&&y<60)
	  {
	   DoExit();
	  }
   }
 if(x>=40&&x<80)
   {
    if(y>=0&&y<20)
	  {
	   DoThing();
	  }
	if(y>=20&&y<40)
	  {
	   DoTheme();
	  }
	if(y>=40&&y<60)
	  {
	   DoRotate();
	  }
   }
 if(x>=100&&x<620&&y>=0&&y<60)
   {
    if(chooses.size()-choosesfrom>=0&&x-100<=MAP_OBJ_WIDTH*(chooses.size()-choosesfrom))
	  {
	   chosen=((x-100)/MAP_OBJ_WIDTH)+choosesfrom;
	   RedrawTopThings();
	  }
   }
 if(UpdateMousePos(x,y))
   {
    DoAddPrvek();
   }
}

void MLevelEditor::MouseMiddle(int x, int y, UINT butts)
{
 if(!(butts&MOUSE_BUTT_MIDDLE)) return;
}

void MLevelEditor::MouseRight(int x, int y, UINT butts)
{
 if(!(butts&MOUSE_BUTT_RIGHT)) return;
 DoRotate();
}

void MLevelEditor::OnAnimTimer(UINT timerID)
{
 switch(timerID)
   {
    case ANIM_TIMER1:
	   SetAnimTimerEnabled(ANIM_TIMER1,false);
	   RedrawTopThings();
	   break;
   }
}

void MLevelEditor::OnActivate(MResponder *resp)
{
 char *info=NULL;
 if(resp==GetFileChoose())
   {
    if(GetFileChooseResult()&&GetFileChooseResult()[0])
	  {
       char file[1024];
	   strcpy(file,GetUserLevelDir());
	   strcat(file,GetFileChooseResult());
	   if(!strchr(file,'.'))
	     {
		  strcat(file,".LV3");
		 }
	   MGameMapSave sv;
	   if(toLoad) 
	     {
		  //if(sv.LoadFromFile(file)) sv.Load(&Map);
		  LoadLevel(file,&Map);
		 }
	    else
		 {
		  bool saved=false;
		  if(sv.Save(&Map))
		    {
			 saved=sv.SaveToFile(file);
			}
		  if(!saved)
		    {
			 info=LoadText("GAME",2,8);
			}
		 }
	  }
   }
 if(!LoadThemeBitmap(themeID,&Cursor,"BERACT",true))
   {
    LoadThemeBitmap(UINT(-1),&Cursor,"BERACT",true);
   }
 tmpbmp.Create(MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT);
 ReinitChooses();
 if(resp!=GetFileChoose())
   {
	themeID=1;
    myPOINT offset; offset.x=0; offset.y=60; Map.Create(XPOLI,YPOLI,offset,themeID);
   }
 ScreenClearRect();
 Draw();
 if(info)
   {
    myRECT r={80,0,640,60};
    ScreenClearRect(&r);
    PrintText(90,20,info);
	FreePtr(info);
	SetAnimTimerElapsed(ANIM_TIMER1,3000);
	SetAnimTimerEnabled(ANIM_TIMER1,true);
   }
}

void MLevelEditor::OnDeactivate(MResponder *resp)
{
 ClearChooses();
 Cursor.Clear();
 tmpbmp.Clear();
}

void MLevelEditor::ClearChooses(void)
{
 MAvailThings t;
 while(!chooses.empty())
   {
    t=chooses[0]; chooses.erase(chooses.begin());
	FreePtr(t.file1);
	FreePtr(t.file2);
	FreePtr(t.file3);
   }
}

void MLevelEditor::ReinitChooses(void)
{
 ClearChooses();
 const char *file=NULL;
 bool justFirst=false;
 UINT i;
 MAnimationBitmap *abmp;
 switch(nowEditing)
   {
    case eBackground: break;
	case eGround: file="GROUND"; break;
	case eWall: file="WALL"; break;
	case eBox: file="BOXES"; break;
	case eTNT: file="TNT"; break;
	case eExit: file="EXIT"; justFirst=true; break;
	case eStone: file="STONE"; justFirst=true; break;
	case eTool: file="TOOL"; break;
	case eKeys: file="KEYS"; break;
	case eDoors:
	  {
	   const char *fl1="DOOR", *fl2;
	   MAnimationBitmap *door=Map.FindItemsBitmap(themeID,fl1);
	   if(door)
	     {
          MAvailThings t;
		  int plr;
		  fl2="DOORKEY";
	      abmp=Map.FindItemsBitmap(themeID,fl2);
		  if(abmp)
		    {
			 for(i=0;i<2;i++)
			   {
			    for(plr=0;plr<5;plr++)
				  {
	               t.file1=strdup(fl2); t.file2=strdup(fl1); t.file3=strdup(fl2);
	               t.frameCol1=plr; t.frameCol2=i; t.frameCol3=plr; 
	               t.frameRow1=i+4; t.frameRow2=1; t.frameRow3=2+i+4;
				   chooses.push_back(t);
				  }
			   }
			}
		  fl2="DOORCOLS";
	      abmp=Map.FindItemsBitmap(themeID,fl2);
		  if(abmp)
		    {
			 for(plr=0;plr<5;plr++)
			   {
	            t.file1=strdup(fl2); t.file2=strdup(fl1); t.file3=strdup(fl2);
	            t.frameCol1=plr; t.frameCol2=0; t.frameCol3=plr; 
	            t.frameRow1=0; t.frameRow2=1; t.frameRow3=1;
			    chooses.push_back(t);
			   }
			}
		  fl2="DOOROT";
	      abmp=Map.FindItemsBitmap(themeID,fl2);
		  if(abmp)
		    {
			 for(i=0;i<2;i++)
			   {
	            t.file1=strdup(fl2); t.file2=strdup(fl1); t.file3=strdup(fl2);
	            t.frameCol1=!i?1:0; t.frameCol2=!i?0:1; t.frameCol3=!i?1:0; 
	            t.frameRow1=2; t.frameRow2=3; t.frameRow3=3;
				chooses.push_back(t);
			   }
			}
	     }
	  }
	  break;
	case ePlayer:
	  {
	   char fl[10];
	   for(i=1;i<=5;i++)
	     {
		  sprintf(fl,"HRAC%d",i);
		  abmp=Map.FindItemsBitmap(themeID,fl);
		  if(abmp)
		    {
             MAvailThings t;
	         t.file1=NULL; t.file2=NULL; t.file3=NULL;
	         t.frameCol1=-1; t.frameCol2=0; t.frameCol3=-1; 
	         t.frameRow1=-1; t.frameRow2=0; t.frameRow3=-1;
			 for(UINT j=0;j<4;j++)
			   {
			    t.frameRow2=j;
				if(abmp->HaveFrame(t.frameCol2,t.frameRow2))
				  {
				   t.file2=strdup(fl);
				   chooses.push_back(t);
				  }
			   }
			}
		 }
	  }
	  break;
   }
 
 if(!file) 
   {
    if(themeID!=1&&chooses.size()<=0)
      {
       themeID=1;
	   ReinitChooses();
      }
    if(chosen>=chooses.size()) 
      {
       if(chooses.size()) chosen=chooses.size()-1;
	    else chosen=0;
      }
    return;
   }

 abmp=Map.FindItemsBitmap(themeID,file);
 if(abmp)
   {
    MAvailThings t;
	t.file1=NULL; t.file2=NULL; t.file3=NULL;
	t.frameCol1=-1; t.frameCol2=0; t.frameCol3=-1; 
	t.frameRow1=-1; t.frameRow2=0; t.frameRow3=-1;
	i=1;
	while(i>0&&abmp->HaveFrame(t.frameCol2,t.frameRow2))
	  {
	   t.file2=strdup(file);
	   chooses.push_back(t);
	   i++;
	   if(justFirst)
	     {
	      t.frameRow2=i-1;
		 }
		else
		 {
	      t.frameCol2=i-1;
		 }
	  }
   }
 if(themeID!=1&&chooses.size()<=0)
   {
    themeID=1;
	ReinitChooses();
   }
 if(chosen>=chooses.size()) 
   {
    if(chooses.size()) chosen=chooses.size()-1;
	 else chosen=0;
   }
}

void MLevelEditor::DoAddPrvek(void)
{
 switch(nowEditing)
   {
    case eBackground: 
	  {
	   MMapObject *obj=Map.GetObject(mousepos.x,mousepos.y);
	   if(obj)
	     {
		  if(obj->playerHere)
		    {
			 Map.DelPlayerAt(mousepos.x,mousepos.y);
			}
		   else
		    {
			 if(obj->item) 
			   {
			    Map.DelItem(mousepos.x,mousepos.y,true);
			   }
			  else
			   {
			    Map.ClearGround(mousepos.x,mousepos.y);
			   }
			}
		 }
	  }
	  break;
	case eGround: Map.SetGround(mousepos.x,mousepos.y,themeID,chosen); break;
	case eWall: Map.AddItemWall(mousepos.x,mousepos.y,themeID,chosen); break;
	case eBox: Map.AddItemBox(mousepos.x,mousepos.y,themeID,chosen); break;
	case eTNT: Map.AddItemTNT(mousepos.x,mousepos.y,themeID,chosen); break;
	case eExit: Map.AddItemExit(mousepos.x,mousepos.y,themeID,0,chosen); break;
	case eStone:Map.AddItemStone(mousepos.x,mousepos.y,themeID,0,chosen); break;
	case eTool: Map.AddItemTool(mousepos.x,mousepos.y,themeID,chosen); break;
	case eKeys:
	  if(chosen==0) Map.AddItemExitKey(mousepos.x,mousepos.y,themeID,0);
	   else Map.AddItemColorKey(mousepos.x,mousepos.y,MPlayerType(chosen),themeID);
	  break;
	case eDoors:
	  {
	   //10 doorkey,5 doorcols,2 doorot
	   if(chosen>=0&&chosen<chooses.size()&&mousepos.x>=1&&mousepos.y>=1&&mousepos.x<Map.mapSize.cx-1&&mousepos.y<Map.mapSize.cy-1)
	     {
		  if(chosen>=0&&chosen<10) //doorkey
		    {
			 Map.AddItemLockDoor(mousepos.x,mousepos.y,(MPlayerType)((chosen%5)+1),chosen<5,(rotation%2)==1,themeID);
			}
		  if(chosen>=10&&chosen<15) //doorcols
		    {
			 Map.AddItemColorWay(mousepos.x,mousepos.y,(MPlayerType)(chosen-10+1),(rotation%2)==1,themeID);
			}
		  if(chosen>=15&&chosen<17) //doorot
		    {
			 Map.AddItemOnceDoor(mousepos.x,mousepos.y,chosen==15,(rotation%2)==1,themeID);
			}
		 }
	  }
	  break;
	case ePlayer:
	  {
	    MPlayerType plr=MPlayerType(1+int(chosen/4));
	   MPlayerRotation rot=MPlayerRotation( (chosen-((1-int(plr))*4))%4 );
	   if(plr>=1&&plr<=5&&rot>=0&&rot<=4) 
	     {
		  Map.DelItem(mousepos.x,mousepos.y,true);
		  Map.AddPlayer(mousepos.x,mousepos.y,plr,rot);
		 }
	  }
	  break;
   }
 /*Map.DrawObjectWithPlayer(mousepos.x, mousepos.y);
 if(mousepos.x>=0&&mousepos.y>=0) 
   {
    MMapObject *o=Map.GetObject(mousepos.x,mousepos.y);
    if(o) ScreenDrawBitmap(&Cursor,&(o->rect));
   }*/
 UpdateMousePos(mousepos.x,mousepos.y,true);
}

void MLevelEditor::RedrawTopThings(void)
{
 myRECT r={80,0,640,60};
 ScreenClearRect(&r);
 if(chooses.size()>26)
   {
    r.left=80; r.top=20; r.right=r.left+MAP_OBJ_WIDTH; r.bottom=r.top+MAP_OBJ_HEIGHT;
    ScreenDrawBitmap("HRNI_011",&r);
    r.left=620; r.top=20; r.right=r.left+MAP_OBJ_WIDTH; r.bottom=r.top+MAP_OBJ_HEIGHT;
    ScreenDrawBitmap("HRNI_013",&r);
	choosesfrom=0;
   }
 if(chooses.size()-choosesfrom-26<0) choosesfrom=chooses.size()-26;
 MAvailThings t;
 MAnimationBitmap *abmp;
 MBitmap des;
 for(UINT i=choosesfrom;i<choosesfrom+26&&i<chooses.size();i++)
   {
    t=chooses[i];
	r.left=100+MAP_OBJ_WIDTH*(i-choosesfrom); r.right=r.left+MAP_OBJ_WIDTH;
	r.top=0; r.bottom=r.top+MAP_OBJ_HEIGHT;
	if(t.file1!=NULL)
	  {
	   abmp=Map.FindItemsBitmap(themeID,t.file1);
	   if(abmp)
	     {
		  des.Create(MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT);
		  abmp->DrawFrame(&des,t.frameCol1,NULL,t.frameRow1);
		  ScreenDrawBitmap(&des,&r);
		 }
	  }
	r.top=r.bottom; r.bottom=r.top+MAP_OBJ_HEIGHT;
	if(t.file2!=NULL)
	  {
	   abmp=Map.FindItemsBitmap(themeID,t.file2);
	   if(abmp)
	     {
		  des.Create(MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT);
		  abmp->DrawFrame(&des,t.frameCol2,NULL,t.frameRow2);
		  ScreenDrawBitmap(&des,&r);
		 }
	  }
	r.top=r.bottom; r.bottom=r.top+MAP_OBJ_HEIGHT;
	if(t.file3!=NULL)
	  {
	   abmp=Map.FindItemsBitmap(themeID,t.file3);
	   if(abmp)
	     {
		  des.Create(MAP_OBJ_WIDTH,MAP_OBJ_HEIGHT);
		  abmp->DrawFrame(&des,t.frameCol3,NULL,t.frameRow3);
		  ScreenDrawBitmap(&des,&r);
		 }
	  }
   }
 if(nowEditing!=eBackground&&chosen>=choosesfrom&&chosen<choosesfrom+26)
   {
    r.left=100+MAP_OBJ_WIDTH*(chosen-choosesfrom); r.right=r.left+MAP_OBJ_WIDTH;
	r.top=MAP_OBJ_HEIGHT; r.bottom=r.top+MAP_OBJ_HEIGHT;
	ScreenDrawBitmap(&Cursor,&r); //"HRNI_058"
   }
}

void MLevelEditor::DrawTopPanel(void)
{
 MBitmap bmp;
 LoadBitmap(&bmp,"editor",false);
 ScreenDrawBitmap(&bmp,0,0);
 RedrawTopThings();
}

void MLevelEditor::Draw(void)
{
 DrawTopPanel();
 Map.DrawMap();
}

void MLevelEditor::DoLoad(void)
{
 toLoad=true;
 ActivateFileChoose(this,true);
}

void MLevelEditor::DoSave(void)
{
 toLoad=false;
 ActivateFileChoose(this,false);
}

void MLevelEditor::DoExit(void)
{
 SetMainResponder(Parent);
}

void MLevelEditor::DoThing(void)
{
 myPOINT mp=mousepos;
 UpdateMousePos(-1,-1,true);
 if(nowEditing==ePlayer) nowEditing=eBackground;
  else nowEditing=MEditing(int(nowEditing)+1);
 ReinitChooses();
 RedrawTopThings();
 UpdateMousePos(mp.x,mp.y,true);
}

void MLevelEditor::DoTheme(void)
{
 myPOINT mp=mousepos;
 UpdateMousePos(-1,-1,true);
 UINT mthemeID;
 switch(nowEditing)
   {
    case eBackground:
	  mthemeID=Map.GetBackgroundTheme()+1;
      if(mthemeID<=0||!ExistThemeBitmap(mthemeID,"TOOL")) mthemeID=1;
	  Map.ChangeBackgroundTheme(mthemeID);
	  Map.DrawMap();
	  break;
	case eGround:
	case eWall:
	case eBox:
	case eTNT:
	case eExit:
	case eStone:
	case eTool:
	case eKeys:
	case eDoors:
	case ePlayer:
	  themeID++;
      if(themeID<=0||!ExistThemeBitmap(themeID,"TOOL")) themeID=0;
	  ReinitChooses();
	  RedrawTopThings();
	  break;
   }
 UpdateMousePos(mp.x,mp.y,true);
}

void MLevelEditor::DoRotate(void)
{
 myPOINT mp=mousepos;
 UpdateMousePos(-1,-1,true);
 rotation=(rotation+1)%4;
 UpdateMousePos(mp.x,mp.y,true);
}

//-----------------------------------------------------------------------------

MLevelEditor LevelEditor;

MResponder *GetLevelEditor(void)
{
 LevelEditor.Parent=GetMainMenu();
 return &LevelEditor;
}

