#include "berdy.h"
#include "MBitmaps.h"
#include <vector>
#include "sound.h"
#include <stdarg.h>

using namespace std;

class MFont
{
 private:
   vector<MBitmap *> fnt;
   int mezerawidth;
   int maxheight;
 public:
   MFont();
   ~MFont();

   MyHDC drawAt;

   int GetMaxHeight(void);
   MBitmap *GetZnak(unsigned char pos);
   void Initialize(void);
   void Clear(void);
   bool Print(int px, int py, const char *buff, int maxchars, int *fromPos, int *lastPos, myPOINT *startxy, myPOINT *lastxy, bool justtest, int newlineplus=2, const myLPRECT clipRegion=NULL);
};

MFont::MFont(){maxheight=0;drawAt=NULL;}
MFont::~MFont(){Clear();}

int MFont::GetMaxHeight(void){return maxheight;}

MBitmap *MFont::GetZnak(unsigned char pos)
{
 if(/*pos>=0&&*/pos<fnt.size()) return fnt[pos];
 return NULL;
}

#ifndef MAX_PATH
#define MAX_PATH 1024
#endif

void MFont::Initialize(void)
{
 if(!fnt.empty()) return;
 mezerawidth=10;
 maxheight=0;
 char file[MAX_PATH];
 MBitmap *obj;
 unsigned int s;
 for(s=0;s<256;s++)
   {
    obj=NULL;
    if(s!=0x0d&&s!=0x0a&&s!=0x09)
	  {
	   obj=new MBitmap;
	   sprintf(file,"FONTY%s%03d","\\",s);
	   if(!LoadBitmap(obj,file,true,true))
	     {
		  delete obj; obj=NULL;
		 }
		else
		 {
		  if(obj)
		    {
		     mySIZE sz;
		     obj->GetSize(sz);
		     if(s==32)
		       {
			    mezerawidth=sz.cx;
				delete obj; obj=NULL;
			   }
			 if(maxheight<sz.cy) maxheight=sz.cy;
			}
		 }
	  }
	fnt.push_back(obj);
   }
}

void MFont::Clear(void)
{
 while(!fnt.empty())
   {
    MBitmap *obj=fnt[0];
	fnt.erase(fnt.begin());
	if(obj) delete obj;
   }
 drawAt=NULL;
}

bool MFont::Print(int px, int py, const char *buff, int maxchars, int *fromPos, int *lastPos, myPOINT *startxy, myPOINT *lastxy, bool justtest, int newlineplus, const myLPRECT clipRegion)
{
 if(fnt.empty()) Initialize();
 if(!buff) return false;

 int x=px,y=py;
 if(startxy)
   {
    x=startxy->x; y=startxy->y;
   }
 mySIZE sz={0,0};
 MBitmap *bmp;
 int pos=0; if(fromPos) pos=*fromPos;
 unsigned char f,s,mz;
 const unsigned char NIC=0, HACEK=161, CARKA=180, KROUZEK=176, TECKA=255;
 myPOINT pt={0,0};

 while(pos<10240&&buff[pos]!=0&&(maxchars==-1||maxchars>0))
   {
    f=buff[pos]; s=NIC;
	mz=f;
	switch(f)
	  {
	   case 138: f='S'; s=HACEK; break;
	   //case '': f='S'; s=CARKA; break;
	   //case '': f='S'; break;
	   case 154: f='s'; s=HACEK; break;
	   //case '': f='s'; s=CARKA; break;
	   //case '': f='s'; break;
	   case 141: f='T'; s=HACEK; break;
	   //case '': f='T'; break;
	   //case 't': f='t'; break;
	   case 157: f='t'; s=HACEK; break;
	   //case '': f='t'; break;
	   case 142: f='Z'; s=HACEK; break;
	   //case '': f='Z'; s=CARKA; break;
	   //case '': f='Z'; s=TECKA; break;
	   case 158: f='z'; s=HACEK; break;
	   //case '': f='z'; s=CARKA; break;
	   //case '': f='z'; s=TECKA; break;
	   //case '': f='L'; break;
	   //case '': f='L'; s=CARKA; break;
	   //case '': f='L'; s=HACEK; break;
	   //case '': f='l'; break;
	   //case '': f='l'; s=CARKA; break;
	   //case '': f='l'; s=HACEK; break;
	   //case '': f='A'; break;
	   case 193: f='A'; s=CARKA; break;
	   //case '': f='A'; break;
	   //case '': f='A'; s=HACEK; break;
	   //case '': f='A'; break;
	   //case '': f='a'; break;
	   case 225: f='a'; s=CARKA; break;
	   //case '': f='a'; break;
	   //case '': f='a'; s=HACEK; break;
	   //case '': f='a'; break;
	   //case 'c': f='c'; break;
	   //case 'R': f='R'; break;
	   //case '': f='R'; s=CARKA; break;
	   case 216: f='R'; s=HACEK; break;
	   //case '': f='r'; s=CARKA; break;
	   case 248: f='r'; s=HACEK; break;
	   //case 'u': f='u'; break;
	   //case '': f='C'; s=CARKA; break;
	   //case '': f='C'; break;
	   case 200: f='C'; s=HACEK; break;
	   //case '': f='c'; s=CARKA; break;
	   //case '': f='c'; break;
	   case 232: f='c'; s=HACEK; break;
	   case 201: f='E'; s=CARKA; break;
	   //case '': f='E'; break;
	   //case '': f='E'; break;
	   case 204: f='E'; s=HACEK; break;
	   case 233: f='e'; s=CARKA; break;
	   //case '': f='e'; break;
	   //case '': f='e'; break;
	   case 236: f='e'; s=HACEK; break;
	   case 205: f='I'; s=CARKA; break;
	   //case '': f='I'; break;
	   case 237: f='i'; s=CARKA; break;
	   //case '': f='i'; break;
	   case 207: f='D'; s=HACEK; break;
	   //case '': f='D'; break;
	   case 239: f='d'; s=HACEK; break;
	   //case '': f='d'; break;
	   //case '': f='N'; s=CARKA; break;
	   case 210: f='N'; s=HACEK; break;
	   //case '': f='n'; s=CARKA; break;
	   case 242: f='n'; s=HACEK; break;
	   case 211: f='O'; s=CARKA; break;
	   //case '': f='O'; break;
	   //case '': f='O'; break;
	   //case '': f='O'; break;
	   case 243: f='o'; s=CARKA; break;
	   //case '': f='o'; break;
	   //case '': f='o'; break;
	   //case '': f='o'; break;
	   case 217: f='U'; s=KROUZEK; break;
	   case 218: f='U'; s=CARKA; break;
	   //case '': f='U'; break;
	   //case '': f='U'; break;
	   case 249: f='u'; s=KROUZEK; break;
	   case 250: f='u'; s=CARKA; break;
	   //case '': f='u'; break;
	   //case '': f='u'; break;
	   case 221: f='Y'; s=CARKA; break;
	   case 253: f='y'; s=CARKA; break;
	  }
    if(maxchars>0) maxchars--;
	if(f==0x0d||f==0x0a||f==0x09||f==0x20)
	  {
	   if(f==0x09)
	     {
		  x+=4*mezerawidth;
		 }
		else
		 {
		  if(f!=0x0d)
		    {
			 if(f==0x20)
			   {
			    x+=mezerawidth;
			   }
			  else
			   {
	            x=px;
	            y+=maxheight+newlineplus;
			   }
			}
		 }
	  }
	 else
	  {
	   bmp=GetZnak(mz);
	   if(!bmp)
	     {
		  bmp=GetZnak(f);
		 }
	   if(!bmp)
	     {
   	      if(f>='a'&&f<='z') 
	        {
		     f-=32;
			 bmp=GetZnak(f);
		    }
	     }
	   if(bmp)
	     {
	      bmp->GetSize(sz);
	      if(!justtest) 
		    {
			 if(!drawAt) ScreenDrawBitmap(bmp,x,y,clipRegion);
			  else
			   {
			    myRECT desr={x,y,x+sz.cx,y+sz.cy};
			    //MyHDC dc=drawAt->BeginPaint();
				bmp->Draw(drawAt,&desr);
				//drawAt->EndPaint();
			   }
			}
	      if(s!=NIC&&!justtest)
	        {
			 bmp=GetZnak(s);
		     if(bmp)
		       {
			    mySIZE ssz;
			    bmp->GetSize(ssz);
				int plus_x=((sz.cx-ssz.cx)/2)-1+((s==CARKA||s==HACEK)?2:0)-((s==KROUZEK)?2:0);
			    if(!drawAt) ScreenDrawBitmap(bmp,x+plus_x,y,clipRegion);
				 else
				  {
			       myRECT desr={x+plus_x,y,x+plus_x+sz.cx,y+sz.cy};
			       //MyHDC dc=drawAt->BeginPaint();
				   bmp->Draw(drawAt,&desr);
				   //drawAt->EndPaint();
				  }
			   }
		    }
	      x+=sz.cx;
		 }
	  }
	pos++;
   }
 if(lastxy)
   {
    lastxy->x=x; lastxy->y=y;
   }
 if(lastPos)
   {
    *lastPos=pos;
   }

 return true;
}

//-----------------------------------------------------------------------------

MFont Font;

void InitFont(void)
{
 Font.Clear();
 Font.Initialize();
}

bool PrintTextFmt(int px, int py, const char *format,...)
{
 if(!format) return false;
 va_list args;
 va_start(args,format);
 char buff[10240+1];
 vsprintf(buff,format,args);
 va_end(args);
 return PrintText(px,py,buff);
}
/*
do maxchars se nepocita ani enter ani tabulator
*/
bool PrintText(int px, int py, const char *buff,int maxchars, int *fromPos, int *lastPos, myPOINT *startxy, myPOINT *lastxy, const myLPRECT clipRegion)
{
 return Font.Print(px,py,buff, maxchars,fromPos,lastPos,startxy,lastxy,false,3,clipRegion);
}

bool PrintTextAlign(int px, int py, const char *text)
{
 if(!text) return false;
 bool center=false, right=false;
 if(text[0]=='#') center=true;
  else if(text[0]=='$') right=true;
 int x=px;
 if(center||right)
   {
    text++;
    myPOINT lp;
    if(!Font.Print(0,0,text,-1,NULL,NULL,NULL,&lp,true)) return false;
    mySIZE sz;
    ScreenGetSize(sz);
    if(center) x=(sz.cx-lp.x-2*px)/2;
	 else x=sz.cx-lp.x-px;
   }
 return Font.Print(x,py,text,-1,NULL,NULL,NULL,NULL,false);
}

bool PrintTextTwoColBlock(int px, int py, const char *text, const char *inter, int newrowplus, bool firstrowalign, char interznak)
{
 if(!text) return false;

 char *tt=strdup(text);
 char *t=tt;
 if(firstrowalign)
   {
    char *p=strchr(t,'\n');
	if(p)
	  {
	   myPOINT l;
	   p[0]=0;
	   if(Font.Print(px,py,t,-1,NULL,NULL,NULL,&l,true,newrowplus))
	     {
		  if(PrintTextAlign(px,py,t)) py=l.y+newrowplus;
		 }
	   p[0]='\n';
	   t=p;
	  }
   }
 myPOINT lxy;
 Font.Print(0,0,inter,-1,NULL,NULL,NULL,&lxy,true);
 int interwidth=lxy.x;
 int maxright=0;
 int ipos;
 char *p=t,*p2=NULL;
 while(p)
   {
    p2=strchr(p,interznak);
	if(p2){p2++; p=p2;}
	if(p)
	  {
	   p2=strchr(p,'\n');
	   if(p2) p2[0]=0;
	   Font.Print(px,0,p,-1,NULL,NULL,NULL,&lxy,true);
	   if(maxright<lxy.x) maxright=lxy.x;
	   if(p2)
	     {
		  p2[0]='\n';
		  p=p2+1;
		 }
	    else p=NULL;
	  }
   }
 mySIZE sz;
 ScreenGetSize(sz);
 maxright=sz.cx-maxright-px;
 lxy.x=px; lxy.y=py;
 p=t; p2=NULL;
 while(p)
   {
    p2=strchr(p,interznak);
	if(p2)
	  {
	   p2[0]=0;
	   Font.Print(px,py,p,-1,NULL,NULL,&lxy,&lxy,false,newrowplus);
	   p2[0]=interznak;
	   p=p2+1;
	   if(lxy.x<maxright)
	     {
		  ipos=maxright;
		  while(ipos=ipos-interwidth, ipos>=lxy.x)
		    {
			 Font.Print(ipos,lxy.y,inter,-1,NULL,NULL,NULL,NULL,false,newrowplus);
			}
		  lxy.x=maxright;
		 }
	  }
	 else 
	  {
	   p2=p;
	   p=NULL;
	  }
   }
 if(p2)
   {
    Font.Print(px,py,p2,-1,NULL,NULL,&lxy,NULL,false,newrowplus);
   }
 //Font.Print(px,py,text,-1,NULL,NULL,NULL,NULL,false,newrowplus);
 if(tt) free(tt);
 return false;
}

//--------------------------------------------------------------------------------------

class MScreenCursor
{
 private:
   MBitmap cursor;
   MBitmap background;
   int lx,ly; //posledni pozice;
   bool visible; //jestli je prave videt
 public:
   MScreenCursor();
   ~MScreenCursor();

   void Draw(int x, int y,bool pShow);
};

MScreenCursor::MScreenCursor()
{
 lx=-1; ly=-1;
 visible=false;
}

MScreenCursor::~MScreenCursor(){}

void MScreenCursor::Draw(int x, int y,bool pShow)
{
 if(cursor.IsEmpty())
   {
    MBitmap *b=Font.GetZnak((unsigned char)'_');
	if(b)
	  {
	   cursor.Assign(b);
	  }
	cursor.UpdateMask(0,0);
	mySIZE sz;
	cursor.GetSize(sz);
	if(sz.cx>0&&sz.cy>0)
	  {
	   background.Create(sz.cx,sz.cy);
	  }
   }
 if(!visible&&!pShow) return;
 if(visible)
   {
    if(x==lx&&y==ly&&pShow) return;
	ScreenDrawBitmap(&background,lx,ly);
	visible=false;
   }
 if(!pShow) return;
 lx=x; ly=y;
 visible=true;
 ScreenGetBitmap(&background,x,y);
 ScreenDrawBitmap(&cursor,x,y);
}


MScreenCursor cur;

void ScreenDrawCursor(int x, int y, bool pShow)
{
 cur.Draw(x,y,pShow);
}

//------------------------------------------------------------------------------------

MTextScrollerLine::MTextScrollerLine(){text=NULL; bmp=NULL;offset.left=0; offset.top=0;offset.right=0; offset.bottom=0;}
MTextScrollerLine::~MTextScrollerLine()
{
 text=NULL;
 if(bmp) delete bmp; bmp=NULL;
}

//------------------------------------------------------------------------------------
MTextScroller::MTextScroller()
{
 File=NULL;
 Text=NULL;
 backFile=NULL;
 backbmp=NULL;
 upperbackbmp=NULL;
 headerbmp=NULL;
 header=NULL;
 backoffset.x=0; backoffset.y=0;
 lnfrom=0;
 clipRegion.left=0; clipRegion.top=0;
 clipRegion.right=0; clipRegion.bottom=0;
 headeroffset.x=0;  headeroffset.y=0;
 upperbackoffset.x=0; upperbackoffset.y=0;
 major=0;
 minor=0;
 canfromfile=true;
 canappend=false;
 UseClipRegion=&clipRegion;
}

MTextScroller::MTextScroller(const char *hdr, int hdrx, int hdry, int clipx, int clipy, int clipwidth, int clipheight, const char *txtfile, UINT txtmajor, UINT txtminor, bool pcanfromfile, bool pcanappend)
   :MResponder()
{
 File=NULL;
 Text=NULL;
 upperbackbmp=NULL;
 headerbmp=NULL;
 header=NULL;
 backFile=NULL;
 backbmp=NULL;
 lnfrom=0;
 clipRegion.left=0; clipRegion.top=0;
 clipRegion.right=0; clipRegion.bottom=0;
 UseClipRegion=&clipRegion;
 headeroffset.x=0;  headeroffset.y=0;
 upperbackoffset.x=0; upperbackoffset.y=0;
 major=0;
 minor=0;
 canfromfile=true;
 canappend=false;
 Initialize(hdr,hdrx,hdry, clipx,clipy,clipwidth,clipheight, txtfile,txtmajor,txtminor,pcanfromfile,pcanappend);
}

MTextScroller::~MTextScroller()
{
 Clear();
}

void MTextScroller::Initialize(const char *hdr, int hdrx, int hdry, int clipx, int clipy, int clipwidth, int clipheight, const char *txtfile, UINT txtmajor, UINT txtminor, bool pcanfromfile, bool pcanappend)
{
 SetHeader(NULL);
 //SetBackground(NULL);
 SetTextFile(NULL);
 ClearLines(true);
 if(upperbackbmp) delete upperbackbmp; upperbackbmp=NULL;
 
 SetHeader(hdr); headeroffset.x=hdrx;  headeroffset.y=hdry;
 //SetBackground(bck); backoffset.x=bckx; backoffset.y=bcky;
 
 clipRegion.left=clipx; clipRegion.top=clipy;
 clipRegion.right=clipRegion.left+clipwidth; clipRegion.bottom=clipRegion.top+clipheight;

 SetTextFile(txtfile);
 major=txtmajor;
 minor=txtminor;
 canfromfile=pcanfromfile;
 canappend=pcanappend;
}

void MTextScroller::Clear(void)
{
 SetHeader(NULL);
 SetBackground(NULL);
 SetTextFile(NULL);
 ClearLines(true);
 if(Text) free(Text); Text=NULL;
 if(upperbackbmp) delete upperbackbmp; upperbackbmp=NULL;
 if(headerbmp) delete headerbmp; headerbmp=NULL;
 if(backbmp) delete backbmp; backbmp=NULL;
}

void MTextScroller::ClearLines(bool AlsoText)
{
 if(AlsoText) {if(Text) free(Text); Text=NULL;}
 MTextScrollerLine *p;
 while(!lines.empty())
   {
    p=lines[0];	lines.erase(lines.begin());
	if(p) delete p;
   }
}


void MTextScroller::SetHeader(const char *file)
{
 if(header) free(header); header=NULL;
 if(file) header=strdup(file);
}
const char *MTextScroller::GetHeader(void){return header;}

void MTextScroller::SetBackground(const char *file)
{
 if(backFile) free(backFile); backFile=NULL;
 if(file) backFile=strdup(file);
}
const char *MTextScroller::GetBackground(void){return backFile;}

void MTextScroller::SetTextFile(const char *textFile)
{
 if(File) free(File); File=NULL;
 if(textFile) File=strdup(textFile);
}
const char *MTextScroller::GetTextFile(void){return File;}

#define SCROLL_PIXEL_STEP 1


void MTextScroller::BreakTextToLines(void)
{
 ClearLines(false);
 if(!Text) return;
 UseClipRegion=&clipRegion;
 if(backFile) 
   {
	if(!backbmp) backbmp=new MBitmap();
	if(backbmp)
	  {
	   if(LoadBitmap(backbmp,backFile,false))
	     {
		  UseClipRegion=NULL;
		 }
		else
		 {
		  delete backbmp;
		  backbmp=NULL;
		 }
	  }
   }

 mySIZE sz;
 ScreenGetSize(sz);
 char *t,*p;
 t=Text;
 while(t)
   {
    p=strchr(t,'\n');
	if(p){p[0]=0; p++;}
	MTextScrollerLine *ln=new MTextScrollerLine;
	if(ln)
	  {
	   ln->text=t;
	   //ln->bmp=new MBitmap;
	   ln->offset.left=0;
	   ln->offset.top=clipRegion.top+lines.size()*(2+Font.GetMaxHeight());
	   //if(ln->bmp)
	     {
		  //Font.drawAt=ln->bmp->BeginPaint();
		  myPOINT lxy;
		  if(Font.Print(0,0,t,-1,NULL,NULL,NULL,&lxy,true,3,NULL))
		    {
			 ln->offset.left=(sz.cx-lxy.x)/2;
			 lxy.y+=Font.GetMaxHeight()+SCROLL_PIXEL_STEP;
			 
			 ln->offset.right=ln->offset.left+lxy.x;
			 ln->offset.bottom=ln->offset.top+lxy.y;

			 /*if(ln->bmp->Create(lxy.x,lxy.y))
			   {
				myRECT r={0,0,lxy.x,lxy.y};
				DrawRect(ln->bmp,&r);
				PrintText(0,0,ln->text);
				if(backbmp) ln->bmp->UpdateMask(0,0);
			   }*/
			}
		  //Font.drawAt=NULL; delete ln->bmp; ln->bmp=NULL;
		 }
	   lines.push_back(ln);
	  }
	t=p;
   }
}

void MTextScroller::DoStep(void)
{
 if(lnfrom>=lines.size())
   {
    Stop();
	return;
   }
 mySIZE backsz;
 if(backbmp)
   {
    backbmp->GetSize(backsz);
   }
  else
   {
    backsz.cx=-1;
	backsz.cy=-1;
   }
 UINT pos=lnfrom;
 MTextScrollerLine *p;
 while(pos<lines.size())
   {
    p=lines[pos];
	if(p)
	  {
	   p->offset.top-=SCROLL_PIXEL_STEP;
	   p->offset.bottom-=SCROLL_PIXEL_STEP;
	   if(backbmp&&p->offset.top<backoffset.y+backsz.cy)
	     {
		  ScreenDrawBitmap(backbmp,backoffset.x,backoffset.y,&p->offset);
		 }
	   if(p->offset.top<clipRegion.bottom) 
	     {
		  if(!p->bmp)
		    {
			 p->bmp=new MBitmap;
			 if(p->bmp&&p->bmp->Create(p->offset.right-p->offset.left,p->offset.bottom-p->offset.top))
			   {
				myRECT r={0,0,p->offset.right-p->offset.left,p->offset.bottom-p->offset.top};
				DrawRect(p->bmp,&r);
				Font.drawAt=p->bmp->BeginPaint();
				PrintText(0,0,p->text);
				Font.drawAt=NULL;
				p->bmp->EndPaint();
				if(backbmp) p->bmp->UpdateMask(0,0);
			   }
			}
		  ScreenDrawBitmap(p->bmp,&(p->offset)/*p->offset.left,p->offset.top*/,UseClipRegion);
		  //PrintText(p->offset.left,p->offset.top,p->text);
		 }
	   if(p->offset.top+Font.GetMaxHeight()<clipRegion.top)
	     {
		  lnfrom=pos+1;
		  if(p->bmp) delete p->bmp;
		  p->bmp=NULL;
		 }
	  }
    pos++;
   }
 if(upperbackbmp) ScreenDrawBitmap(upperbackbmp,upperbackoffset.x,upperbackoffset.y,UseClipRegion);
}

void MTextScroller::Stop(void)
{
 SetMainResponder(Parent);
}

void MTextScroller::KeyPress(UINT Key,UINT butts)
{
 switch(Key)
   {
    case KEY_ESCAPE:
	case KEY_SPACE:
	case KEY_RETURN:
	case KEY_SELECT:
	  Stop();
	  break;
   }
}

void MTextScroller::MouseMove(int x, int y, UINT butts){}
void MTextScroller::MouseLeft(int x, int y, UINT butts){}
void MTextScroller::MouseMiddle(int x, int y, UINT butts){}
void MTextScroller::MouseRight(int x, int y, UINT butts){}

void MTextScroller::OnAnimTimer(UINT timerID)
{
 switch(timerID)
   {
    case ANIM_TIMER1:
	  DoStep();
	  break;
   }
}

void MTextScroller::OnActivate(MResponder *resp)
{
 if(Text) free(Text);
 Text=LoadText(GetTextFile(),major,minor,canfromfile,canappend);
 BreakTextToLines();
 if(GetBackground())
   {
    if(!backbmp) backbmp=new MBitmap;
    LoadBitmap(backbmp,GetBackground());
   }
  else
   {
    if(!backbmp) delete backbmp; backbmp=NULL;
   }
 if(GetHeader())
   {
    if(!headerbmp) headerbmp=new MBitmap;
    LoadBitmap(headerbmp,GetHeader());
   }
  else
   {
    if(headerbmp) delete headerbmp;
	headerbmp=NULL;
   }
 lnfrom=0;
 if(headerbmp)
   {
    mySIZE sz;
	headerbmp->GetSize(sz);
	if(headeroffset.y+sz.cy>clipRegion.top)
	  {
	   upperbackoffset.x=headeroffset.x;
	   upperbackoffset.y=clipRegion.top;
	   if(!upperbackbmp) upperbackbmp=new MBitmap;
	   if(upperbackbmp)
	     {
		  if(upperbackbmp->Create(sz.cx,headeroffset.y+sz.cy-clipRegion.top))
		    {
			 MyHDC dc=upperbackbmp->BeginPaint();
			 myRECT vysek={0,clipRegion.top-headeroffset.y,sz.cx,sz.cy};
			 myRECT r={0,0,vysek.right,vysek.bottom-vysek.top};
			 headerbmp->Draw(dc,&r,&vysek);
			 upperbackbmp->EndPaint();
			 upperbackbmp->UpdateMask(0,0);
			}
		 }
	  }
   }

 ScreenClearRect();
 if(upperbackbmp) ScreenDrawBitmap(upperbackbmp,upperbackoffset.x,upperbackoffset.y);
 if(headerbmp) ScreenDrawBitmap(headerbmp,headeroffset.x, headeroffset.y);
 if(backbmp) ScreenDrawBitmap(backbmp,backoffset.x,backoffset.y);

 SetAnimTimerElapsed(ANIM_TIMER1,TEXTSCROLL_DELAY);
 SetAnimTimerEnabled(ANIM_TIMER1, true);
}

void MTextScroller::OnDeactivate(MResponder *resp)
{
 SetAnimTimerEnabled(ANIM_TIMER1, false);
 if(Text) free(Text); Text=NULL;
 if(upperbackbmp) delete upperbackbmp; upperbackbmp=NULL;
 if(headerbmp) delete headerbmp; headerbmp=NULL;
 if(backbmp) delete backbmp; backbmp=NULL;
 ScreenClearRect();
}

//------------------------------------------------------------------------------------
//responder, ktery ma u sebe uvedeno, ze kdyz se zmackla klavesa ci mys, tak bylo Abort
class MAbortResponder:public MResponder
{
 private:
   bool aborted;
 protected:
   bool canskip;
 public:
   MAbortResponder();
   virtual ~MAbortResponder();

   bool Aborted(void); //jestli bylo preruseno uzivatelem
   void SetAborted(bool pval);

   void KeyPress(UINT Key,UINT butts);
   void MouseMove(int x, int y, UINT butts);
   void MouseLeft(int x, int y, UINT butts);
   void MouseMiddle(int x, int y, UINT butts);
   void MouseRight(int x, int y, UINT butts);
};

MAbortResponder::MAbortResponder(){aborted=true; canskip=true;}
MAbortResponder::~MAbortResponder(){}

bool MAbortResponder::Aborted(void){return aborted;}
void MAbortResponder::SetAborted(bool pval){aborted=pval;}
void MAbortResponder::KeyPress(UINT Key,UINT butts)
{
 if(canskip){
    if(Key!=0) aborted=true;
 }
}

void MAbortResponder::MouseMove(int x, int y, UINT butts){}
void MAbortResponder::MouseLeft(int x, int y, UINT butts)
{
 if(canskip&&((butts&MOUSE_BUTT_LEFT)!=0)){
    aborted=true;
 }
}
void MAbortResponder::MouseMiddle(int x, int y, UINT butts)
{
 if(canskip&&((butts&MOUSE_BUTT_MIDDLE)!=0)){
    aborted=true;
 }
}
void MAbortResponder::MouseRight(int x, int y, UINT butts)
{
 if(canskip&&((butts&MOUSE_BUTT_RIGHT)!=0)){
    aborted=true;
 }
}
//------------------------------------------------------------------------------------

class MTextTyper:public MAbortResponder
{
 private:
   const char *text; //jen si pujcuje tento ukazatel, nealokuje ho znovu
   myPOINT pos;
   int frompos;
   bool showed;
 public:
   MTextTyper();
   virtual ~MTextTyper();

   void Initialize(MResponder *par, const char *ptext,int x, int y, bool center);
   void DoStep(void);

   void OnAnimTimer(UINT timerID);
   void OnActivate(MResponder *resp);
   void OnDeactivate(MResponder *resp);
};

MTextTyper::MTextTyper(){text=NULL; pos.x=0; pos.y=0; frompos=0; showed=false;}
MTextTyper::~MTextTyper(){}

void MTextTyper::Initialize(MResponder *par, const char *ptext,int x, int y, bool center)
{
 Parent=par;
 text=ptext;
 pos.x=x; pos.y=y;
 SetAborted(text==NULL);
 showed=false;
 frompos=0;
 if(!Aborted()&&center)
   {
    myPOINT lxy;
    Font.Print(0,0,text,-1,NULL,NULL,NULL,&lxy,true);
	mySIZE sz;
	ScreenGetSize(sz);
	pos.x=(sz.cx-lxy.x)/2;
   }
}

void MTextTyper::DoStep(void)
{
 if(Aborted()||text==NULL||text[frompos]==0)
   {
    SetMainResponder(Parent);
	return;
   }
 ScreenDrawCursor(pos.x, pos.y,false);
 Font.Print(pos.x,pos.y,text,1,&frompos,NULL,&pos,&pos,false);
 ScreenDrawCursor(pos.x, pos.y,showed);
 if(text[frompos]!=0) frompos++;
 PlaySfx(SFX_MENU_KLIK,SFX_PRIORITY3);
}

void MTextTyper::OnAnimTimer(UINT timerID)
{
 if(Aborted())
   {
    SetMainResponder(Parent);
	return;
   }
 switch(timerID)
   {
    case ANIM_TIMER1:
	  DoStep();
	  break;
	case ANIM_TIMER2:
      ScreenDrawCursor(pos.x, pos.y,false);
	  showed=!showed;
      ScreenDrawCursor(pos.x, pos.y,showed);
	  break;
   }
}

void MTextTyper::OnActivate(MResponder *resp)
{
 SetAnimTimerElapsed(ANIM_TIMER1,150);
 SetAnimTimerEnabled(ANIM_TIMER1,true);
 SetAnimTimerElapsed(ANIM_TIMER2,75);
 //SetAnimTimerEnabled(ANIM_TIMER2,true);
 showed=true;
 ScreenDrawCursor(pos.x, pos.y,showed);
}

void MTextTyper::OnDeactivate(MResponder *resp)
{
 SetAnimTimerEnabled(ANIM_TIMER1,false);
 SetAnimTimerEnabled(ANIM_TIMER2,false);
 ScreenDrawCursor(pos.x, pos.y,false);
}

//-----------------------------------------------------------------------------

MTextTyper TextTyper;

//-----------------------------------------------------------------------------

void TypeText(MResponder *parent, const char *text, int x, int y, bool center)
{
 TextTyper.Initialize(parent,text,x,y,center);
 SetMainResponder(&TextTyper);
}

bool TypeTextAborted(void)
{
 return TextTyper.Aborted();
}

//-----------------------------------------------------------------------------

class MShowBitmapShut:public MAbortResponder
{
 private:
   MBitmap bmp;
   bool up_type;
   bool second_stage;
   bool done;
   mySIZE sz;
   myRECT where, clip;
 public:
   MShowBitmapShut();
   virtual ~MShowBitmapShut();

   void Initialize(MResponder *par,const char *bitmapname, bool up, bool pcanskip);
   void DoStep(void);

   void OnAnimTimer(UINT timerID);
   void OnActivate(MResponder *resp);
   void OnDeactivate(MResponder *resp);
};

MShowBitmapShut::MShowBitmapShut(){up_type=false;second_stage=false; done=true; canskip=true;}
MShowBitmapShut::~MShowBitmapShut(){}

void MShowBitmapShut::Initialize(MResponder *par,const char *bitmapname, bool up, bool pcanskip)
{
 Parent=par;
 SetAborted(false);
 ScreenGetSize(sz);
 if(!bmp.Create(sz.cx,sz.cy))
   {
    SetAborted(true);
	return;
   }
 DrawRect(&bmp,NULL,0,0,0);
 up_type=up;
 second_stage=false;
 canskip=pcanskip;
 if(bitmapname)
   {
    MBitmap b;
	if(!LoadBitmap(&b,bitmapname,false))
	  {
	   second_stage=true;
	  }
	 else
	  {
	   mySIZE s;
	   b.GetSize(s);
	   myRECT r={(sz.cx-s.cx)/2,(sz.cy-s.cy)/2,s.cx+(sz.cx-s.cx)/2,s.cy+(sz.cy-s.cy)/2};
	   MyHDC dc=bmp.BeginPaint();
	   b.Draw(dc,&r);
	   bmp.EndPaint();
	  }
   }
 done=false;
 if(up)
   {
    clip.top=(sz.cy/2)-2;
    if(second_stage)
	  {
	   clip.left=0;
	   clip.right=sz.cx;
	  }
	 else
	  {
	   clip.left=(sz.cx/2)-1;
	   clip.right=clip.left+2;
	  }
	clip.bottom=clip.top+4;
    where=clip;
    where.left=0;
    where.right=sz.cx;
   }
  else
   {
    clip.left=0; clip.top=-4;
	clip.right=sz.cx; clip.bottom=clip.top+4;
	where.left=clip.left; where.right=clip.right;
	where.top=sz.cy;
	where.bottom=where.top+4;
   }
}

void MShowBitmapShut::DoStep(void)
{
 if(Aborted()||done)
   {
    SetMainResponder(Parent);
    return;
   }
 if(up_type)
   {
    if(!second_stage)
	  {
	   if(clip.left>0)
	     {
		  clip.left-=4;
		  clip.right+=4;
		  if(clip.left<where.left) clip.left=where.left;
		  if(clip.right>where.right) clip.right=where.right;
		  ScreenDrawBitmap(&bmp,0,0,&clip);
		 }
		else
		 {
		  second_stage=true;
		  clip.left=where.left;
		  clip.right=where.right;
		 }
	  }
	 else
	  {
	   if(clip.top>0)
	     {
		  int h=clip.bottom-clip.top;
		  clip.top-=h;
		  clip.bottom-=h;
		  ScreenDrawBitmap(&bmp,0,0,&clip);
		  where.top+=h;
		  where.bottom+=h;
		  ScreenDrawBitmap(&bmp,0,0,&where);
		 }
		else
		 {
		  done=true;
		 }
	  }
   }
  else
   {
    if(clip.top<where.top)
	  {
	   int h=clip.bottom-clip.top;
	   clip.top+=h;
	   clip.bottom+=h;
	   ScreenDrawBitmap(&bmp,0,0,&clip);
	   where.top-=h;
	   where.bottom-=h;
	   ScreenDrawBitmap(&bmp,0,0,&where);
      }
	 else
	  {
	   done=true;
	  }
   }
}

void MShowBitmapShut::OnAnimTimer(UINT timerID)
{
 switch(timerID)
   {
    case ANIM_TIMER1:
	  DoStep();
	  break;
   }
}

void MShowBitmapShut::OnActivate(MResponder *resp)
{
 SetAnimTimerElapsed(ANIM_TIMER1,30);
 SetAnimTimerEnabled(ANIM_TIMER1,true);
}

void MShowBitmapShut::OnDeactivate(MResponder *resp)
{
 SetAnimTimerEnabled(ANIM_TIMER1,false);
}

//-----------------------------------------------------------------------------

MShowBitmapShut ShowBitmapShut;

void DoShowBitmapShut(MResponder *parent, const char *bitmapname, bool up, bool canskip)
{
 ShowBitmapShut.Initialize(parent,bitmapname,up,canskip);
 SetMainResponder(&ShowBitmapShut);
}

bool ShowBitmapShutAborted(void)
{
 return ShowBitmapShut.Aborted();
}

//-----------------------------------------------------------------------------

class MIntro:public MAbortResponder
{
 private:
   int stage;
   char *t;
 public:
   MIntro();
   virtual ~MIntro();

   void Initialize(MResponder *par);
   void DoStep(void);

   void OnAnimTimer(UINT timerID);
   void OnActivate(MResponder *resp);
   void OnDeactivate(MResponder *resp);
};

MIntro::MIntro(){stage=0; t=NULL;}
MIntro::~MIntro(){if(t) free(t); t=NULL;}

void MIntro::Initialize(MResponder *par)
{
 SetAborted(false);
 Parent=par; 
 stage=0;
 if(t) free(t); t=NULL;
}

void MIntro::DoStep(void)
{
 if(t) free(t); t=NULL;
 if(stage>15 ||Aborted())
   {
    SetMainResponder(Parent);
	return;
   }
 switch(stage)
   {
    case 0: DoShowBitmapShut(this,NULL,false); break;
	case 1:
	   SetAborted(ShowBitmapShutAborted());
	   if(!Aborted())
	     {
	      t=LoadText("GAME",3,1);
	      TypeText(this,t,0,180,true);
		 }
	   break;
	case 2:
	   SetAborted(TypeTextAborted());
	   if(!Aborted())
	     {
	      t=LoadText("GAME",3,2);
	      TypeText(this,t,0,210,true);
		 }
	   break;
	case 3:
	   SetAborted(TypeTextAborted());
	   if(!Aborted())
	     {
	      SetAnimTimerElapsed(ANIM_TIMER1,500);
	      SetAnimTimerEnabled(ANIM_TIMER1,true);
		 }
	   break;
	case 4:
	   DoShowBitmapShut(this,"MENU_079",true);
	   break;
	case 5:
	   SetAborted(ShowBitmapShutAborted());
	   if(!Aborted())
	     {
	      t=LoadText("GAME",3,3);
	      TypeText(this,t,0,330,true);
		 }
	   break;
	case 6:
	   SetAborted(TypeTextAborted());
	   if(!Aborted())
	     {
	      SetAnimTimerElapsed(ANIM_TIMER1,2000);
	      SetAnimTimerEnabled(ANIM_TIMER1,true);
		 }
	   break;
	case 7:
	   DoShowBitmapShut(this,"MENU_078",true);
	   break;
	case 8:
	   SetAborted(ShowBitmapShutAborted());
	   if(!Aborted())
	     {
	      t=LoadText("GAME",3,4);
	      TypeText(this,t,0,20,false);
		 }
	   break;
	case 9:
	   SetAborted(TypeTextAborted());
	   if(!Aborted())
	     {
	      SetAnimTimerElapsed(ANIM_TIMER1,150);
	      SetAnimTimerEnabled(ANIM_TIMER1,true);
		 }
	   break;
	case 10:
	   if(!Aborted())
	     {
	      t=LoadText("GAME",3,5);
	      TypeText(this,t,0,40,false);
		 }
	   break;
	case 11:
	   SetAborted(TypeTextAborted());
	   if(!Aborted())
	     {
	      SetAnimTimerElapsed(ANIM_TIMER1,150);
	      SetAnimTimerEnabled(ANIM_TIMER1,true);
		 }
	   break;
	case 12:
	   t=LoadText("GAME",3,6);
	   TypeText(this,t,360,440,false);
	   break;
	case 13:
	   SetAborted(TypeTextAborted());
	   if(!Aborted())
	     {
	      t=LoadText("GAME",3,7);
	      TypeText(this,t,360,460,false);
		 }
	   break;
	case 14:
	   SetAborted(TypeTextAborted());
	   if(!Aborted())
	     {
	      SetAnimTimerElapsed(ANIM_TIMER1,2000);
	      SetAnimTimerEnabled(ANIM_TIMER1,true);
		 }
	   break;
    case 15: 
	  SetAborted(TypeTextAborted());
	  if(!Aborted())
	    {
	     DoShowBitmapShut(this,NULL,false); break;
	    }
	  break;
   }
 stage++;
 if(Aborted()) SetMainResponder(Parent);
}

void MIntro::OnAnimTimer(UINT timerID)
{
 switch(timerID)
   {
    case ANIM_TIMER1:
	  DoStep();
	  break;
   }
}

void MIntro::OnActivate(MResponder *resp)
{
 SetAnimTimerEnabled(ANIM_TIMER1,false);
 DoStep();
}

void MIntro::OnDeactivate(MResponder *resp)
{
 SetAnimTimerEnabled(ANIM_TIMER1,false);
 if(resp==Parent||resp==NULL) 
   {
	ScreenClearRect();
    ClearIntro();
   }
}

//-----------------------------------------------------------------------------
MIntro *intro=NULL;

void RunIntro(MResponder *par)
{
 intro=new MIntro;
 if(!intro)
   {
    SetMainResponder(par);
   }
  else
   {
    intro->Initialize(par);
	SetMainResponder(intro);
    hraj_hudbu_intro();
   }
}

void ClearIntro(void)
{
 if(intro) delete intro;
 intro=NULL;
}

//-----------------------------------------------------------------------------
