#include "berdy.h"
#include <string.h>
#include <stdio.h>
#include "datafile.h"

const char *GetDataDir(void);

//--------------------------------------------------------------------------------------

class MTextLoader
{
 private:
   //FILE *f;
 public:
   MTextLoader();
   ~MTextLoader();
   
   /*bool Open(const char *pFileName);
   void Close(void);*/

   void AppendText(char **buff, const char *text);

   //vraci nove alokovany misto pameti, ma uvolnit ten, kdo metodu zavolal
   char *ReadText(MStream *strm, int xorval, UINT major, UINT minor); //nacte text podle identifikaoru "~major_minor"
   char *ReadWholeFile(MStream *strm, int xorval); //vrati cely soubor (od zacatku souboru, at je kde je)
};

//--------------------------------------------------------------------------------------

MTextLoader::MTextLoader()
{
}

MTextLoader::~MTextLoader()
{
// Close();
}

void MTextLoader::AppendText(char **buff, const char *text)
{
 if(!buff||!text) return;
 char *b=*buff,*res;
 int len=0;
 if(b) len+=strlen(b);
 if(text) len+=strlen(text);
 if(len==0) return;
 len++;
 res=(char *)malloc(sizeof(char)*len);
 if(!res) return;
 strcpy(res,"");
 if(b) 
   {
    strcat(res,b);
	free(b);
   }
 if(text) strcat(res,text);
 *buff=res;
}

/*bool MTextLoader::Open(const char *pFileName)
{
 Close();
 if(!pFileName) return false;
 /*char file[MAX_PATH+1];
 strcpy(file,GetDataDir());
 strcat(file,pFileName);* /
 f=fopen(pFileName,"rb");
 return f!=NULL;
}

void MTextLoader::Close(void)
{
}*/

char *MTextLoader::ReadText(MStream *strm, int xorval, UINT major, UINT minor)
{
 if(!strm) return NULL;
 char *res=NULL, tofind[50],ch=0;
 sprintf(tofind,"~%d_%d",major,minor);
 strm->seek(0);
 bool have=false;
 int pos=0;
 while(ch=have?ch:strm->get()^xorval, !strm->eof()&&!have)
   {
    /*if(ch==0x0d||ch==0x0a) 
	  {
	   if(tofind[pos]==0) have=true;
	    else pos=0;
	  }
	 else*/
	  {
	   if(tofind[pos]==0&&(ch==0x0d||ch==0x0a||ch==' ')) 
	     {
		  have=true;
		  while(ch=strm->get()^xorval,!strm->eof()&&(ch==0x0d||ch==0x0a||ch==' '));
		 } 
	    else 
		 {
		  if(tofind[pos]==ch) pos++;
		   else pos=0;
		 }
	  }
   }
 if(have)
   {
    if(ch==' '||ch==0x0d) ch=0;
    const int bufflen=1024;
    char buff[bufflen+1];
	int bpos=0;
	buff[bpos]=0;
	if(ch!=0&&(!(ch==0x0d||ch==0x0a||ch==' ')))
	  {
	   buff[bpos]=ch; bpos++;
	  }
	while(ch=strm->get()^xorval,!strm->eof()&&ch!='~')
	  {
	   if(ch!=0x0d)
	     {
		  buff[bpos]=ch; bpos++;
		  buff[bpos]=0;
		  if(bpos==bufflen)
		    {
			 AppendText(&res,buff);
			 bpos=0;
			}
		 }
	  }
	if(bpos) AppendText(&res,buff);
	if(res)
	  {
	   pos=strlen(res)-1;
	   while(pos>0&&res[pos]=='\n')
	     {
		  res[pos]=0;
		  pos--;
		 }
	  }
   }
 return res;
}

char *MTextLoader::ReadWholeFile(MStream *strm, int xorval)
{
 if(!strm) return NULL;
 char *res=NULL;
 long from=strm->tell();
 strm->seek(0);
 const int bufflen=1024;
 char buff[bufflen+1],ch;
 int bpos=0;
 buff[bpos]=0;
 while(ch=strm->get()^xorval,!strm->eof())
   {
    if(ch!=0x0d)
      {
 	   buff[bpos]=ch; bpos++;
	   buff[bpos]=0;
	   if(bpos==bufflen)
	     {
		  AppendText(&res,buff);
		  bpos=0;
	     }
 	  }
   }
 if(bpos) AppendText(&res,buff);
 if(res)
   {
    bpos=strlen(res)-1;
    while(bpos>0&&res[bpos]=='\n')
      {
	   res[bpos]=0;
	   bpos--;
	  }
   }
 return res;
}

MTextLoader txtLoader;

#ifndef MAX_PATH
#define MAX_PATH 1024
#endif

void ToLower(char *buff);

char *LoadText(const char *file, UINT major, UINT minor, bool canfromfile, bool canappendfromfile)
{
 if(!file) return NULL;
 char buff[MAX_PATH];
 if(canfromfile) strcpy(buff,GetDataDir());
  else strcpy(buff,"Data\\");
 char *pf=strdup(file);
 if(pf)
   {
	ToLower(pf);
	strcat(buff,pf);
   }
  else strcat(buff,file);
 strcat(buff,".txt");
 MStream *s=NULL;
 bool clear_strm=false;
 if(canfromfile)
   {
    MFileStream *fl=new MFileStream();
	if(fl)
	  {
	   if(!fl->open(buff,foBinRead))
	     {
		  delete fl;
	     }
		else
		 {
		  s=fl;
		  clear_strm=true;
		 }
	  }
   }
 if(s==NULL)
   {
    strcpy(buff,"Data\\");
    strcat(buff,file);
    strcat(buff,".TXT");
	s=GetDataFileStream(buff);
   }
 if(!s)
   {
	strcpy(buff,GetDataDir());
	if(pf) strcat(buff,pf);
	 else strcat(buff,file);
	strcat(buff,".txt");
    WriteToLog("Text file open '%s' failed",buff);
	if(pf) free(pf);
    return NULL;
   }
 
 char *res=NULL;
 if(!major||!minor) res=txtLoader.ReadWholeFile(s,clear_strm?0:GetTextFileXorVal());
  else res=txtLoader.ReadText(s,clear_strm?0:GetTextFileXorVal(),major,minor);
 if(clear_strm&&s) delete s;

 if(!res&&clear_strm)
   {
    strcpy(buff,"Data\\");
    strcat(buff,file);
    strcat(buff,".TXT");
	s=GetDataFileStream(buff);
    char *res2=NULL;
    if(!major||!minor) res2=txtLoader.ReadWholeFile(s,GetTextFileXorVal());
     else res2=txtLoader.ReadText(s,GetTextFileXorVal(),major,minor);
	if(res2)
	  {
	   txtLoader.AppendText(&res,res2);
	   free(res2);
	  }
   }
 if(canappendfromfile)
   {
    strcpy(buff,GetDataDir());
    if(pf) strcat(buff,pf);
	 else strcat(buff,file);
    strcat(buff,".txt");
    MFileStream *fl=new MFileStream();
	if(fl)
	  {
	   if(fl->open(buff,foBinRead))
	     {
		  txtLoader.AppendText(&res,"\n\n\n\n");
		  char *res2=NULL;
          if(!major||!minor) res2=txtLoader.ReadWholeFile(fl,0);
           else res2=txtLoader.ReadText(fl,0,major,minor);
	      if(res2)
		    {
		     txtLoader.AppendText(&res,res2);
			 free(res2);
			}
	     }
	   delete fl;
	  }
   }

 if(!res) WriteToLog("Read from text file '%s' [%d,%d] failed",buff,major,minor);
 if(pf) free(pf);
 return res;
}
